package tableClass;

import java.io.BufferedReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;

import Hungarian.HungarianAlgorithm;
import dataPropertyColumnMatch.ColPropNameMatcher;
import dataPropertyColumnMatch.matchingMatrix4ColNamePropName;

public class labelMatcher {


	public static void main(String[] args) {
		// TODO Auto-generated method stub


		//ArrayList<ArrayList<String>> temp  = classTableLabelMatch(readRDBSchema.dbTables("npd_clean_no_spatial"), readOntologySchema.ontologyClasses("npd"));
		//ArrayList<ArrayList<String>> temp  = classTableLabelMatch(readRDBSchema.dbTables("my_volts"), readOntologySchema.ontologyClasses("mv"));
		ArrayList<ArrayList<String>> temp  = classTableLabelMatch(readRDBSchema.dbTablesPostgres("conference_nofks"), readOntologySchema.ontologyClasses("conf"));
	}

	public static ArrayList<ArrayList<String>> classTableLabelMatch(ArrayList<String> tableName , ArrayList<ArrayList<String>> className){
		ArrayList<ArrayList<String>> matchingMatrix = new ArrayList<>();
		matchingMatrix.add(new ArrayList<String>()); //colName 0
		matchingMatrix.add(new ArrayList<String>()); //prop uri	1
		matchingMatrix.add(new ArrayList<String>()); //prop name	2
		matchingMatrix.add(new ArrayList<String>()); //label results	3\
		matchingMatrix.add(new ArrayList<String>()); //value of column and property matches
		//	matchingMatrix.add(new ArrayList<String>()); //difference b/w counts


		try {
			//create a buffered reader that connects to the console, we use it so we can read lines
			BufferedReader in = new BufferedReader(new InputStreamReader(System.in));


			//create an print writer for writing to a file
			PrintWriter out = new PrintWriter(new FileWriter("similarity.csv"));
			System.out.println(tableName.size() + " * " + className.get(0).size() );
			for(int i=0; i< tableName.size() ; i++){
				for(int j=0; j< className.get(0).size() ; j++){

					double temp = ColPropNameMatcher.getPairwiseScore(tableName.get(i).toString(),className.get(1).get(j).toString());
				//	System.out.println(temp);
					if(temp >= 0){
						matchingMatrix.get(0).add(tableName.get(i));
						matchingMatrix.get(1).add(className.get(0).get(j));
						matchingMatrix.get(2).add(className.get(1).get(j));
						matchingMatrix.get(3).add(Double.toString(temp));
				//		double[] temp2 = columnPropertyGroupedMatching(tableName.get(i),className.get(0).get(j));
				//		matchingMatrix.get(4).add(Double.toString(temp2[0]));
						//output to the file a line
					//	out.println(tableName.get(i) + "  " + className.get(1).get(j) + "  "+ temp+ "  " + temp2[0]);
						if (temp > 70)
						System.out.println(tableName.get(i) + "  " + className.get(1).get(j) + "  "+ temp);
					}
				}	
			}


			//close the file (VERY IMPORTANT!)
			out.close();
		}
		catch(IOException e1) {
			System.out.println("Error during reading/writing");
		}

		return matchingMatrix;


	}

	public static double[] columnPropertyGroupedMatching(String tableName, String className){


		double[] returnDouble = new double[2];
		ArrayList<String> colName = readRDBSchema.getColumns("npd_clean_no_spatial", tableName);

		ArrayList<String> propName = readOntologySchema.getProperties("npd", className);

		int count = 0;
		
		if(colName.size() >0 && propName.size() >0 ){
		double[][] sum = new double[colName.size()][propName.size()];
		returnDouble[1] = Math.abs(colName.size() -propName.size());

		for(int i=0; i< colName.size() ; i++){
			for(int j=0; j<propName.size() ; j++){
				sum[i][j] = ColPropNameMatcher.getPairwiseScore(colName.get(i), propName.get(j));
			}
		}

		if(sum.length > sum[0].length){
			returnDouble[0]= (HungarianAlgorithm.hgAlgorithmSum(HungarianAlgorithm.transpose(sum), "max"))/sum.length;
		}
		else
			returnDouble[0]=  (HungarianAlgorithm.hgAlgorithmSum(sum, "max"))/sum[0].length;

		}

		return returnDouble;
	}


}
