[PrefixDeclaration]
:   http://sws.ifi.uio.no/vocab/npd-v2#
dc:   http://purl.org/dc/elements/1.1/
ex:   http://example.org/ex#
isc:    http://resource.geosciml.org/classifier/ics/ischart/
nlx:    http://sws.ifi.uio.no/data/norlex/
npd:    http://sws.ifi.uio.no/data/npd-v2/
owl:    http://www.w3.org/2002/07/owl#
ptl:    http://sws.ifi.uio.no/vocab/npd-v2-ptl#
rdf:    http://www.w3.org/1999/02/22-rdf-syntax-ns#
sql:    http://sws.ifi.uio.no/vocab/sql#
xsd:    http://www.w3.org/2001/XMLSchema#
geos:   http://www.opengis.net/ont/geosparql#
nlxv:   http://sws.ifi.uio.no/vocab/norlex#
npdv:   http://sws.ifi.uio.no/vocab/npd-v2#
rdfs:   http://www.w3.org/2000/01/rdf-schema#
void:   http://rdfs.org/ns/void#
diskos:   http://sws.ifi.uio.no/data/diskos/
diskosv:    http://sws.ifi.uio.no/vocab/diskos#

[SourceDeclaration]
sourceUri http://sws.ifi.uio.no/vocab/npd-v2
connectionUrl jdbc:mysql://host_addr/db_name
username  x
password  x
driverClass com.mysql.jdbc.Driver

[MappingDeclaration] @collection [[
mappingId Mapping:00001:Literal:wellbore_coordinates:wlbNsMin
target    npd:wellbore/{wlbNpdidWellbore}/point npdv:minutesNS {wlbNsMin}^^xsd:integer . 
source    SELECT wlbNpdidWellbore,wlbNsMin FROM wellbore_coordinates

mappingId Mapping:00002:Literal:licence_transfer_hst:prlTransferDateUpdated
target    npd:licence/{prlNpdidLicence}/transfer/{prlTransferDirection}/{cmpNpdidCompany}/history/{prlTransferDateValidFrom} npdv:dateUpdated {prlTransferDateUpdated}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,prlTransferDirection,cmpNpdidCompany,prlTransferDateValidFrom,prlTransferDateUpdated FROM licence_transfer_hst WHERE prlTransferDateUpdated <> '9999-12-31'

mappingId Mapping:00003:Literal:wellbore_development_all:wlbNsDeg
target    npd:wellbore/{wlbNpdidWellbore} npdv:degreesNS {wlbNsDeg}^^xsd:integer . 
source    SELECT wlbNpdidWellbore,wlbNsDeg FROM wellbore_development_all

mappingId Mapping:00004:Literal:seaMultiline:seaSourcePressure
target    npd:survey/{seaSurveyName}/multiline npdv:sourcePressure {seaSourcePressure}^^rdfs:Literal . 
source    SELECT seaSurveyName,seaSourcePressure FROM seaMultiline

mappingId Mapping:00005:Literal:wellbore_dst:wlbDstFinFlowPress
target    npd:wellbore/{wlbNpdidWellbore}/test/drillstem/{wlbDstTestNumber} npdv:DSTFinalFlowPressure {wlbDstFinFlowPress}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbDstTestNumber,wlbDstFinFlowPress FROM wellbore_dst

mappingId Mapping:00006:Literal:wellbore_casing_and_lot:wlbCasingDepth
target    npd:wellbore/{wlbNpdidWellbore}/test/casingleakoff/{wellbore_casing_and_lot_id} npdv:casingDepth {wlbCasingDepth}^^xsd:decimal . 
source    SELECT wellbore_casing_and_lot_id,wlbNpdidWellbore,wlbCasingDepth FROM wellbore_casing_and_lot

mappingId Mapping:00007:Literal:wellbore_development_all:wlbPlotSymbol
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellborePlotSymbol {wlbPlotSymbol}^^xsd:integer . 
source    SELECT wlbNpdidWellbore,wlbPlotSymbol FROM wellbore_development_all

mappingId Mapping:00008:Literal:seis_acquisition:sea3DKm2
target    npd:survey/{seaName} npdv:areaSize3DKm2 {sea3DKm2}^^xsd:decimal . 
source    SELECT seaName,sea3DKm2 FROM seis_acquisition

mappingId Mapping:00009:Literal:pipLine:pipMedium
target    npd:pipeline/{pipNpdidPipe} npdv:pipelineMedium {pipMedium}^^xsd:string . 
source    SELECT pipNpdidPipe,pipMedium FROM pipLine

mappingId Mapping:00010:Literal:company_reserves:cmpRemainingOE
target    npd:company/{cmpNpdidCompany}/reserve/{fldNpdidField} npdv:remainingOilEquivalents {cmpRemainingOE}^^xsd:decimal . 
source    SELECT cmpNpdidCompany,fldNpdidField,cmpRemainingOE FROM company_reserves

mappingId Mapping:00012:Literal:wellbore_dst:wlbDstToDepth
target    npd:wellbore/{wlbNpdidWellbore}/test/drillstem/{wlbDstTestNumber} npdv:DSTDepthTo {wlbDstToDepth}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbDstTestNumber,wlbDstToDepth FROM wellbore_dst

mappingId Mapping:00013:Literal:bsns_arr_area_area_poly_hst:baaAreaPolyArea
target    npd:baa/{baaNpdidBsnsArrArea}/block/{baaAreaPolyBlockName}/polyno/{baaAreaPolyNo}/history/{baaAreaPolyDateValidFrom}/{baaAreaPolyDateValidTo} npdv:areaSize {baaAreaPolyArea}^^xsd:decimal . 
source    SELECT baaNpdidBsnsArrArea,baaAreaPolyBlockName,baaAreaPolyNo,baaAreaPolyDateValidFrom,baaAreaPolyDateValidTo,baaAreaPolyArea FROM bsns_arr_area_area_poly_hst

mappingId Mapping:00014:Literal:wellbore_development_all:wlbNpdidWellboreReclass
target    npd:wellbore/{wlbNpdidWellbore} npdv:reclassedFromWellbore npd:wellbore/{wlbNpdidWellboreReclass} . 
source    SELECT wlbNpdidWellbore,wlbNpdidWellboreReclass FROM wellbore_development_all

mappingId Mapping:00015:Literal:wellbore_coordinates:dateSyncNPD
target    npd:wellbore/{wlbNpdidWellbore}/point npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT wlbNpdidWellbore,dateSyncNPD FROM wellbore_coordinates WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00016:Literal:licence_petreg_licence:ptlDateAwarded
target    npd:petreg/licence/{prlNpdidLicence} ptl:dateAwarded {ptlDateAwarded}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,ptlDateAwarded FROM licence_petreg_licence WHERE ptlDateAwarded <> '9999-12-31'

mappingId Mapping:00017:Literal:wellbore_dst:wlbDstOilDensity
target    npd:wellbore/{wlbNpdidWellbore}/test/drillstem/{wlbDstTestNumber} npdv:DSTOilDensity {wlbDstOilDensity}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbDstTestNumber,wlbDstOilDensity FROM wellbore_dst

mappingId Mapping:00018:Literal:seaMultiline:seaSensorLength
target    npd:survey/{seaSurveyName}/multiline npdv:sensorLength {seaSensorLength}^^rdfs:Literal . 
source    SELECT seaSurveyName,seaSensorLength FROM seaMultiline

mappingId Mapping:00019:Literal:tuf_petreg_licence:ptlDateValidTo
target    npd:petreg/facility/{tufNpdidTuf} ptl:dateLicenceValidTo {ptlDateValidTo}^^xsd:dateTime . 
source    SELECT tufNpdidTuf,ptlDateValidTo FROM tuf_petreg_licence WHERE ptlDateValidTo <> '9999-12-31'

mappingId Mapping:00020:Literal:wellbore_document:wlbDocumentDateUpdated
target    npd:wellbore/{wlbNpdidWellbore}/document/{wellbore_document_id}/{wlbDocumentName} npdv:dateUpdated {wlbDocumentDateUpdated}^^xsd:dateTime . 
source    SELECT wellbore_document_id,wlbNpdidWellbore,wlbDocumentName,wlbDocumentDateUpdated FROM wellbore_document WHERE wlbDocumentDateUpdated <> '9999-12-31'

mappingId Mapping:00021:Literal:wellbore_shallow_all:wlbGeodeticDatum
target    npd:wellbore/{wlbNpdidWellbore} npdv:geodeticDatum {wlbGeodeticDatum}^^xsd:string . 
source    SELECT wlbNpdidWellbore,wlbGeodeticDatum FROM wellbore_shallow_all

mappingId Mapping:00022:Literal:wellbore_document:wlbDocumentName
target    npd:wellbore/{wlbNpdidWellbore}/document/{wellbore_document_id}/{wlbDocumentName} npdv:documentName {wlbDocumentName}^^xsd:string . 
source    SELECT wellbore_document_id,wlbNpdidWellbore,wlbDocumentName FROM wellbore_document

mappingId Mapping:00023:Literal:wellbore_exploration_all:wlbWaterDepth
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreWaterDepth {wlbWaterDepth}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbWaterDepth FROM wellbore_exploration_all

mappingId Mapping:00024:Literal:wellbore_development_all:wlbNamePart6
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreNamePart6 {wlbNamePart6}^^xsd:string . 
source    SELECT wlbNpdidWellbore,wlbNamePart6 FROM wellbore_development_all

mappingId Mapping:00025:Literal:wellbore_shallow_all:wlbNsUtm
target    npd:wellbore/{wlbNpdidWellbore} npdv:utmNS {wlbNsUtm}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbNsUtm FROM wellbore_shallow_all

mappingId Mapping:00026:Literal:bsns_arr_area_area_poly_hst:baaAreaPolyNo
target    npd:baa/{baaNpdidBsnsArrArea}/block/{baaAreaPolyBlockName}/polyno/{baaAreaPolyNo}/history/{baaAreaPolyDateValidFrom}/{baaAreaPolyDateValidTo} npdv:polygonNo {baaAreaPolyNo}^^xsd:integer . 
source    SELECT baaNpdidBsnsArrArea,baaAreaPolyBlockName,baaAreaPolyNo,baaAreaPolyDateValidFrom,baaAreaPolyDateValidTo FROM bsns_arr_area_area_poly_hst

mappingId Mapping:00027:Literal:company_reserves:cmpDateOffResEstDisplay
target    npd:company/{cmpNpdidCompany}/reserve/{fldNpdidField} npdv:dateResourceEstimate {cmpDateOffResEstDisplay}^^xsd:dateTime . 
source    SELECT cmpNpdidCompany,fldNpdidField,cmpDateOffResEstDisplay FROM company_reserves WHERE cmpDateOffResEstDisplay <> '9999-12-31'

mappingId Mapping:00028:Literal:wellbore_development_all:wlbTotalDepth
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreTotalDepth {wlbTotalDepth}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbTotalDepth FROM wellbore_development_all

mappingId Mapping:00029:Literal:wellbore_development_all:wlbCompletionYear
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreCompletionYear {wlbCompletionYear}^^xsd:integer . 
source    SELECT wlbNpdidWellbore,wlbCompletionYear FROM wellbore_development_all

mappingId Mapping:00030:Literal:discovery_reserves:dateSyncNPD
target    npd:discovery/{dscNpdidDiscovery}/{dscReservesRC} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT dscNpdidDiscovery,dscReservesRC,dateSyncNPD FROM discovery_reserves WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00031:Literal:bsns_arr_area_licensee_hst:baaLicenseeDateValidFrom
target    npd:baa/{baaNpdidBsnsArrArea}/licensee/{cmpNpdidCompany}/history/{baaLicenseeDateValidFrom}/{baaLicenseeDateValidTo} npdv:dateBaaLicenseeValidFrom {baaLicenseeDateValidFrom}^^xsd:dateTime . 
source    SELECT baaNpdidBsnsArrArea,cmpNpdidCompany,baaLicenseeDateValidFrom,baaLicenseeDateValidTo FROM bsns_arr_area_licensee_hst WHERE baaLicenseeDateValidFrom <> '9999-12-31'

mappingId Mapping:00032:Literal:wellbore_development_all:wlbEwUtm
target    npd:wellbore/{wlbNpdidWellbore} npdv:utmEW {wlbEwUtm}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbEwUtm FROM wellbore_development_all

mappingId Mapping:00033:Literal:discovery:dateSyncNPD
target    npd:discovery/{dscNpdidDiscovery} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT dscNpdidDiscovery,dateSyncNPD FROM discovery WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00034:Literal:wellbore_shallow_all:wlbNpdidWellbore
target    npd:wellbore/{wlbNpdidWellbore} npdv:idNPD {wlbNpdidWellbore}^^xsd:integer . 
source    SELECT wlbNpdidWellbore FROM wellbore_shallow_all

mappingId Mapping:00035:Literal:Trans:seis_acquisition:seaShallowDrilling
target    npd:survey/{seaName} npdv:isShallowDrillingPerformed "true"^^rdfs:Literal . 
source    SELECT seaName FROM seis_acquisition WHERE seaShallowDrilling='Ja'

mappingId Mapping:00036:Literal:Trans:seis_acquisition:seaShallowDrilling
target    npd:survey/{seaName} npdv:isShallowDrillingPerformed "false"^^rdfs:Literal . 
source    SELECT seaName FROM seis_acquisition WHERE seaShallowDrilling='Nei'

mappingId Mapping:00037:Literal:licence_petreg_licence:ptlDateValidFrom
target    npd:petreg/licence/{prlNpdidLicence} ptl:dateLicenceValidFrom {ptlDateValidFrom}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,ptlDateValidFrom FROM licence_petreg_licence WHERE ptlDateValidFrom <> '9999-12-31'

mappingId Mapping:00038:Literal:seaArea:seaSourceNumber
target    npd:survey/{seaSurveyName}/area npdv:sourceNumber {seaSourceNumber}^^rdfs:Literal . 
source    SELECT seaArea_id,seaSurveyName,seaSourceNumber FROM seaArea

mappingId Mapping:00039:Literal:wellbore_development_all:wlbNamePart1
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreNamePart1 {wlbNamePart1}^^xsd:integer . 
source    SELECT wlbNpdidWellbore,wlbNamePart1 FROM wellbore_development_all

mappingId Mapping:00040:Literal:wellbore_exploration_all:wlbNamePart3
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreNamePart3 {wlbNamePart3}^^xsd:string . 
source    SELECT wlbNpdidWellbore,wlbNamePart3 FROM wellbore_exploration_all

mappingId Mapping:00041:Literal:licence_phase_hst:dateSyncNPD
target    npd:licence/{prlNpdidLicence}/phase/{prlPhase}/history/{prlDatePhaseValidFrom}/{prlDatePhaseValidTo} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,prlPhase,prlDatePhaseValidFrom,prlDatePhaseValidTo,dateSyncNPD FROM licence_phase_hst WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00042:Literal:wellbore_exploration_all:wlbSeismicLocation
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreSeismicLocation {wlbSeismicLocation}^^xsd:string . 
source    SELECT wlbNpdidWellbore,wlbSeismicLocation FROM wellbore_exploration_all

mappingId Mapping:00043:Literal:field:fldNpdidField
target    npd:field/{fldNpdidField} npdv:idNPD {fldNpdidField}^^xsd:integer . 
source    SELECT fldNpdidField FROM field

mappingId Mapping:00044:Literal:company_reserves:cmpShare
target    npd:company/{cmpNpdidCompany}/reserve/{fldNpdidField} npdv:companyShare {cmpShare}^^xsd:decimal . 
source    SELECT cmpNpdidCompany,fldNpdidField,cmpShare FROM company_reserves

mappingId Mapping:00045:Literal:wellbore_development_all:wlbLicensingActivity
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreLicensingActivity {wlbLicensingActivity}^^xsd:string . 
source    SELECT wlbNpdidWellbore,wlbLicensingActivity FROM wellbore_development_all

mappingId Mapping:00046:Literal:Trans:wellbore_core:wlbCoreSampleAvailable
target    npd:wellbore/{wlbNpdidWellbore}/core/{wlbCoreNumber} npdv:isCoreSampleAvailable "true"^^rdfs:Literal . 
source    SELECT wellbore_core_id,wlbNpdidWellbore,wlbCoreNumber FROM wellbore_core WHERE wlbCoreSampleAvailable='YES'

mappingId Mapping:00047:Literal:Trans:wellbore_core:wlbCoreSampleAvailable
target    npd:wellbore/{wlbNpdidWellbore}/core/{wlbCoreNumber} npdv:isCoreSampleAvailable "false"^^rdfs:Literal . 
source    SELECT wellbore_core_id,wlbNpdidWellbore,wlbCoreNumber FROM wellbore_core WHERE wlbCoreSampleAvailable='NO'

mappingId Mapping:00048:Literal:licence_transfer_hst:prlTransferSdfi
target    npd:licence/{prlNpdidLicence}/transfer/{prlTransferDirection}/{cmpNpdidCompany}/history/{prlTransferDateValidFrom} npdv:SDFI {prlTransferSdfi}^^xsd:decimal . 
source    SELECT prlNpdidLicence,prlTransferDirection,cmpNpdidCompany,prlTransferDateValidFrom,prlTransferSdfi FROM licence_transfer_hst

mappingId Mapping:00049:Literal:bsns_arr_area:baaDateUpdated
target    npd:baa/{baaNpdidBsnsArrArea} npdv:dateUpdated {baaDateUpdated}^^xsd:dateTime . 
source    SELECT baaNpdidBsnsArrArea,baaDateUpdated FROM bsns_arr_area WHERE baaDateUpdated <> '9999-12-31'

mappingId Mapping:00050:Literal:field_reserves:fldRemainingNGL
target    npd:field/{fldNpdidField}/reserve npdv:remainingNGL {fldRemainingNGL}^^xsd:decimal . 
source    SELECT fldNpdidField,fldRemainingNGL FROM field_reserves

mappingId Mapping:00051:Literal:field_production_yearly:prfPrdCondensateNetMillSm3
target    npd:field/{prfNpdidInformationCarrier}/production/{prfYear} npdv:producedCondensate {prfPrdCondensateNetMillSm3}^^xsd:decimal . 
source    SELECT prfNpdidInformationCarrier,prfYear,prfPrdCondensateNetMillSm3 FROM field_production_yearly

mappingId Mapping:00052:Literal:wellbore_mud:wlbMudWeightAtMD
target    npd:wellbore/{wlbNpdidWellbore}/test/mud/{wellbore_mud_id} npdv:mudWeight {wlbMudWeightAtMD}^^xsd:decimal . 
source    SELECT wellbore_mud_id,wlbNpdidWellbore,wlbMudWeightAtMD FROM wellbore_mud

mappingId Mapping:00053:Literal:pipLine:pipName
target    npd:pipeline/{pipNpdidPipe} npdv:name {pipName} . 
source    SELECT pipNpdidPipe,pipName FROM pipLine

mappingId Mapping:00054:Literal:wellbore_casing_and_lot:dateSyncNPD
target    npd:wellbore/{wlbNpdidWellbore}/test/casingleakoff/{wellbore_casing_and_lot_id} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT wellbore_casing_and_lot_id,wlbNpdidWellbore,dateSyncNPD FROM wellbore_casing_and_lot WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00055:Literal:wellbore_formation_top:dateSyncNPD
target    npd:wellbore/{wlbNpdidWellbore}/stratum/{lsuNpdidLithoStrat}/depth/{lsuTopDepth}/{lsuBottomDepth} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT wlbNpdidWellbore,lsuNpdidLithoStrat,lsuTopDepth,lsuBottomDepth,dateSyncNPD FROM wellbore_formation_top WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00057:Literal:discovery_reserves:dscRecoverableNGL
target    npd:discovery/{dscNpdidDiscovery}/{dscReservesRC} npdv:recoverableNGL {dscRecoverableNGL}^^xsd:decimal . 
source    SELECT dscNpdidDiscovery,dscReservesRC,dscRecoverableNGL FROM discovery_reserves

mappingId Mapping:00058:Literal:Trans:wellbore_development_all:wlbMainArea
target    npd:wellbore/{wlbNpdidWellbore} npdv:mainAreaLocation npd:ncs/mainarea/1 . 
source    SELECT wlbNpdidWellbore FROM wellbore_development_all WHERE wlbMainArea='Barents sea'

mappingId Mapping:00059:Literal:Trans:wellbore_development_all:wlbMainArea
target    npd:wellbore/{wlbNpdidWellbore} npdv:mainAreaLocation npd:ncs/mainarea/2 . 
source    SELECT wlbNpdidWellbore FROM wellbore_development_all WHERE wlbMainArea='Norwegian sea'

mappingId Mapping:00060:Literal:Trans:wellbore_development_all:wlbMainArea
target    npd:wellbore/{wlbNpdidWellbore} npdv:mainAreaLocation npd:ncs/mainarea/3 . 
source    SELECT wlbNpdidWellbore FROM wellbore_development_all WHERE wlbMainArea='North sea'

mappingId Mapping:00061:Literal:wellbore_casing_and_lot:wlbLotMudDencity
target    npd:wellbore/{wlbNpdidWellbore}/test/casingleakoff/{wellbore_casing_and_lot_id} npdv:LOTMudDensity {wlbLotMudDencity}^^xsd:decimal . 
source    SELECT wellbore_casing_and_lot_id,wlbNpdidWellbore,wlbLotMudDencity FROM wellbore_casing_and_lot

mappingId Mapping:00062:Literal:facility_fixed:fclEwCode
target    npd:facility/{fclNpdidFacility} npdv:codeEW {fclEwCode}^^xsd:string . 
source    SELECT fclNpdidFacility,fclEwCode FROM facility_fixed

mappingId Mapping:00063:Literal:wellbore_mud:wlbMudType
target    npd:wellbore/{wlbNpdidWellbore}/test/mud/{wellbore_mud_id} npdv:mudType {wlbMudType}^^xsd:string . 
source    SELECT wellbore_mud_id,wlbNpdidWellbore,wlbMudType FROM wellbore_mud

mappingId Mapping:00064:Literal:strat_litho_wellbore_core:dateSyncNPD
target    npd:wellbore/{wlbNpdidWellbore}/stratum/{lsuNpdidLithoStrat}/cores npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT wlbNpdidWellbore,lsuNpdidLithoStrat,dateSyncNPD FROM strat_litho_wellbore_core WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00065:Literal:facility_fixed:fclEwMin
target    npd:facility/{fclNpdidFacility} npdv:minutesEW {fclEwMin}^^xsd:integer . 
source    SELECT fclNpdidFacility,fclEwMin FROM facility_fixed

mappingId Mapping:00066:Literal:wellbore_coordinates:wlbGeodeticDatum
target    npd:wellbore/{wlbNpdidWellbore}/point npdv:geodeticDatum {wlbGeodeticDatum}^^xsd:string . 
source    SELECT wlbNpdidWellbore,wlbGeodeticDatum FROM wellbore_coordinates

mappingId Mapping:00067:Literal:wellbore_document:wlbDocumentType
target    npd:wellbore/{wlbNpdidWellbore}/document/{wellbore_document_id}/{wlbDocumentName} npdv:documentType {wlbDocumentType}^^xsd:string . 
source    SELECT wellbore_document_id,wlbNpdidWellbore,wlbDocumentName,wlbDocumentType FROM wellbore_document

mappingId Mapping:00068:Literal:Trans:seaArea:seaMarketAvailable
target    npd:survey/{seaSurveyName}/area npdv:isMarketAvailable "true"^^rdfs:Literal . 
source    SELECT seaArea_id,seaSurveyName FROM seaArea WHERE seaMarketAvailable='Ja'

mappingId Mapping:00069:Literal:Trans:seaArea:seaMarketAvailable
target    npd:survey/{seaSurveyName}/area npdv:isMarketAvailable "false"^^rdfs:Literal . 
source    SELECT seaArea_id,seaSurveyName FROM seaArea WHERE seaMarketAvailable='Nei'

mappingId Mapping:00070:Literal:seis_acquisition_coordinates_inc_turnarea:seaPolygonPointNumber
target    npd:survey/{seaSurveyName}/point/{seaPolygonPointNumber} npdv:polygonPointNo {seaPolygonPointNumber}^^xsd:integer . 
source    SELECT seaSurveyName,seaPolygonPointNumber FROM seis_acquisition_coordinates_inc_turnarea

mappingId Mapping:00071:Literal:wellbore_dst:wlbDstTestNumber
target    npd:wellbore/{wlbNpdidWellbore}/test/drillstem/{wlbDstTestNumber} npdv:DSTTestNo {wlbDstTestNumber}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbDstTestNumber FROM wellbore_dst

mappingId Mapping:00072:Literal:Trans:wellbore_coordinates:wlbMainArea
target    npd:wellbore/{wlbNpdidWellbore}/point npdv:mainAreaLocation npd:ncs/mainarea/1 . 
source    SELECT wlbNpdidWellbore FROM wellbore_coordinates WHERE wlbMainArea='Barents sea'

mappingId Mapping:00073:Literal:Trans:wellbore_coordinates:wlbMainArea
target    npd:wellbore/{wlbNpdidWellbore}/point npdv:mainAreaLocation npd:ncs/mainarea/2 . 
source    SELECT wlbNpdidWellbore FROM wellbore_coordinates WHERE wlbMainArea='Norwegian sea'

mappingId Mapping:00074:Literal:Trans:wellbore_coordinates:wlbMainArea
target    npd:wellbore/{wlbNpdidWellbore}/point npdv:mainAreaLocation npd:ncs/mainarea/3 . 
source    SELECT wlbNpdidWellbore FROM wellbore_coordinates WHERE wlbMainArea='North sea'

mappingId Mapping:00075:Literal:prlArea:prlFactUrl
target    npd:licence/{prlNpdidLicence}/area/{prlArea_id}/history/{prlAreaPolyDateValidFrom}/{prlAreaPolyDateValidTo} npdv:factPageURL {prlFactUrl} . 
source    SELECT prlArea_id,prlNpdidLicence,prlAreaPolyDateValidFrom,prlAreaPolyDateValidTo,prlFactUrl FROM prlArea

mappingId Mapping:00076:Literal:wellbore_core:dateSyncNPD
target    npd:wellbore/{wlbNpdidWellbore}/core/{wlbCoreNumber} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT wellbore_core_id,wlbNpdidWellbore,wlbCoreNumber,dateSyncNPD FROM wellbore_core WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00077:Literal:company_reserves:cmpRemainingCondensate
target    npd:company/{cmpNpdidCompany}/reserve/{fldNpdidField} npdv:remainingCondensate {cmpRemainingCondensate}^^xsd:decimal . 
source    SELECT cmpNpdidCompany,fldNpdidField,cmpRemainingCondensate FROM company_reserves

mappingId Mapping:00078:Literal:discovery_reserves:dscReservesDateUpdated
target    npd:discovery/{dscNpdidDiscovery}/{dscReservesRC} npdv:dateUpdated {dscReservesDateUpdated}^^xsd:dateTime . 
source    SELECT dscNpdidDiscovery,dscReservesRC,dscReservesDateUpdated FROM discovery_reserves WHERE dscReservesDateUpdated <> '9999-12-31'

mappingId Mapping:00079:Literal:wellbore_exploration_all:wlbCompletionDate
target    npd:wellbore/{wlbNpdidWellbore} npdv:dateWellboreCompletion {wlbCompletionDate}^^xsd:dateTime . 
source    SELECT wlbNpdidWellbore,wlbCompletionDate FROM wellbore_exploration_all WHERE wlbCompletionDate <> '9999-12-31'

mappingId Mapping:00080:Literal:wellbore_development_all:wlbFactMapUrl
target    npd:wellbore/{wlbNpdidWellbore} npdv:factMapURL {wlbFactMapUrl} . 
source    SELECT wlbNpdidWellbore,wlbFactMapUrl FROM wellbore_development_all

mappingId Mapping:00081:Literal:wellbore_shallow_all:wlbNamePart2
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreNamePart2 {wlbNamePart2}^^xsd:integer . 
source    SELECT wlbNpdidWellbore,wlbNamePart2 FROM wellbore_shallow_all

mappingId Mapping:00082:Literal:wellbore_shallow_all:wlbNsDecDeg
target    npd:wellbore/{wlbNpdidWellbore} npdv:decimalDegreesNS {wlbNsDecDeg}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbNsDecDeg FROM wellbore_shallow_all

mappingId Mapping:00083:Literal:wellbore_development_all:wlbDiskosWellboreType
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreType {wlbDiskosWellboreType} . 
source    SELECT wlbNpdidWellbore,wlbDiskosWellboreType FROM wellbore_development_all

mappingId Mapping:00084:Literal:wellbore_shallow_all:wlbCompletionYear
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreCompletionYear {wlbCompletionYear}^^xsd:integer . 
source    SELECT wlbNpdidWellbore,wlbCompletionYear FROM wellbore_shallow_all

mappingId Mapping:00085:Literal:wellbore_core_photo:wlbCoreNumber
target    npd:wellbore/{wlbNpdidWellbore}/core/{wlbCoreNumber}/photo/{wellbore_core_photo_id}/{wlbCorePhotoTitle} npdv:coreNo {wlbCoreNumber}^^xsd:integer . 
source    SELECT wellbore_core_photo_id,wlbNpdidWellbore,wlbCoreNumber,wlbCorePhotoTitle FROM wellbore_core_photo

mappingId Mapping:00086:Literal:bsns_arr_area:baaDateValidFrom
target    npd:baa/{baaNpdidBsnsArrArea} npdv:dateBaaValidFrom {baaDateValidFrom}^^xsd:dateTime . 
source    SELECT baaNpdidBsnsArrArea,baaDateValidFrom FROM bsns_arr_area WHERE baaDateValidFrom <> '9999-12-31'

mappingId Mapping:00087:Literal:field_operator_hst:fldOperatorTo
source    SELECT fldNpdidField,cmpNpdidCompany,fldOperatorFrom,fldOperatorTo FROM field_operator_hst WHERE fldOperatorTo <> '9999-12-31'

mappingId Mapping:00088:Literal:wellbore_exploration_all:wlbNpdidWellboreReclass
target    npd:wellbore/{wlbNpdidWellbore} npdv:reclassedFromWellbore npd:wellbore/{wlbNpdidWellboreReclass} . 
source    SELECT wlbNpdidWellbore,wlbNpdidWellboreReclass FROM wellbore_exploration_all

mappingId Mapping:00089:Literal:seis_acquisition:seaSurveyTypeMain
target    npd:survey/{seaName} npdv:surveyType {seaSurveyTypeMain}^^xsd:string . 
source    SELECT seaName,seaSurveyTypeMain FROM seis_acquisition

mappingId Mapping:00090:Literal:wellbore_development_all:wlbWdssQcdate
target    npd:wellbore/{wlbNpdidWellbore} npdv:dateWDSSQC {wlbWdssQcdate}^^xsd:dateTime . 
source    SELECT wlbNpdidWellbore,wlbWdssQcdate FROM wellbore_development_all WHERE wlbWdssQcdate <> '9999-12-31'

mappingId Mapping:00091:Literal:field_production_totalt_NCS_year:prfPrdGasNetBillSm
target    npd:ncs/production/{prfYear} npdv:producedGas {prfPrdGasNetBillSm}^^xsd:decimal . 
source    SELECT prfYear,prfPrdGasNetBillSm FROM field_production_totalt_NCS_year

mappingId Mapping:00092:Literal:wellbore_exploration_all:wlbEwMin
target    npd:wellbore/{wlbNpdidWellbore} npdv:minutesEW {wlbEwMin}^^xsd:integer . 
source    SELECT wlbNpdidWellbore,wlbEwMin FROM wellbore_exploration_all

mappingId Mapping:00093:Literal:tuf_petreg_licence_licencee:ptlLicenseeInterest
target    npd:petreg/facility/{tufNpdidTuf}/licencee/{cmpNpdidCompany} ptl:licenseeInterest {ptlLicenseeInterest}^^xsd:decimal . 
source    SELECT tufNpdidTuf,cmpNpdidCompany,ptlLicenseeInterest FROM tuf_petreg_licence_licencee

mappingId Mapping:00094:Literal:seis_acquisition:seaPlanFromDate
target    npd:survey/{seaName} npdv:dateSurveyPlannedStart {seaPlanFromDate}^^xsd:dateTime . 
source    SELECT seaName,seaPlanFromDate FROM seis_acquisition WHERE seaPlanFromDate <> '9999-12-31'

mappingId Mapping:00095:Literal:wellbore_exploration_all:wlbEwCode
target    npd:wellbore/{wlbNpdidWellbore} npdv:codeEW {wlbEwCode} . 
source    SELECT wlbNpdidWellbore,wlbEwCode FROM wellbore_exploration_all

mappingId Mapping:00096:Literal:facility_fixed:fclKind
target    npd:facility/{fclNpdidFacility} npdv:facilityType {fclKind}^^xsd:string . 
source    SELECT fclNpdidFacility,fclKind FROM facility_fixed

mappingId Mapping:00097:Literal:wellbore_development_all:wlbNamePart3
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreNamePart3 {wlbNamePart3}^^xsd:string . 
source    SELECT wlbNpdidWellbore,wlbNamePart3 FROM wellbore_development_all

mappingId Mapping:00098:Literal:wellbore_development_all:wlbDateUpdatedMax
target    npd:wellbore/{wlbNpdidWellbore} npdv:dateUpdatedMax {wlbDateUpdatedMax}^^xsd:dateTime . 
source    SELECT wlbNpdidWellbore,wlbDateUpdatedMax FROM wellbore_development_all WHERE wlbDateUpdatedMax <> '9999-12-31'

mappingId Mapping:00099:Literal:wellbore_npdid_overview:wlbNpdidWellbore
target    npd:wellbore/{wlbNpdidWellbore} npdv:idNPD {wlbNpdidWellbore}^^xsd:integer . 
source    SELECT wlbNpdidWellbore FROM wellbore_npdid_overview

mappingId Mapping:00100:Literal:licence_licensee_hst:prlLicenseeDateValidFrom
target    npd:licence/{prlNpdidLicence}/licensee/{cmpNpdidCompany}/history/{prlLicenseeDateValidFrom}/{prlLicenseeDateValidTo} npdv:dateLicenseeValidFrom {prlLicenseeDateValidFrom}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,cmpNpdidCompany,prlLicenseeDateValidFrom,prlLicenseeDateValidTo FROM licence_licensee_hst WHERE prlLicenseeDateValidFrom <> '9999-12-31'

mappingId Mapping:00101:Literal:wellbore_shallow_all:wlbEwDeg
target    npd:wellbore/{wlbNpdidWellbore} npdv:degreesEW {wlbEwDeg}^^xsd:integer . 
source    SELECT wlbNpdidWellbore,wlbEwDeg FROM wellbore_shallow_all

mappingId Mapping:00102:Literal:wellbore_exploration_all:wlbDateUpdated
target    npd:wellbore/{wlbNpdidWellbore} npdv:dateUpdated {wlbDateUpdated}^^xsd:dateTime . 
source    SELECT wlbNpdidWellbore,wlbDateUpdated FROM wellbore_exploration_all WHERE wlbDateUpdated <> '9999-12-31'

mappingId Mapping:00103:Literal:discovery:dscFactMapUrl
target    npd:discovery/{dscNpdidDiscovery} npdv:factMapURL {dscFactMapUrl} . 
source    SELECT dscNpdidDiscovery,dscFactMapUrl FROM discovery

mappingId Mapping:00104:Literal:wellbore_dst:wlbDstDateUpdated
target    npd:wellbore/{wlbNpdidWellbore}/test/drillstem/{wlbDstTestNumber} npdv:dateUpdated {wlbDstDateUpdated}^^xsd:dateTime . 
source    SELECT wlbNpdidWellbore,wlbDstTestNumber,wlbDstDateUpdated FROM wellbore_dst WHERE wlbDstDateUpdated <> '9999-12-31'

mappingId Mapping:00105:Literal:licence:prlFactMapUrl
target    npd:licence/{prlNpdidLicence} npdv:factMapURL {prlFactMapUrl} . 
source    SELECT prlNpdidLicence,prlFactMapUrl FROM licence

mappingId Mapping:00106:Literal:wellbore_dst:dateSyncNPD
target    npd:wellbore/{wlbNpdidWellbore}/test/drillstem/{wlbDstTestNumber} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT wlbNpdidWellbore,wlbDstTestNumber,dateSyncNPD FROM wellbore_dst WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00107:Literal:wellbore_development_all:fclNpdidFacilityProducing
target    npd:wellbore/{wlbNpdidWellbore} npdv:productionFacility npd:facility/{fclNpdidFacilityProducing} . 
source    SELECT wlbNpdidWellbore,fclNpdidFacilityProducing FROM wellbore_development_all

mappingId Mapping:00108:Literal:field_production_totalt_NCS_month:prfMonth
target    npd:ncs/production/{prfYear}/{prfMonth} npdv:productionMonth {prfMonth}^^xsd:integer . 
source    SELECT prfYear,prfMonth FROM field_production_totalt_NCS_month

mappingId Mapping:00109:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc2
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel2 isc:Campanian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc2='CAMPANIAN'

mappingId Mapping:00110:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc2
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel2 isc:Carboniferous . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc2='CARBONIFEROUS'

mappingId Mapping:00111:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc2
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel2 isc:Cretaceous . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc2='CRETACEOUS'

mappingId Mapping:00112:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc2
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel2 isc:Danian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc2='DANIAN'

mappingId Mapping:00113:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc2
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel2 isc:Devonian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc2='DEVONIAN'

mappingId Mapping:00114:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc2
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel2 isc:Mississippian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc2='EARLY CARBONIFEROUS'

mappingId Mapping:00115:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc2
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel2 isc:LowerCretaceous . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc2='EARLY CRETACEOUS'

mappingId Mapping:00116:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc2
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel2 isc:LowerJurassic . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc2='EARLY JURASSIC'

mappingId Mapping:00117:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc2
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel2 isc:Cisuralian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc2='EARLY PERMIAN'

mappingId Mapping:00118:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc2
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel2 isc:LowerTriassic . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc2='EARLY TRIASSIC'

mappingId Mapping:00119:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc2
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel2 isc:Eocene . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc2='EOCENE'

mappingId Mapping:00120:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc2
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel2 isc:Jurassic . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc2='JURASSIC'

mappingId Mapping:00121:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc2
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel2 isc:Pennsylvanian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc2='LATE CARBONIFEROUS'

mappingId Mapping:00122:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc2
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel2 isc:UpperCretaceous . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc2='LATE CRETACEOUS'

mappingId Mapping:00123:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc2
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel2 isc:UpperJurassic . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc2='LATE JURASSIC'

mappingId Mapping:00124:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc2
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel2 isc:Thanetian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc2='LATE PALEOCENE'

mappingId Mapping:00125:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc2
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel2 isc:Lopingian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc2='LATE PERMIAN'

mappingId Mapping:00126:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc2
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel2 isc:Piacenzian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc2='LATE PLIOCENE'

mappingId Mapping:00127:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc2
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel2 isc:UpperTriassic . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc2='LATE TRIASSIC'

mappingId Mapping:00128:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc2
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel2 isc:MiddleJurassic . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc2='MIDDLE JURASSIC'

mappingId Mapping:00129:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc2
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel2 isc:MiddleTriassic . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc2='MIDDLE TRIASSIC'

mappingId Mapping:00130:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc2
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel2 isc:Miocene . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc2='MIOCENE'

mappingId Mapping:00131:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc2
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel2 isc:Oligocene . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc2='OLIGOCENE'

mappingId Mapping:00132:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc2
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel2 isc:Paleocene . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc2='PALEOCENE'

mappingId Mapping:00133:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc2
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel2 isc:Permian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc2='PERMIAN'

mappingId Mapping:00134:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc2
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel2 isc:Pleistocene . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc2='PLEISTOCENE'

mappingId Mapping:00135:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc2
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel2 isc:Pliocene . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc2='PLIOCENE'

mappingId Mapping:00136:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc2
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel2 isc:Silurian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc2='SILURIAN'

mappingId Mapping:00137:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc2
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel2 isc:Triassic . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc2='TRIASSIC'

mappingId Mapping:00138:Literal:discovery_reserves:dscNpdidDiscovery
target    npd:discovery/{dscNpdidDiscovery}/{dscReservesRC} npdv:idNPD {dscNpdidDiscovery}^^xsd:integer . 
source    SELECT dscNpdidDiscovery,dscReservesRC FROM discovery_reserves

mappingId Mapping:00139:Literal:discovery:dscDiscoveryYear
target    npd:discovery/{dscNpdidDiscovery} npdv:discoveryYear {dscDiscoveryYear}^^xsd:integer . 
source    SELECT dscNpdidDiscovery,dscDiscoveryYear FROM discovery

mappingId Mapping:00140:Literal:wellbore_shallow_all:wlbEntryDate
target    npd:wellbore/{wlbNpdidWellbore} npdv:dateWellboreEntry {wlbEntryDate}^^xsd:dateTime . 
source    SELECT wlbNpdidWellbore,wlbEntryDate FROM wellbore_shallow_all WHERE wlbEntryDate <> '9999-12-31'

mappingId Mapping:00141:Literal:wellbore_development_all:wlbNsMin
target    npd:wellbore/{wlbNpdidWellbore} npdv:minutesNS {wlbNsMin}^^xsd:integer . 
source    SELECT wlbNpdidWellbore,wlbNsMin FROM wellbore_development_all

mappingId Mapping:00142:Literal:apaAreaNet:blkLabel
target    npd:quadrant/{qdrName}/block/{blkName}/award/{prvName}/area/{apaAreaNet_id} npdv:blockLocation npd:block/{blkLabel} . 
source    SELECT apaAreaNet_id,qdrName,blkName,prvName,blkId,blkLabel FROM apaAreaNet

mappingId Mapping:00143:Literal:field_owner_hst:dateSyncNPD
target    npd:field/{fldNpdidField}/owner/{fldNpdidOwner}/history/{fldOwnershipFromDate}/{fldOwnershipToDate} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT fldNpdidField,fldNpdidOwner,fldOwnershipFromDate,fldOwnershipToDate,dateSyncNPD FROM field_owner_hst WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00144:Literal:seis_acquisition_coordinates_inc_turnarea:seaPolygonEWSec
target    npd:survey/{seaSurveyName}/point/{seaPolygonPointNumber} npdv:secondsEW {seaPolygonEWSec}^^xsd:decimal . 
source    SELECT seaSurveyName,seaPolygonPointNumber,seaPolygonEWSec FROM seis_acquisition_coordinates_inc_turnarea

mappingId Mapping:00145:Literal:wellbore_exploration_all:wlbBottomHoleTemperature
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreBottomHoleTemperature {wlbBottomHoleTemperature}^^xsd:integer . 
source    SELECT wlbNpdidWellbore,wlbBottomHoleTemperature FROM wellbore_exploration_all

mappingId Mapping:00146:Literal:tuf_petreg_licence:tufNpdidTuf
target    npd:petreg/facility/{tufNpdidTuf} npdv:idNPD {tufNpdidTuf}^^xsd:integer . 
source    SELECT tufNpdidTuf FROM tuf_petreg_licence

mappingId Mapping:00147:Literal:company:dateSyncNPD
target    npd:company/{cmpNpdidCompany} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT cmpNpdidCompany,dateSyncNPD FROM company WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00148:Literal:field_production_yearly:prfPrdProducedWaterInFieldMillSm3
target    npd:field/{prfNpdidInformationCarrier}/production/{prfYear} npdv:producedWater {prfPrdProducedWaterInFieldMillSm3}^^xsd:decimal . 
source    SELECT prfNpdidInformationCarrier,prfYear,prfPrdProducedWaterInFieldMillSm3 FROM field_production_yearly

mappingId Mapping:00149:Literal:wellbore_exploration_all:wlbWdssQcDate
target    npd:wellbore/{wlbNpdidWellbore} npdv:dateWDSSQC {wlbWdssQcDate}^^xsd:dateTime . 
source    SELECT wlbNpdidWellbore,wlbWdssQcDate FROM wellbore_exploration_all WHERE wlbWdssQcDate <> '9999-12-31'

mappingId Mapping:00150:Literal:facility_moveable:dateSyncNPD
target    npd:facility/{fclNpdidFacility} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT fclNpdidFacility,dateSyncNPD FROM facility_moveable WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00151:Literal:company:cmpShortName
target    npd:company/{cmpNpdidCompany} npdv:shortName {cmpShortName}^^xsd:string . 
source    SELECT cmpNpdidCompany,cmpShortName FROM company

mappingId Mapping:00152:Literal:facility_moveable:fclFunctions
target    npd:facility/{fclNpdidFacility} npdv:facilityFunction {fclFunctions} . 
source    SELECT fclNpdidFacility,fclFunctions FROM facility_moveable

mappingId Mapping:00153:Literal:licence_oper_hst:prlOperDateUpdated
target    npd:licence/{prlNpdidLicence}/operator/{cmpNpdidCompany}/history/{prlOperDateValidFrom}/{prlOperDateValidTo} npdv:dateUpdated {prlOperDateUpdated}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,cmpNpdidCompany,prlOperDateValidFrom,prlOperDateValidTo,prlOperDateUpdated FROM licence_oper_hst WHERE prlOperDateUpdated <> '9999-12-31'

mappingId Mapping:00154:Literal:wellbore_shallow_all:wlbEntryYear
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreEntryYear {wlbEntryYear}^^xsd:integer . 
source    SELECT wlbNpdidWellbore,wlbEntryYear FROM wellbore_shallow_all

mappingId Mapping:00155:Literal:wellbore_npdid_overview:wlbWellboreName
target    npd:wellbore/{wlbNpdidWellbore} npdv:name {wlbWellboreName} . 
source    SELECT wlbNpdidWellbore,wlbWellboreName FROM wellbore_npdid_overview

mappingId Mapping:00156:Literal:wellbore_shallow_all:wlbDrillPermit
target    npd:wellbore/{wlbNpdidWellbore} npdv:drillPermit {wlbDrillPermit}^^xsd:string . 
source    SELECT wlbNpdidWellbore,wlbDrillPermit FROM wellbore_shallow_all

mappingId Mapping:00157:Literal:Trans:licence:prlMainArea
target    npd:licence/{prlNpdidLicence} npdv:mainAreaLocation npd:ncs/mainarea/1 . 
source    SELECT prlNpdidLicence FROM licence WHERE prlMainArea='Barents sea'

mappingId Mapping:00158:Literal:Trans:licence:prlMainArea
target    npd:licence/{prlNpdidLicence} npdv:mainAreaLocation npd:ncs/mainarea/2 . 
source    SELECT prlNpdidLicence FROM licence WHERE prlMainArea='Norwegian sea'

mappingId Mapping:00159:Literal:Trans:licence:prlMainArea
target    npd:licence/{prlNpdidLicence} npdv:mainAreaLocation npd:ncs/mainarea/3 . 
source    SELECT prlNpdidLicence FROM licence WHERE prlMainArea='North sea'

mappingId Mapping:00160:Literal:licence_task:prlTaskTypeNo
target    npd:licence/{prlNpdidLicence}/task/{prlTaskID} npdv:taskType {prlTaskTypeNo} . 
source    SELECT prlNpdidLicence,prlTaskID,prlTaskTypeNo FROM licence_task

mappingId Mapping:00161:Literal:seis_acquisition:seaSurveyTypePart
target    npd:survey/{seaName} npdv:surveySubType {seaSurveyTypePart}^^xsd:string . 
source    SELECT seaName,seaSurveyTypePart FROM seis_acquisition

mappingId Mapping:00162:Literal:wellbore_exploration_all:wlbNamePart5
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreNamePart5 {wlbNamePart5}^^xsd:string . 
source    SELECT wlbNpdidWellbore,wlbNamePart5 FROM wellbore_exploration_all

mappingId Mapping:00163:Literal:facility_fixed:fclGeodeticDatum
target    npd:facility/{fclNpdidFacility} npdv:geodeticDatum {fclGeodeticDatum} . 
source    SELECT fclNpdidFacility,fclGeodeticDatum FROM facility_fixed

mappingId Mapping:00164:Literal:field_owner_hst:fldOwnershipFromDate
target    npd:field/{fldNpdidField}/owner/{fldNpdidOwner}/history/{fldOwnershipFromDate}/{fldOwnershipToDate} npdv:dateFieldOwnerFrom {fldOwnershipFromDate}^^xsd:dateTime . 
source    SELECT fldNpdidField,fldNpdidOwner,fldOwnershipFromDate,fldOwnershipToDate FROM field_owner_hst WHERE fldOwnershipFromDate <> '9999-12-31'

mappingId Mapping:00165:Literal:discovery_reserves:dscReservesRC
target    npd:discovery/{dscNpdidDiscovery}/{dscReservesRC} npdv:reservesResourceClass {dscReservesRC}^^xsd:string . 
source    SELECT dscNpdidDiscovery,dscReservesRC FROM discovery_reserves

mappingId Mapping:00166:Literal:field_production_totalt_NCS_year:prfPrdOilNetMillSm
target    npd:ncs/production/{prfYear} npdv:producedOil {prfPrdOilNetMillSm}^^xsd:decimal . 
source    SELECT prfYear,prfPrdOilNetMillSm FROM field_production_totalt_NCS_year

mappingId Mapping:00167:Literal:discovery:dscDateUpdatedMax
target    npd:discovery/{dscNpdidDiscovery} npdv:dateUpdatedMax {dscDateUpdatedMax}^^xsd:dateTime . 
source    SELECT dscNpdidDiscovery,dscDateUpdatedMax FROM discovery WHERE dscDateUpdatedMax <> '9999-12-31'

mappingId Mapping:00168:Literal:wellbore_shallow_all:wlbNsCode
target    npd:wellbore/{wlbNpdidWellbore} npdv:codeNS {wlbNsCode} . 
source    SELECT wlbNpdidWellbore,wlbNsCode FROM wellbore_shallow_all

mappingId Mapping:00169:Literal:wellbore_oil_sample:wlbOilSampleDateUpdated
target    npd:wellbore/{wlbNpdidWellbore}/test/oilsample/{wellbore_oil_sample_id} npdv:dateUpdated {wlbOilSampleDateUpdated}^^xsd:dateTime . 
source    SELECT wellbore_oil_sample_id,wlbNpdidWellbore,wlbOilSampleDateUpdated FROM wellbore_oil_sample WHERE wlbOilSampleDateUpdated <> '9999-12-31'

mappingId Mapping:00170:Literal:tuf_owner_hst:tufOwnerDateValidTo
target    npd:facility/{tufNpdidTuf}/owner/{cmpNpdidCompany}/history/{tufOwnerDateValidFrom}/{tufOwnerDateValidTo} npdv:dateTUFOwnerValidTo {tufOwnerDateValidTo}^^xsd:dateTime . 
source    SELECT tufNpdidTuf,cmpNpdidCompany,tufOwnerDateValidFrom,tufOwnerDateValidTo FROM tuf_owner_hst WHERE tufOwnerDateValidTo <> '9999-12-31'

mappingId Mapping:00171:Literal:Trans:wellbore_development_all:wlbMultilateral
target    npd:wellbore/{wlbNpdidWellbore} npdv:isMultilateral "true"^^rdfs:Literal . 
source    SELECT wlbNpdidWellbore FROM wellbore_development_all WHERE wlbMultilateral='YES'

mappingId Mapping:00172:Literal:Trans:wellbore_development_all:wlbMultilateral
target    npd:wellbore/{wlbNpdidWellbore} npdv:isMultilateral "false"^^rdfs:Literal . 
source    SELECT wlbNpdidWellbore FROM wellbore_development_all WHERE wlbMultilateral='NO'

mappingId Mapping:00173:Literal:wellbore_shallow_all:wlbWellboreName
target    npd:wellbore/{wlbNpdidWellbore} npdv:name {wlbWellboreName} . 
source    SELECT wlbNpdidWellbore,wlbWellboreName FROM wellbore_shallow_all

mappingId Mapping:00174:Literal:field_production_yearly:prfPrdOilNetMillSm3
target    npd:field/{prfNpdidInformationCarrier}/production/{prfYear} npdv:producedOil {prfPrdOilNetMillSm3}^^xsd:decimal . 
source    SELECT prfNpdidInformationCarrier,prfYear,prfPrdOilNetMillSm3 FROM field_production_yearly

mappingId Mapping:00175:Literal:wellbore_shallow_all:wlbNamePart4
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreNamePart4 {wlbNamePart4}^^xsd:integer . 
source    SELECT wlbNpdidWellbore,wlbNamePart4 FROM wellbore_shallow_all

mappingId Mapping:00176:Literal:facility_fixed:fclName
target    npd:facility/{fclNpdidFacility} npdv:name {fclName} . 
source    SELECT fclNpdidFacility,fclName FROM facility_fixed

mappingId Mapping:00177:Literal:wellbore_casing_and_lot:wlbHoleDiameter
target    npd:wellbore/{wlbNpdidWellbore}/test/casingleakoff/{wellbore_casing_and_lot_id} npdv:wellboreHoleDiameter {wlbHoleDiameter}^^rdfs:Literal . 
source    SELECT wellbore_casing_and_lot_id,wlbNpdidWellbore,wlbHoleDiameter FROM wellbore_casing_and_lot

mappingId Mapping:00178:Literal:wellbore_shallow_all:wlbDateUpdatedMax
target    npd:wellbore/{wlbNpdidWellbore} npdv:dateUpdatedMax {wlbDateUpdatedMax}^^xsd:dateTime . 
source    SELECT wlbNpdidWellbore,wlbDateUpdatedMax FROM wellbore_shallow_all WHERE wlbDateUpdatedMax <> '9999-12-31'

mappingId Mapping:00179:Literal:seis_acquisition:seaBoatTotalKm
target    npd:survey/{seaName} npdv:lengthBoatTotalKm {seaBoatTotalKm}^^xsd:integer . 
source    SELECT seaName,seaBoatTotalKm FROM seis_acquisition

mappingId Mapping:00180:Literal:licence_petreg_licence_licencee:dateSyncNPD
target    npd:petreg/licence/{prlNpdidLicence}/licencee/{cmpNpdidCompany} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,cmpNpdidCompany,dateSyncNPD FROM licence_petreg_licence_licencee WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00181:Literal:bsns_arr_area:baaName
target    npd:baa/{baaNpdidBsnsArrArea} npdv:name {baaName} . 
source    SELECT baaNpdidBsnsArrArea,baaName FROM bsns_arr_area

mappingId Mapping:00182:Literal:wellbore_development_all:wlbNsSec
target    npd:wellbore/{wlbNpdidWellbore} npdv:secondsNS {wlbNsSec}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbNsSec FROM wellbore_development_all

mappingId Mapping:00183:Literal:wellbore_development_all:wlbNsDecDeg
target    npd:wellbore/{wlbNpdidWellbore} npdv:decimalDegreesNS {wlbNsDecDeg}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbNsDecDeg FROM wellbore_development_all

mappingId Mapping:00184:Literal:wellbore_oil_sample:wlbOilSampleTestDate
target    npd:wellbore/{wlbNpdidWellbore}/test/oilsample/{wellbore_oil_sample_id} npdv:dateOilSampleTest {wlbOilSampleTestDate}^^xsd:dateTime . 
source    SELECT wellbore_oil_sample_id,wlbNpdidWellbore,wlbOilSampleTestDate FROM wellbore_oil_sample WHERE wlbOilSampleTestDate <> '9999-12-31'

mappingId Mapping:00185:Literal:wellbore_development_all:wlbDiskosWellboreParent
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreParent {wlbDiskosWellboreParent} . 
source    SELECT wlbNpdidWellbore,wlbDiskosWellboreParent FROM wellbore_development_all

mappingId Mapping:00186:Literal:wellbore_dst:wlbDstChokeSize
target    npd:wellbore/{wlbNpdidWellbore}/test/drillstem/{wlbDstTestNumber} npdv:DSTChokeSize {wlbDstChokeSize}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbDstTestNumber,wlbDstChokeSize FROM wellbore_dst

mappingId Mapping:00187:Literal:wellbore_exploration_all:wlbWellboreName
target    npd:wellbore/{wlbNpdidWellbore} npdv:name {wlbWellboreName} . 
source    SELECT wlbNpdidWellbore,wlbWellboreName FROM wellbore_exploration_all

mappingId Mapping:00188:Literal:wellbore_shallow_all:wlbEwCode
target    npd:wellbore/{wlbNpdidWellbore} npdv:codeEW {wlbEwCode} . 
source    SELECT wlbNpdidWellbore,wlbEwCode FROM wellbore_shallow_all

mappingId Mapping:00189:Literal:licence:prlDateGranted
target    npd:licence/{prlNpdidLicence} npdv:dateLicenceGranted {prlDateGranted}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,prlDateGranted FROM licence WHERE prlDateGranted <> '9999-12-31'

mappingId Mapping:00190:Literal:seaArea:seaSourcePressure
target    npd:survey/{seaSurveyName}/area npdv:sourcePressure {seaSourcePressure}^^rdfs:Literal . 
source    SELECT seaArea_id,seaSurveyName,seaSourcePressure FROM seaArea

mappingId Mapping:00191:Literal:wellbore_formation_top:lsuNpdidLithoStrat
target    npd:wellbore/{wlbNpdidWellbore}/stratum/{lsuNpdidLithoStrat}/depth/{lsuTopDepth}/{lsuBottomDepth} npdv:inLithostratigraphicUnit npd:stratum/{lsuNpdidLithoStrat} . 
source    SELECT wlbNpdidWellbore,lsuNpdidLithoStrat,lsuTopDepth,lsuBottomDepth FROM wellbore_formation_top

mappingId Mapping:00192:Literal:field_licensee_hst:fldSdfiShare
target    npd:field/{fldNpdidField}/licensee/{cmpNpdidCompany}/history/{fldLicenseeFrom}/{fldLicenseeTo} npdv:SDFI {fldSdfiShare}^^xsd:decimal . 
source    SELECT fldNpdidField,cmpNpdidCompany,fldLicenseeFrom,fldLicenseeTo,fldSdfiShare FROM field_licensee_hst

mappingId Mapping:00193:Literal:facility_moveable:fclNpdidFacility
target    npd:facility/{fclNpdidFacility} npdv:idNPD {fclNpdidFacility}^^xsd:integer . 
source    SELECT fclNpdidFacility FROM facility_moveable

mappingId Mapping:00194:Literal:bsns_arr_area:dateSyncNPD
target    npd:baa/{baaNpdidBsnsArrArea} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT baaNpdidBsnsArrArea,dateSyncNPD FROM bsns_arr_area WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00195:Literal:field_reserves:fldRemainingOE
target    npd:field/{fldNpdidField}/reserve npdv:remainingOilEquivalents {fldRemainingOE}^^xsd:decimal . 
source    SELECT fldNpdidField,fldRemainingOE FROM field_reserves

mappingId Mapping:00196:Literal:licence_transfer_hst:prlTransferredInterest
target    npd:licence/{prlNpdidLicence}/transfer/{prlTransferDirection}/{cmpNpdidCompany}/history/{prlTransferDateValidFrom} npdv:transferredInterest {prlTransferredInterest}^^xsd:decimal . 
source    SELECT prlNpdidLicence,prlTransferDirection,cmpNpdidCompany,prlTransferDateValidFrom,prlTransferredInterest FROM licence_transfer_hst

mappingId Mapping:00197:Literal:facility_fixed:fclPhase
target    npd:facility/{fclNpdidFacility} npdv:status {fclPhase}^^xsd:string .
source    SELECT fclNpdidFacility,fclPhase FROM facility_fixed

mappingId Mapping:00198:Literal:wellbore_exploration_all:wlbNsSec
target    npd:wellbore/{wlbNpdidWellbore} npdv:secondsNS {wlbNsSec}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbNsSec FROM wellbore_exploration_all

mappingId Mapping:00199:Literal:wellbore_development_all:wlbUtmZone
target    npd:wellbore/{wlbNpdidWellbore} npdv:utmZone {wlbUtmZone}^^xsd:integer . 
source    SELECT wlbNpdidWellbore,wlbUtmZone FROM wellbore_development_all

mappingId Mapping:00200:Literal:licence_licensee_hst:prlLicenseeInterest
target    npd:licence/{prlNpdidLicence}/licensee/{cmpNpdidCompany}/history/{prlLicenseeDateValidFrom}/{prlLicenseeDateValidTo} npdv:licenseeInterest {prlLicenseeInterest}^^xsd:decimal . 
source    SELECT prlNpdidLicence,cmpNpdidCompany,prlLicenseeDateValidFrom,prlLicenseeDateValidTo,prlLicenseeInterest FROM licence_licensee_hst

mappingId Mapping:00201:Literal:wellbore_exploration_all:wlbDateUpdatedMax
target    npd:wellbore/{wlbNpdidWellbore} npdv:dateUpdatedMax {wlbDateUpdatedMax}^^xsd:dateTime . 
source    SELECT wlbNpdidWellbore,wlbDateUpdatedMax FROM wellbore_exploration_all WHERE wlbDateUpdatedMax <> '9999-12-31'

mappingId Mapping:00202:Literal:discovery:dscHcType
target    npd:discovery/{dscNpdidDiscovery} npdv:hydrocarbonType {dscHcType}^^xsd:string . 
source    SELECT dscNpdidDiscovery,dscHcType FROM discovery

mappingId Mapping:00203:Literal:licence_petreg_licence:dateSyncNPD
target    npd:petreg/licence/{prlNpdidLicence} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,dateSyncNPD FROM licence_petreg_licence WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00204:Literal:wellbore_coordinates:wlbEwUtm
target    npd:wellbore/{wlbNpdidWellbore}/point npdv:utmEW {wlbEwUtm}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbEwUtm FROM wellbore_coordinates

mappingId Mapping:00205:Literal:seis_acquisition:seaCdpTotalKm
target    npd:survey/{seaName} npdv:lengthCdpTotalKm {seaCdpTotalKm}^^xsd:integer . 
source    SELECT seaName,seaCdpTotalKm FROM seis_acquisition

mappingId Mapping:00206:Literal:field_production_totalt_NCS_year:prfYear
target    npd:ncs/production/{prfYear} npdv:productionYear {prfYear}^^xsd:integer . 
source    SELECT prfYear FROM field_production_totalt_NCS_year

mappingId Mapping:00207:Literal:Trans:wellbore_development_all:wlbDiscoveryWellbore
target    npd:wellbore/{wlbNpdidWellbore} npdv:isDiscoveryWellbore "true"^^rdfs:Literal . 
source    SELECT wlbNpdidWellbore FROM wellbore_development_all WHERE wlbDiscoveryWellbore='YES'

mappingId Mapping:00208:Literal:Trans:wellbore_development_all:wlbDiscoveryWellbore
target    npd:wellbore/{wlbNpdidWellbore} npdv:isDiscoveryWellbore "false"^^rdfs:Literal . 
source    SELECT wlbNpdidWellbore FROM wellbore_development_all WHERE wlbDiscoveryWellbore='NO'

mappingId Mapping:00209:Literal:Trans:prlArea:prlAreaPolyStratigraphical
target    npd:licence/{prlNpdidLicence}/area/{prlArea_id}/history/{prlAreaPolyDateValidFrom}/{prlAreaPolyDateValidTo} npdv:isStratigraphical "true"^^rdfs:Literal . 
source    SELECT prlArea_id,prlNpdidLicence,prlAreaPolyDateValidFrom,prlAreaPolyDateValidTo FROM prlArea WHERE prlAreaPolyStratigraphical='YES'

mappingId Mapping:00210:Literal:Trans:prlArea:prlAreaPolyStratigraphical
target    npd:licence/{prlNpdidLicence}/area/{prlArea_id}/history/{prlAreaPolyDateValidFrom}/{prlAreaPolyDateValidTo} npdv:isStratigraphical "false"^^rdfs:Literal . 
source    SELECT prlArea_id,prlNpdidLicence,prlAreaPolyDateValidFrom,prlAreaPolyDateValidTo FROM prlArea WHERE prlAreaPolyStratigraphical='NO'

mappingId Mapping:00211:Literal:wellbore_oil_sample:wlbOilSampleBottomDepth
target    npd:wellbore/{wlbNpdidWellbore}/test/oilsample/{wellbore_oil_sample_id} npdv:oilSampleBottomDepth {wlbOilSampleBottomDepth}^^xsd:decimal . 
source    SELECT wellbore_oil_sample_id,wlbNpdidWellbore,wlbOilSampleBottomDepth FROM wellbore_oil_sample

mappingId Mapping:00212:Literal:field_licensee_hst:fldOwnerFrom
target    npd:field/{fldNpdidField}/licensee/{cmpNpdidCompany}/history/{fldLicenseeFrom}/{fldLicenseeTo} npdv:dateFieldOwnerFrom {fldOwnerFrom}^^xsd:dateTime . 
source    SELECT fldNpdidField,cmpNpdidCompany,fldLicenseeFrom,fldLicenseeTo,fldOwnerFrom FROM field_licensee_hst WHERE fldOwnerFrom <> '9999-12-31'

mappingId Mapping:00213:Literal:seis_acquisition_progress:seaProgressDate
target    npd:survey/{seaProgressText2}/status/{seis_acquisition_progress_id} npdv:dateSurveyProgress {seaProgressDate}^^xsd:dateTime . 
source    SELECT seis_acquisition_progress_id,seaProgressText2,seaProgressDate FROM seis_acquisition_progress WHERE seaProgressDate <> '9999-12-31'

mappingId Mapping:00214:Literal:Trans:company:cmpLicenceOperFormer
target    npd:company/{cmpNpdidCompany} npdv:isFormerLicenceOperator "true"^^rdfs:Literal . 
source    SELECT cmpNpdidCompany FROM company WHERE cmpLicenceOperFormer='Y'

mappingId Mapping:00215:Literal:Trans:company:cmpLicenceOperFormer
target    npd:company/{cmpNpdidCompany} npdv:isFormerLicenceOperator "false"^^rdfs:Literal . 
source    SELECT cmpNpdidCompany FROM company WHERE cmpLicenceOperFormer='N'

mappingId Mapping:00216:Literal:wellbore_core:wlbCoreIntervalBottom
target    npd:wellbore/{wlbNpdidWellbore}/core/{wlbCoreNumber} npdv:coreIntervalBottom {wlbCoreIntervalBottom}^^xsd:decimal . 
source    SELECT wellbore_core_id,wlbNpdidWellbore,wlbCoreNumber,wlbCoreIntervalBottom FROM wellbore_core

mappingId Mapping:00217:Literal:licence_licensee_hst:prlOperDateValidTo
target    npd:licence/{prlNpdidLicence}/licensee/{cmpNpdidCompany}/history/{prlLicenseeDateValidFrom}/{prlLicenseeDateValidTo} npdv:dateOperatorValidTo {prlOperDateValidTo}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,cmpNpdidCompany,prlLicenseeDateValidFrom,prlLicenseeDateValidTo,prlOperDateValidTo FROM licence_licensee_hst WHERE prlOperDateValidTo <> '9999-12-31'

mappingId Mapping:00218:Literal:seaMultiline:seaPlanCdpKm
target    npd:survey/{seaSurveyName}/multiline npdv:lengthPlannedCdpKm {seaPlanCdpKm}^^xsd:integer . 
source    SELECT seaSurveyName,seaPlanCdpKm FROM seaMultiline

mappingId Mapping:00219:Literal:tuf_petreg_message:ptlMessageDateUpdated
target    npd:petreg/facility/{tufNpdidTuf}/message/{ptlMessageDocumentNo} ptl:dateUpdated {ptlMessageDateUpdated}^^xsd:dateTime . 
source    SELECT tufNpdidTuf,ptlMessageDocumentNo,ptlMessageDateUpdated FROM tuf_petreg_message WHERE ptlMessageDateUpdated <> '9999-12-31'

mappingId Mapping:00220:Literal:field_activity_status_hst:fldStatus
target    npd:field/{fldNpdidField}/activity/{fldStatus}/history/{fldStatusFromDate}/{fldStatusToDate} npdv:status {fldStatus} . 
source    SELECT fldNpdidField,fldStatus,fldStatusFromDate,fldStatusToDate FROM field_activity_status_hst

mappingId Mapping:00221:Literal:wellbore_dst:wlbDstFinShutInPress
target    npd:wellbore/{wlbNpdidWellbore}/test/drillstem/{wlbDstTestNumber} npdv:DSTFinalShutInPressure {wlbDstFinShutInPress}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbDstTestNumber,wlbDstFinShutInPress FROM wellbore_dst

mappingId Mapping:00222:Literal:seaArea:seaPlanBoatKm
target    npd:survey/{seaSurveyName}/area npdv:lengthPlannedBoatKm {seaPlanBoatKm}^^xsd:integer . 
source    SELECT seaArea_id,seaSurveyName,seaPlanBoatKm FROM seaArea

mappingId Mapping:00223:Literal:licence_task:wlbName
target    npd:licence/{prlNpdidLicence}/task/{prlTaskID} npdv:name {wlbName} . 
source    SELECT prlNpdidLicence,prlTaskID,wlbName FROM licence_task

mappingId Mapping:00224:Literal:licence_oper_hst:dateSyncNPD
target    npd:licence/{prlNpdidLicence}/operator/{cmpNpdidCompany}/history/{prlOperDateValidFrom}/{prlOperDateValidTo} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,cmpNpdidCompany,prlOperDateValidFrom,prlOperDateValidTo,dateSyncNPD FROM licence_oper_hst WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00225:Literal:facility_fixed:fclNsSec
target    npd:facility/{fclNpdidFacility} npdv:secondsNS {fclNsSec}^^xsd:decimal . 
source    SELECT fclNpdidFacility,fclNsSec FROM facility_fixed

mappingId Mapping:00226:Literal:apaAreaGross:apaMap_no
target    npd:mainarea/{apaAreaGross_id} npdv:mapNo {apaMap_no}^^xsd:integer . 
source    SELECT apaAreaGross_id,apaMap_no FROM apaAreaGross

mappingId Mapping:00227:Literal:discovery:dscFactPageUrl
target    npd:discovery/{dscNpdidDiscovery} npdv:factPageURL {dscFactPageUrl} . 
source    SELECT dscNpdidDiscovery,dscFactPageUrl FROM discovery

mappingId Mapping:00228:Literal:wellbore_mud:wlbMD
target    npd:wellbore/{wlbNpdidWellbore}/test/mud/{wellbore_mud_id} npdv:mudMeasuredDepth {wlbMD}^^xsd:decimal . 
source    SELECT wellbore_mud_id,wlbNpdidWellbore,wlbMD FROM wellbore_mud

mappingId Mapping:00229:Literal:wellbore_shallow_all:wlbNamePart6
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreNamePart6 {wlbNamePart6}^^xsd:string . 
source    SELECT wlbNpdidWellbore,wlbNamePart6 FROM wellbore_shallow_all

mappingId Mapping:00230:Literal:facility_fixed:fclNsMin
target    npd:facility/{fclNpdidFacility} npdv:minutesNS {fclNsMin}^^xsd:integer . 
source    SELECT fclNpdidFacility,fclNsMin FROM facility_fixed

mappingId Mapping:00231:Literal:discovery_reserves:dscDateOffResEstDisplay
target    npd:discovery/{dscNpdidDiscovery}/{dscReservesRC} npdv:dateResourceEstimate {dscDateOffResEstDisplay}^^xsd:dateTime . 
source    SELECT dscNpdidDiscovery,dscReservesRC,dscDateOffResEstDisplay FROM discovery_reserves WHERE dscDateOffResEstDisplay <> '9999-12-31'

mappingId Mapping:00232:Literal:field:fldName
target    npd:field/{fldNpdidField} npdv:name {fldName} . 
source    SELECT fldNpdidField,fldName FROM field

mappingId Mapping:00233:Literal:wellbore_exploration_all:wlbFactPageUrl
target    npd:wellbore/{wlbNpdidWellbore} npdv:factPageURL {wlbFactPageUrl} . 
source    SELECT wlbNpdidWellbore,wlbFactPageUrl FROM wellbore_exploration_all

mappingId Mapping:00234:Literal:wellbore_exploration_all:wlbDiskosWellboreParent
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreParent {wlbDiskosWellboreParent} . 
source    SELECT wlbNpdidWellbore,wlbDiskosWellboreParent FROM wellbore_exploration_all

mappingId Mapping:00235:Literal:licence_licensee_hst:prlLicenseeDateUpdated
target    npd:licence/{prlNpdidLicence}/licensee/{cmpNpdidCompany}/history/{prlLicenseeDateValidFrom}/{prlLicenseeDateValidTo} npdv:dateUpdated {prlLicenseeDateUpdated}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,cmpNpdidCompany,prlLicenseeDateValidFrom,prlLicenseeDateValidTo,prlLicenseeDateUpdated FROM licence_licensee_hst WHERE prlLicenseeDateUpdated <> '9999-12-31'

mappingId Mapping:00236:Literal:wellbore_exploration_all:wlbNpdidWellbore
target    npd:wellbore/{wlbNpdidWellbore} npdv:idNPD {wlbNpdidWellbore}^^xsd:integer . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all

mappingId Mapping:00237:Literal:field_reserves:fldRecoverableGas
target    npd:field/{fldNpdidField}/reserve npdv:recoverableGas {fldRecoverableGas}^^xsd:decimal . 
source    SELECT fldNpdidField,fldRecoverableGas FROM field_reserves

mappingId Mapping:00238:Literal:prlArea:prlAreaPolyFromZvalue
target    npd:licence/{prlNpdidLicence}/area/{prlArea_id}/history/{prlAreaPolyDateValidFrom}/{prlAreaPolyDateValidTo} npdv:ZValueFrom {prlAreaPolyFromZvalue}^^xsd:integer . 
source    SELECT prlArea_id,prlNpdidLicence,prlAreaPolyDateValidFrom,prlAreaPolyDateValidTo,prlAreaPolyFromZvalue FROM prlArea

mappingId Mapping:00239:Literal:field_production_monthly:prfPrdCondensateNetMillSm3
target    npd:field/{prfNpdidInformationCarrier}/production/{prfYear}/{prfMonth} npdv:producedCondensate {prfPrdCondensateNetMillSm3}^^xsd:decimal . 
source    SELECT prfNpdidInformationCarrier,prfYear,prfMonth,prfPrdCondensateNetMillSm3 FROM field_production_monthly

mappingId Mapping:00240:Literal:licence_petreg_licence:ptlName
target    npd:petreg/licence/{prlNpdidLicence} ptl:name {ptlName} . 
source    SELECT prlNpdidLicence,ptlName FROM licence_petreg_licence

mappingId Mapping:00241:Literal:strat_litho_wellbore:lsuTopDepth
target    npd:wellbore/{wlbNpdidWellbore}/stratum/{lsuNpdidLithoStrat}/depth/{lsuTopDepth}/{lsuBottomDepth} npdv:wellboreStratumTopDepth {lsuTopDepth}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,lsuNpdidLithoStrat,lsuTopDepth,lsuBottomDepth FROM strat_litho_wellbore

mappingId Mapping:00242:Literal:field_investment_yearly:prfInvestmentsMillNOK
target    npd:field/{prfNpdidInformationCarrier}/investment/{prfYear} npdv:investmentNOK {prfInvestmentsMillNOK}^^xsd:decimal . 
source    SELECT prfNpdidInformationCarrier,prfYear,prfInvestmentsMillNOK FROM field_investment_yearly

mappingId Mapping:00243:Literal:wellbore_dst:wlbDstFromDepth
target    npd:wellbore/{wlbNpdidWellbore}/test/drillstem/{wlbDstTestNumber} npdv:DSTDepthFrom {wlbDstFromDepth}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbDstTestNumber,wlbDstFromDepth FROM wellbore_dst

mappingId Mapping:00244:Literal:company_reserves:dateSyncNPD
target    npd:company/{cmpNpdidCompany}/reserve/{fldNpdidField} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT cmpNpdidCompany,fldNpdidField,dateSyncNPD FROM company_reserves WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00245:Literal:wellbore_exploration_all:wlbDrillingDays
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreDrillingDays {wlbDrillingDays}^^xsd:integer . 
source    SELECT wlbNpdidWellbore,wlbDrillingDays FROM wellbore_exploration_all

mappingId Mapping:00246:Literal:seis_acquisition_coordinates_inc_turnarea:seaPolygonNSDeg
target    npd:survey/{seaSurveyName}/point/{seaPolygonPointNumber} npdv:degreesNS {seaPolygonNSDeg}^^xsd:integer . 
source    SELECT seaSurveyName,seaPolygonPointNumber,seaPolygonNSDeg FROM seis_acquisition_coordinates_inc_turnarea

mappingId Mapping:00247:Literal:bsns_arr_area_operator:baaOperatorDateUpdated
target    npd:baa/{baaNpdidBsnsArrArea} npdv:dateUpdated {baaOperatorDateUpdated}^^xsd:dateTime . 
source    SELECT baaNpdidBsnsArrArea,baaOperatorDateUpdated FROM bsns_arr_area_operator WHERE baaOperatorDateUpdated <> '9999-12-31'

mappingId Mapping:00248:Literal:tuf_owner_hst:dateSyncNPD
target    npd:facility/{tufNpdidTuf}/owner/{cmpNpdidCompany}/history/{tufOwnerDateValidFrom}/{tufOwnerDateValidTo} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT tufNpdidTuf,cmpNpdidCompany,tufOwnerDateValidFrom,tufOwnerDateValidTo,dateSyncNPD FROM tuf_owner_hst WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00249:Literal:wellbore_exploration_all:wlbPlotSymbol
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellborePlotSymbol {wlbPlotSymbol}^^xsd:integer . 
source    SELECT wlbNpdidWellbore,wlbPlotSymbol FROM wellbore_exploration_all

mappingId Mapping:00250:Literal:field_reserves:fldDateOffResEstDisplay
target    npd:field/{fldNpdidField}/reserve npdv:dateResourceEstimate {fldDateOffResEstDisplay}^^xsd:dateTime . 
source    SELECT fldNpdidField,fldDateOffResEstDisplay FROM field_reserves WHERE fldDateOffResEstDisplay <> '9999-12-31'

mappingId Mapping:00251:Literal:wellbore_oil_sample:wlbOilSampledateReceivedDate
target    npd:wellbore/{wlbNpdidWellbore}/test/oilsample/{wellbore_oil_sample_id} npdv:dateOilSampleReceived {wlbOilSampledateReceivedDate}^^xsd:dateTime . 
source    SELECT wellbore_oil_sample_id,wlbNpdidWellbore,wlbOilSampledateReceivedDate FROM wellbore_oil_sample WHERE wlbOilSampledateReceivedDate <> '9999-12-31'

mappingId Mapping:00252:Literal:wellbore_oil_sample:wlbOilSampleTestNumber
target    npd:wellbore/{wlbNpdidWellbore}/test/oilsample/{wellbore_oil_sample_id} npdv:oilSampleTestNumber {wlbOilSampleTestNumber}^^xsd:string . 
source    SELECT wellbore_oil_sample_id,wlbNpdidWellbore,wlbOilSampleTestNumber FROM wellbore_oil_sample

mappingId Mapping:00253:Literal:licence:prlPhaseCurrent
target    npd:licence/{prlNpdidLicence} npdv:currentStatus {prlPhaseCurrent}^^xsd:string . 
source    SELECT prlNpdidLicence,prlPhaseCurrent FROM licence

mappingId Mapping:00254:Literal:facility_moveable:fclNpdidCurrentRespCompany
target    npd:facility/{fclNpdidFacility} npdv:currentResponsibleCompany npd:company/{fclNpdidCurrentRespCompany} . 
source    SELECT fclNpdidFacility,fclNpdidCurrentRespCompany FROM facility_moveable

mappingId Mapping:00255:Literal:prlAreaSplitByBlock:prlAreaPolyFromZvalue
target    npd:licence/{prlNpdidLicence}/block/{blcName}/polyno/{prlAreaPolyPolyNo}/history/{prlAreaPolyDateValidFrom}/{prlAreaPolyDateValidTo} npdv:ZValueFrom {prlAreaPolyFromZvalue}^^xsd:integer . 
source    SELECT prlNpdidLicence,blcName,prlAreaPolyPolyNo,prlAreaPolyDateValidFrom,prlAreaPolyDateValidTo,prlAreaPolyFromZvalue FROM prlAreaSplitByBlock

mappingId Mapping:00256:Literal:field_operator_hst:fldOperatorFrom
target    npd:field/{fldNpdidField}/operator/{cmpNpdidCompany}/history/{fldOperatorFrom}/{fldOperatorTo} npdv:dateFieldOperatorFrom {fldOperatorFrom}^^xsd:dateTime . 
source    SELECT fldNpdidField,cmpNpdidCompany,fldOperatorFrom,fldOperatorTo FROM field_operator_hst WHERE fldOperatorFrom <> '9999-12-31'

mappingId Mapping:00257:Literal:wellbore_development_all:wlbDrillPermit
target    npd:wellbore/{wlbNpdidWellbore} npdv:drillPermit {wlbDrillPermit}^^xsd:string . 
source    SELECT wlbNpdidWellbore,wlbDrillPermit FROM wellbore_development_all

mappingId Mapping:00258:Literal:seaMultiline:seaSourceNumber
target    npd:survey/{seaSurveyName}/multiline npdv:sourceNumber {seaSourceNumber}^^rdfs:Literal . 
source    SELECT seaSurveyName,seaSourceNumber FROM seaMultiline

mappingId Mapping:00259:Literal:wellbore_development_all:wlbNsUtm
target    npd:wellbore/{wlbNpdidWellbore} npdv:utmNS {wlbNsUtm}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbNsUtm FROM wellbore_development_all

mappingId Mapping:00260:Literal:field_production_yearly:prfPrdGasNetBillSm3
target    npd:field/{prfNpdidInformationCarrier}/production/{prfYear} npdv:producedGas {prfPrdGasNetBillSm3}^^xsd:decimal . 
source    SELECT prfNpdidInformationCarrier,prfYear,prfPrdGasNetBillSm3 FROM field_production_yearly

mappingId Mapping:00261:Literal:field:fldFactPageUrl
target    npd:field/{fldNpdidField} npdv:factPageURL {fldFactPageUrl} . 
source    SELECT fldNpdidField,fldFactPageUrl FROM field

mappingId Mapping:00262:Literal:licence_petreg_licence_oper:ptlOperDateUpdated
target    npd:petreg/licence/{prlNpdidLicence} ptl:dateUpdated {ptlOperDateUpdated}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,ptlOperDateUpdated FROM licence_petreg_licence_oper WHERE ptlOperDateUpdated <> '9999-12-31'

mappingId Mapping:00263:Literal:seaArea:seaSensorNumbers
target    npd:survey/{seaSurveyName}/area npdv:sensorNumbers {seaSensorNumbers}^^rdfs:Literal . 
source    SELECT seaArea_id,seaSurveyName,seaSensorNumbers FROM seaArea

mappingId Mapping:00264:Literal:wellbore_development_all:wlbFactPageUrl
target    npd:wellbore/{wlbNpdidWellbore} npdv:factPageURL {wlbFactPageUrl} . 
source    SELECT wlbNpdidWellbore,wlbFactPageUrl FROM wellbore_development_all

mappingId Mapping:00265:Literal:licence_petreg_licence:ptlDateValidTo
target    npd:petreg/licence/{prlNpdidLicence} ptl:dateLicenceValidTo {ptlDateValidTo}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,ptlDateValidTo FROM licence_petreg_licence WHERE ptlDateValidTo <> '9999-12-31'

mappingId Mapping:00266:Literal:Trans:discovery:nmaName
target    npd:discovery/{dscNpdidDiscovery} npdv:mainAreaLocation npd:ncs/mainarea/1 . 
source    SELECT dscNpdidDiscovery FROM discovery WHERE nmaName='Barents sea'

mappingId Mapping:00267:Literal:Trans:discovery:nmaName
target    npd:discovery/{dscNpdidDiscovery} npdv:mainAreaLocation npd:ncs/mainarea/2 . 
source    SELECT dscNpdidDiscovery FROM discovery WHERE nmaName='Norwegian sea'

mappingId Mapping:00268:Literal:Trans:discovery:nmaName
target    npd:discovery/{dscNpdidDiscovery} npdv:mainAreaLocation npd:ncs/mainarea/3 . 
source    SELECT dscNpdidDiscovery FROM discovery WHERE nmaName='North sea'

mappingId Mapping:00269:Literal:licence_task:dateSyncNPD
target    npd:licence/{prlNpdidLicence}/task/{prlTaskID} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,prlTaskID,dateSyncNPD FROM licence_task WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00270:Literal:bsns_arr_area_licensee_hst:baaLicenseeDateUpdated
target    npd:baa/{baaNpdidBsnsArrArea}/licensee/{cmpNpdidCompany}/history/{baaLicenseeDateValidFrom}/{baaLicenseeDateValidTo} npdv:dateUpdated {baaLicenseeDateUpdated}^^xsd:dateTime . 
source    SELECT baaNpdidBsnsArrArea,cmpNpdidCompany,baaLicenseeDateValidFrom,baaLicenseeDateValidTo,baaLicenseeDateUpdated FROM bsns_arr_area_licensee_hst WHERE baaLicenseeDateUpdated <> '9999-12-31'

mappingId Mapping:00271:Literal:facility_moveable:fclFactPageUrl
target    npd:facility/{fclNpdidFacility} npdv:factPageURL {fclFactPageUrl} . 
source    SELECT fclNpdidFacility,fclFactPageUrl FROM facility_moveable

mappingId Mapping:00272:Literal:bsns_arr_area_licensee_hst:baaLicenseeDateValidTo
target    npd:baa/{baaNpdidBsnsArrArea}/licensee/{cmpNpdidCompany}/history/{baaLicenseeDateValidFrom}/{baaLicenseeDateValidTo} npdv:dateBaaLicenseeValidTo {baaLicenseeDateValidTo}^^xsd:dateTime . 
source    SELECT baaNpdidBsnsArrArea,cmpNpdidCompany,baaLicenseeDateValidFrom,baaLicenseeDateValidTo FROM bsns_arr_area_licensee_hst WHERE baaLicenseeDateValidTo <> '9999-12-31'

mappingId Mapping:00273:Literal:seaArea:seaPlanCdpKm
target    npd:survey/{seaSurveyName}/area npdv:lengthPlannedCdpKm {seaPlanCdpKm}^^xsd:integer . 
source    SELECT seaArea_id,seaSurveyName,seaPlanCdpKm FROM seaArea

mappingId Mapping:00274:Literal:wellbore_coordinates:wlbNsSec
target    npd:wellbore/{wlbNpdidWellbore}/point npdv:secondsNS {wlbNsSec}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbNsSec FROM wellbore_coordinates

mappingId Mapping:00275:Literal:licence_oper_hst:prlOperDateValidFrom
target    npd:licence/{prlNpdidLicence}/operator/{cmpNpdidCompany}/history/{prlOperDateValidFrom}/{prlOperDateValidTo} npdv:dateOperatorValidFrom {prlOperDateValidFrom}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,cmpNpdidCompany,prlOperDateValidFrom,prlOperDateValidTo FROM licence_oper_hst WHERE prlOperDateValidFrom <> '9999-12-31'

mappingId Mapping:00276:Literal:seaArea:sea3DKm2
target    npd:survey/{seaSurveyName}/area npdv:areaSize3DKm2 {sea3DKm2}^^xsd:decimal . 
source    SELECT seaArea_id,seaSurveyName,sea3DKm2 FROM seaArea

mappingId Mapping:00277:Literal:licence_task:prlTaskDateUpdated
target    npd:licence/{prlNpdidLicence}/task/{prlTaskID} npdv:dateUpdated {prlTaskDateUpdated}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,prlTaskID,prlTaskDateUpdated FROM licence_task WHERE prlTaskDateUpdated <> '9999-12-31'

mappingId Mapping:00278:Literal:tuf_petreg_licence:ptlDateUpdated
target    npd:petreg/facility/{tufNpdidTuf} ptl:dateUpdated {ptlDateUpdated}^^xsd:dateTime . 
source    SELECT tufNpdidTuf,ptlDateUpdated FROM tuf_petreg_licence WHERE ptlDateUpdated <> '9999-12-31'

mappingId Mapping:00279:Literal:wellbore_oil_sample:dateSyncNPD
target    npd:wellbore/{wlbNpdidWellbore}/test/oilsample/{wellbore_oil_sample_id} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT wellbore_oil_sample_id,wlbNpdidWellbore,dateSyncNPD FROM wellbore_oil_sample WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00280:Literal:bsns_arr_area_transfer_hst:baaTransferredInterest
target    npd:baa/{baaNpdidBsnsArrArea}/transfer/{baaTransferDirection}/{cmpNpdidCompany}/history/{baaTransferDateValidFrom} npdv:transferredInterest {baaTransferredInterest}^^xsd:decimal . 
source    SELECT baaNpdidBsnsArrArea,baaTransferDirection,cmpNpdidCompany,baaTransferDateValidFrom,baaTransferredInterest FROM bsns_arr_area_transfer_hst

mappingId Mapping:00281:Literal:field_production_totalt_NCS_month:prfYear
target    npd:ncs/production/{prfYear}/{prfMonth} npdv:productionYear {prfYear}^^xsd:integer . 
source    SELECT prfYear,prfMonth FROM field_production_totalt_NCS_month

mappingId Mapping:00282:Literal:wellbore_dst:wlbDstBottomHolePress
target    npd:wellbore/{wlbNpdidWellbore}/test/drillstem/{wlbDstTestNumber} npdv:DSTBottomHolePressure {wlbDstBottomHolePress}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbDstTestNumber,wlbDstBottomHolePress FROM wellbore_dst

mappingId Mapping:00283:Literal:wellbore_mud:dateSyncNPD
target    npd:wellbore/{wlbNpdidWellbore}/test/mud/{wellbore_mud_id} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT wellbore_mud_id,wlbNpdidWellbore,dateSyncNPD FROM wellbore_mud WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00284:Literal:wellbore_shallow_all:wlbNsMin
target    npd:wellbore/{wlbNpdidWellbore} npdv:minutesNS {wlbNsMin}^^xsd:integer . 
source    SELECT wlbNpdidWellbore,wlbNsMin FROM wellbore_shallow_all

mappingId Mapping:00285:Literal:wellbore_exploration_all:wlbNsUtm
target    npd:wellbore/{wlbNpdidWellbore} npdv:utmNS {wlbNsUtm}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbNsUtm FROM wellbore_exploration_all

mappingId Mapping:00286:Literal:field_production_totalt_NCS_month:prfPrdProducedWaterInFieldMillSm3
target    npd:ncs/production/{prfYear}/{prfMonth} npdv:producedWater {prfPrdProducedWaterInFieldMillSm3}^^xsd:decimal . 
source    SELECT prfYear,prfMonth,prfPrdProducedWaterInFieldMillSm3 FROM field_production_totalt_NCS_month

mappingId Mapping:00287:Literal:field_licensee_hst:fldLicenseeTo
target    npd:field/{fldNpdidField}/licensee/{cmpNpdidCompany}/history/{fldLicenseeFrom}/{fldLicenseeTo} npdv:dateFieldLicenseeTo {fldLicenseeTo}^^xsd:dateTime . 
source    SELECT fldNpdidField,cmpNpdidCompany,fldLicenseeFrom,fldLicenseeTo FROM field_licensee_hst WHERE fldLicenseeTo <> '9999-12-31'

mappingId Mapping:00289:Literal:wellbore_dst:wlbDstOilProd
target    npd:wellbore/{wlbNpdidWellbore}/test/drillstem/{wlbDstTestNumber} npdv:DSTOilProducedRate {wlbDstOilProd}^^xsd:integer . 
source    SELECT wlbNpdidWellbore,wlbDstTestNumber,wlbDstOilProd FROM wellbore_dst

mappingId Mapping:00290:Literal:licence_licensee_hst:prlOperDateValidFrom
target    npd:licence/{prlNpdidLicence}/licensee/{cmpNpdidCompany}/history/{prlLicenseeDateValidFrom}/{prlLicenseeDateValidTo} npdv:dateOperatorValidFrom {prlOperDateValidFrom}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,cmpNpdidCompany,prlLicenseeDateValidFrom,prlLicenseeDateValidTo,prlOperDateValidFrom FROM licence_licensee_hst WHERE prlOperDateValidFrom <> '9999-12-31'

mappingId Mapping:00291:Literal:tuf_petreg_licence_oper:dateSyncNPD
target    npd:petreg/facility/{tufNpdidTuf} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT tufNpdidTuf,dateSyncNPD FROM tuf_petreg_licence_oper WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00292:Literal:wellbore_exploration_all:wlbDiskosWellboreType
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreType {wlbDiskosWellboreType} . 
source    SELECT wlbNpdidWellbore,wlbDiskosWellboreType FROM wellbore_exploration_all

mappingId Mapping:00293:Literal:bsns_arr_area_area_poly_hst:baaAreaPolyDateValidTo
target    npd:baa/{baaNpdidBsnsArrArea}/block/{baaAreaPolyBlockName}/polyno/{baaAreaPolyNo}/history/{baaAreaPolyDateValidFrom}/{baaAreaPolyDateValidTo} npdv:dateBaaAreaValidTo {baaAreaPolyDateValidTo}^^xsd:dateTime . 
source    SELECT baaNpdidBsnsArrArea,baaAreaPolyBlockName,baaAreaPolyNo,baaAreaPolyDateValidFrom,baaAreaPolyDateValidTo FROM bsns_arr_area_area_poly_hst WHERE baaAreaPolyDateValidTo <> '9999-12-31'

mappingId Mapping:00294:Literal:wellbore_dst:wlbDstGasDensity
target    npd:wellbore/{wlbNpdidWellbore}/test/drillstem/{wlbDstTestNumber} npdv:DSTGasDensity {wlbDstGasDensity}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbDstTestNumber,wlbDstGasDensity FROM wellbore_dst

mappingId Mapping:00295:Literal:bsns_arr_area_transfer_hst:baaTransferDateUpdated
target    npd:baa/{baaNpdidBsnsArrArea}/transfer/{baaTransferDirection}/{cmpNpdidCompany}/history/{baaTransferDateValidFrom} npdv:dateUpdated {baaTransferDateUpdated}^^xsd:dateTime . 
source    SELECT baaNpdidBsnsArrArea,baaTransferDirection,cmpNpdidCompany,baaTransferDateValidFrom,baaTransferDateUpdated FROM bsns_arr_area_transfer_hst WHERE baaTransferDateUpdated <> '9999-12-31'

mappingId Mapping:00296:Literal:wellbore_exploration_all:wlbCompletionYear
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreCompletionYear {wlbCompletionYear}^^xsd:integer . 
source    SELECT wlbNpdidWellbore,wlbCompletionYear FROM wellbore_exploration_all

mappingId Mapping:00297:Literal:wellbore_shallow_all:wlbWaterDepth
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreWaterDepth {wlbWaterDepth}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbWaterDepth FROM wellbore_shallow_all

mappingId Mapping:00298:Literal:wellbore_exploration_all:wlbFinalVerticalDepth
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreFinalVerticalDepth {wlbFinalVerticalDepth}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbFinalVerticalDepth FROM wellbore_exploration_all

mappingId Mapping:00299:Literal:facility_fixed:fclEwSec
target    npd:facility/{fclNpdidFacility} npdv:secondsEW {fclEwSec}^^xsd:decimal . 
source    SELECT fclNpdidFacility,fclEwSec FROM facility_fixed

mappingId Mapping:00300:Literal:pipLine:pipNpdidPipe
target    npd:pipeline/{pipNpdidPipe} npdv:idNPD {pipNpdidPipe}^^xsd:integer . 
source    SELECT pipNpdidPipe FROM pipLine

mappingId Mapping:00301:Literal:facility_fixed:fclStartupDate
target    npd:facility/{fclNpdidFacility} npdv:dateProductionStart {fclStartupDate}^^xsd:dateTime . 
source    SELECT fclNpdidFacility,fclStartupDate FROM facility_fixed WHERE fclStartupDate <> '9999-12-31'

mappingId Mapping:00302:Literal:bsns_arr_area:baaFactMapUrl
target    npd:baa/{baaNpdidBsnsArrArea} npdv:factMapURL {baaFactMapUrl} . 
source    SELECT baaNpdidBsnsArrArea,baaFactMapUrl FROM bsns_arr_area

mappingId Mapping:00303:Literal:wellbore_coordinates:wlbEwSec
target    npd:wellbore/{wlbNpdidWellbore}/point npdv:secondsEW {wlbEwSec}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbEwSec FROM wellbore_coordinates

mappingId Mapping:00304:Literal:company_reserves:cmpRecoverableOil
target    npd:company/{cmpNpdidCompany}/reserve/{fldNpdidField} npdv:recoverableOil {cmpRecoverableOil}^^xsd:decimal . 
source    SELECT cmpNpdidCompany,fldNpdidField,cmpRecoverableOil FROM company_reserves

mappingId Mapping:00305:Literal:seaMultiline:seaSensorNumbers
target    npd:survey/{seaSurveyName}/multiline npdv:sensorNumbers {seaSensorNumbers}^^rdfs:Literal . 
source    SELECT seaSurveyName,seaSensorNumbers FROM seaMultiline

mappingId Mapping:00306:Literal:seis_acquisition_coordinates_inc_turnarea:seaPolygonNSMin
target    npd:survey/{seaSurveyName}/point/{seaPolygonPointNumber} npdv:minutesNS {seaPolygonNSMin}^^xsd:integer . 
source    SELECT seaSurveyName,seaPolygonPointNumber,seaPolygonNSMin FROM seis_acquisition_coordinates_inc_turnarea

mappingId Mapping:00307:Literal:seis_acquisition:seaDateFinalized
target    npd:survey/{seaName} npdv:dateSurveyActualCompleted {seaDateFinalized}^^xsd:dateTime . 
source    SELECT seaName,seaDateFinalized FROM seis_acquisition WHERE seaDateFinalized <> '9999-12-31'

mappingId Mapping:00308:Literal:wellbore_exploration_all:wlbNamePart1
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreNamePart1 {wlbNamePart1}^^xsd:integer . 
source    SELECT wlbNpdidWellbore,wlbNamePart1 FROM wellbore_exploration_all

mappingId Mapping:00309:Literal:bsns_arr_area:baaDateApproved
target    npd:baa/{baaNpdidBsnsArrArea} npdv:dateApproved {baaDateApproved}^^xsd:dateTime . 
source    SELECT baaNpdidBsnsArrArea,baaDateApproved FROM bsns_arr_area WHERE baaDateApproved <> '9999-12-31'

mappingId Mapping:00310:Literal:wellbore_casing_and_lot:wlbCasingDiameter
target    npd:wellbore/{wlbNpdidWellbore}/test/casingleakoff/{wellbore_casing_and_lot_id} npdv:casingDiameter {wlbCasingDiameter}^^xsd:string . 
source    SELECT wellbore_casing_and_lot_id,wlbNpdidWellbore,wlbCasingDiameter FROM wellbore_casing_and_lot

mappingId Mapping:00311:Literal:Trans:licence:prlStatus
target    npd:licence/{prlNpdidLicence} npdv:isActive "true"^^rdfs:Literal . 
source    SELECT prlNpdidLicence FROM licence WHERE prlStatus='ACTIVE'

mappingId Mapping:00312:Literal:Trans:licence:prlStatus
target    npd:licence/{prlNpdidLicence} npdv:isActive "false"^^rdfs:Literal . 
source    SELECT prlNpdidLicence FROM licence WHERE prlStatus='INACTIVE'

mappingId Mapping:00313:Literal:licence_task:prlTaskTypeEn
target    npd:licence/{prlNpdidLicence}/task/{prlTaskID} npdv:taskType {prlTaskTypeEn}^^xsd:string . 
source    SELECT prlNpdidLicence,prlTaskID,prlTaskTypeEn FROM licence_task

mappingId Mapping:00314:Literal:seaArea:seaSourceSize
target    npd:survey/{seaSurveyName}/area npdv:sourceSize {seaSourceSize}^^rdfs:Literal . 
source    SELECT seaArea_id,seaSurveyName,seaSourceSize FROM seaArea

mappingId Mapping:00315:Literal:wellbore_core:wlbCoreNumber
target    npd:wellbore/{wlbNpdidWellbore}/core/{wlbCoreNumber} npdv:coreNo {wlbCoreNumber}^^xsd:integer . 
source    SELECT wellbore_core_id,wlbNpdidWellbore,wlbCoreNumber FROM wellbore_core

mappingId Mapping:00316:Literal:field_production_monthly:prfPrdNGLNetMillSm3
target    npd:field/{prfNpdidInformationCarrier}/production/{prfYear}/{prfMonth} npdv:producedNGL {prfPrdNGLNetMillSm3}^^xsd:decimal . 
source    SELECT prfNpdidInformationCarrier,prfYear,prfMonth,prfPrdNGLNetMillSm3 FROM field_production_monthly

mappingId Mapping:00317:Literal:licence:prlDateValidTo
target    npd:licence/{prlNpdidLicence} npdv:dateLicenceValidTo {prlDateValidTo}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,prlDateValidTo FROM licence WHERE prlDateValidTo <> '9999-12-31'

mappingId Mapping:00318:Literal:licence_phase_hst:prlDatePhaseValidTo
target    npd:licence/{prlNpdidLicence}/phase/{prlPhase}/history/{prlDatePhaseValidFrom}/{prlDatePhaseValidTo} npdv:dateStatusValidTo {prlDatePhaseValidTo}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,prlPhase,prlDatePhaseValidFrom,prlDatePhaseValidTo FROM licence_phase_hst WHERE prlDatePhaseValidTo <> '9999-12-31'

mappingId Mapping:00319:Literal:dscArea:dscNpdidResInclInDiscovery
target    npd:discovery/{dscNpdidDiscovery}/area/hctype/{dscHcType} npdv:resourcesIncludedInDiscovery npd:discovery/{dscNpdidResInclInDiscovery} . 
source    SELECT dscNpdidDiscovery,dscHcType,dscNpdidResInclInDiscovery FROM dscArea

mappingId Mapping:00320:Literal:licence_phase_hst:prlPhaseDateUpdated
target    npd:licence/{prlNpdidLicence}/phase/{prlPhase}/history/{prlDatePhaseValidFrom}/{prlDatePhaseValidTo} npdv:dateUpdated {prlPhaseDateUpdated}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,prlPhase,prlDatePhaseValidFrom,prlDatePhaseValidTo,prlPhaseDateUpdated FROM licence_phase_hst WHERE prlPhaseDateUpdated <> '9999-12-31'

mappingId Mapping:00321:Literal:wellbore_exploration_all:wlbEwDesDeg
target    npd:wellbore/{wlbNpdidWellbore} npdv:decimalDegreesEW {wlbEwDesDeg}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbEwDesDeg FROM wellbore_exploration_all

mappingId Mapping:00322:Literal:tuf_petreg_licence:ptlDateValidFrom
target    npd:petreg/facility/{tufNpdidTuf} ptl:dateLicenceValidFrom {ptlDateValidFrom}^^xsd:dateTime . 
source    SELECT tufNpdidTuf,ptlDateValidFrom FROM tuf_petreg_licence WHERE ptlDateValidFrom <> '9999-12-31'

mappingId Mapping:00323:Literal:wellbore_development_all:wlbGeodeticDatum
target    npd:wellbore/{wlbNpdidWellbore} npdv:geodeticDatum {wlbGeodeticDatum}^^xsd:string . 
source    SELECT wlbNpdidWellbore,wlbGeodeticDatum FROM wellbore_development_all

mappingId Mapping:00324:Literal:licence_petreg_message:ptlMessageDocumentNo
target    npd:petreg/licence/{prlNpdidLicence}/message/{ptlMessageDocumentNo} ptl:messageNo {ptlMessageDocumentNo}^^xsd:integer . 
source    SELECT prlNpdidLicence,ptlMessageDocumentNo FROM licence_petreg_message

mappingId Mapping:00325:Literal:tuf_petreg_licence:dateSyncNPD
target    npd:petreg/facility/{tufNpdidTuf} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT tufNpdidTuf,dateSyncNPD FROM tuf_petreg_licence WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00327:Literal:wellbore_exploration_all:wlbTotalDepth
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreTotalDepth {wlbTotalDepth}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbTotalDepth FROM wellbore_exploration_all

mappingId Mapping:00328:Literal:field_production_yearly:prfPrdOeNetMillSm3
target    npd:field/{prfNpdidInformationCarrier}/production/{prfYear} npdv:producedOilEquivalents {prfPrdOeNetMillSm3}^^xsd:decimal . 
source    SELECT prfNpdidInformationCarrier,prfYear,prfPrdOeNetMillSm3 FROM field_production_yearly

mappingId Mapping:00329:Literal:field:fldDateUpdatedMax
target    npd:field/{fldNpdidField} npdv:dateUpdatedMax {fldDateUpdatedMax}^^xsd:dateTime . 
source    SELECT fldNpdidField,fldDateUpdatedMax FROM field WHERE fldDateUpdatedMax <> '9999-12-31'

mappingId Mapping:00330:Literal:seis_acquisition_coordinates_inc_turnarea:seaPolygonNSSec
target    npd:survey/{seaSurveyName}/point/{seaPolygonPointNumber} npdv:secondsNS {seaPolygonNSSec}^^xsd:decimal . 
source    SELECT seaSurveyName,seaPolygonPointNumber,seaPolygonNSSec FROM seis_acquisition_coordinates_inc_turnarea

mappingId Mapping:00331:Literal:field_investment_yearly:prfYear
target    npd:field/{prfNpdidInformationCarrier}/investment/{prfYear} npdv:productionYear {prfYear}^^xsd:integer . 
source    SELECT prfNpdidInformationCarrier,prfYear FROM field_investment_yearly

mappingId Mapping:00332:Literal:wellbore_mud:wlbMudDateUpdated
target    npd:wellbore/{wlbNpdidWellbore}/test/mud/{wellbore_mud_id} npdv:dateUpdated {wlbMudDateUpdated}^^xsd:dateTime . 
source    SELECT wellbore_mud_id,wlbNpdidWellbore,wlbMudDateUpdated FROM wellbore_mud WHERE wlbMudDateUpdated <> '9999-12-31'

mappingId Mapping:00333:Literal:field_licensee_hst:fldCompanyShare
target    npd:field/{fldNpdidField}/licensee/{cmpNpdidCompany}/history/{fldLicenseeFrom}/{fldLicenseeTo} npdv:companyShare {fldCompanyShare}^^xsd:decimal . 
source    SELECT fldNpdidField,cmpNpdidCompany,fldLicenseeFrom,fldLicenseeTo,fldCompanyShare FROM field_licensee_hst

mappingId Mapping:00334:Literal:Trans:seaArea:seaPolygonKind
target    npd:survey/{seaSurveyName}/area npdv:isTurnAreaIncluded "true"^^rdfs:Literal . 
source    SELECT seaArea_id,seaSurveyName FROM seaArea WHERE seaPolygonKind='Område inkludert snuområde'

mappingId Mapping:00335:Literal:Trans:seaArea:seaPolygonKind
target    npd:survey/{seaSurveyName}/area npdv:isTurnAreaIncluded "false"^^rdfs:Literal . 
source    SELECT seaArea_id,seaSurveyName FROM seaArea WHERE seaPolygonKind='Område unntatt snuområde'

mappingId Mapping:00336:Literal:wellbore_shallow_all:wlbEwDesDeg
target    npd:wellbore/{wlbNpdidWellbore} npdv:decimalDegreesEW {wlbEwDesDeg}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbEwDesDeg FROM wellbore_shallow_all

mappingId Mapping:00337:Literal:company_reserves:cmpRecoverableCondensate
target    npd:company/{cmpNpdidCompany}/reserve/{fldNpdidField} npdv:recoverableCondensate {cmpRecoverableCondensate}^^xsd:decimal . 
source    SELECT cmpNpdidCompany,fldNpdidField,cmpRecoverableCondensate FROM company_reserves

mappingId Mapping:00338:Literal:wellbore_development_all:wlbContentPlanned
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellborePlannedContent {wlbContentPlanned}^^xsd:string . 
source    SELECT wlbNpdidWellbore,wlbContentPlanned FROM wellbore_development_all

mappingId Mapping:00339:Literal:company_reserves:cmpRemainingNGL
target    npd:company/{cmpNpdidCompany}/reserve/{fldNpdidField} npdv:remainingNGL {cmpRemainingNGL}^^xsd:decimal . 
source    SELECT cmpNpdidCompany,fldNpdidField,cmpRemainingNGL FROM company_reserves

mappingId Mapping:00340:Literal:wellbore_coordinates:wlbEwCode
target    npd:wellbore/{wlbNpdidWellbore}/point npdv:codeEW {wlbEwCode} . 
source    SELECT wlbNpdidWellbore,wlbEwCode FROM wellbore_coordinates

mappingId Mapping:00341:Literal:field_production_yearly:prfYear
target    npd:field/{prfNpdidInformationCarrier}/production/{prfYear} npdv:productionYear {prfYear}^^xsd:integer . 
source    SELECT prfNpdidInformationCarrier,prfYear FROM field_production_yearly

mappingId Mapping:00342:Literal:facility_fixed:fclFunctions
target    npd:facility/{fclNpdidFacility} npdv:facilityFunction {fclFunctions} . 
source    SELECT fclNpdidFacility,fclFunctions FROM facility_fixed

mappingId Mapping:00343:Literal:field_production_totalt_NCS_month:prfPrdGasNetBillSm3
target    npd:ncs/production/{prfYear}/{prfMonth} npdv:producedGas {prfPrdGasNetBillSm3}^^xsd:decimal . 
source    SELECT prfYear,prfMonth,prfPrdGasNetBillSm3 FROM field_production_totalt_NCS_month

mappingId Mapping:00344:Literal:wellbore_exploration_all:wlbContent
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreContent {wlbContent}^^xsd:string . 
source    SELECT wlbNpdidWellbore,wlbContent FROM wellbore_exploration_all

mappingId Mapping:00345:Literal:wellbore_exploration_all:wlbUtmZone
target    npd:wellbore/{wlbNpdidWellbore} npdv:utmZone {wlbUtmZone}^^xsd:integer . 
source    SELECT wlbNpdidWellbore,wlbUtmZone FROM wellbore_exploration_all

mappingId Mapping:00346:Literal:wellbore_mud:wlbMudViscosityAtMD
target    npd:wellbore/{wlbNpdidWellbore}/test/mud/{wellbore_mud_id} npdv:mudViscosity {wlbMudViscosityAtMD}^^xsd:decimal . 
source    SELECT wellbore_mud_id,wlbNpdidWellbore,wlbMudViscosityAtMD FROM wellbore_mud

mappingId Mapping:00347:Literal:wellbore_coordinates:wlbUtmZone
target    npd:wellbore/{wlbNpdidWellbore}/point npdv:utmZone {wlbUtmZone}^^xsd:integer . 
source    SELECT wlbNpdidWellbore,wlbUtmZone FROM wellbore_coordinates

mappingId Mapping:00348:Literal:licence_oper_hst:prlOperDateValidTo
target    npd:licence/{prlNpdidLicence}/operator/{cmpNpdidCompany}/history/{prlOperDateValidFrom}/{prlOperDateValidTo} npdv:dateOperatorValidTo {prlOperDateValidTo}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,cmpNpdidCompany,prlOperDateValidFrom,prlOperDateValidTo FROM licence_oper_hst WHERE prlOperDateValidTo <> '9999-12-31'

mappingId Mapping:00349:Literal:wellbore_exploration_all:wlbEwSec
target    npd:wellbore/{wlbNpdidWellbore} npdv:secondsEW {wlbEwSec}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbEwSec FROM wellbore_exploration_all

mappingId Mapping:00350:Literal:bsns_arr_area_area_poly_hst:dateSyncNPD
target    npd:baa/{baaNpdidBsnsArrArea}/block/{baaAreaPolyBlockName}/polyno/{baaAreaPolyNo}/history/{baaAreaPolyDateValidFrom}/{baaAreaPolyDateValidTo} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT baaNpdidBsnsArrArea,baaAreaPolyBlockName,baaAreaPolyNo,baaAreaPolyDateValidFrom,baaAreaPolyDateValidTo,dateSyncNPD FROM bsns_arr_area_area_poly_hst WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00351:Literal:wellbore_development_all:wlbNamePart5
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreNamePart5 {wlbNamePart5}^^xsd:string . 
source    SELECT wlbNpdidWellbore,wlbNamePart5 FROM wellbore_development_all

mappingId Mapping:00352:Literal:tuf_petreg_licence_licencee:ptlLicenseeDateUpdated
target    npd:petreg/facility/{tufNpdidTuf}/licencee/{cmpNpdidCompany} ptl:dateUpdated {ptlLicenseeDateUpdated}^^xsd:dateTime . 
source    SELECT tufNpdidTuf,cmpNpdidCompany,ptlLicenseeDateUpdated FROM tuf_petreg_licence_licencee WHERE ptlLicenseeDateUpdated <> '9999-12-31'

mappingId Mapping:00353:Literal:seis_acquisition_coordinates_inc_turnarea:seaPolygonEWMin
target    npd:survey/{seaSurveyName}/point/{seaPolygonPointNumber} npdv:minutesEW {seaPolygonEWMin}^^xsd:integer . 
source    SELECT seaSurveyName,seaPolygonPointNumber,seaPolygonEWMin FROM seis_acquisition_coordinates_inc_turnarea

mappingId Mapping:00354:Literal:wellbore_development_all:wlbWell
target    npd:wellbore/{wlbNpdidWellbore} npdv:belongsToWell npd:well/{wlbWell} . 
source    SELECT wlbNpdidWellbore,wlbWell FROM wellbore_development_all

mappingId Mapping:00355:Literal:wellbore_development_all:wlbDateUpdated
target    npd:wellbore/{wlbNpdidWellbore} npdv:dateUpdated {wlbDateUpdated}^^xsd:dateTime . 
source    SELECT wlbNpdidWellbore,wlbDateUpdated FROM wellbore_development_all WHERE wlbDateUpdated <> '9999-12-31'

mappingId Mapping:00356:Literal:licence:prlOriginalArea
target    npd:licence/{prlNpdidLicence} npdv:originalAreaSize {prlOriginalArea}^^xsd:decimal . 
source    SELECT prlNpdidLicence,prlOriginalArea FROM licence

mappingId Mapping:00357:Literal:prlAreaSplitByBlock:prlAreaPolyPolyArea
target    npd:licence/{prlNpdidLicence}/block/{blcName}/polyno/{prlAreaPolyPolyNo}/history/{prlAreaPolyDateValidFrom}/{prlAreaPolyDateValidTo} npdv:areaSize {prlAreaPolyPolyArea}^^xsd:decimal . 
source    SELECT prlNpdidLicence,blcName,prlAreaPolyPolyNo,prlAreaPolyDateValidFrom,prlAreaPolyDateValidTo,prlAreaPolyPolyArea FROM prlAreaSplitByBlock

mappingId Mapping:00358:Literal:facility_fixed:fclNsDeg
target    npd:facility/{fclNpdidFacility} npdv:degreesNS {fclNsDeg}^^xsd:integer . 
source    SELECT fclNpdidFacility,fclNsDeg FROM facility_fixed

mappingId Mapping:00359:Literal:licence_petreg_licence:ptlDateUpdated
target    npd:petreg/licence/{prlNpdidLicence} ptl:dateUpdated {ptlDateUpdated}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,ptlDateUpdated FROM licence_petreg_licence WHERE ptlDateUpdated <> '9999-12-31'

mappingId Mapping:00360:Literal:wellbore_coordinates:wlbNsDeg
target    npd:wellbore/{wlbNpdidWellbore}/point npdv:degreesNS {wlbNsDeg}^^xsd:integer . 
source    SELECT wlbNpdidWellbore,wlbNsDeg FROM wellbore_coordinates

mappingId Mapping:00361:Literal:wellbore_development_all:dateSyncNPD
target    npd:wellbore/{wlbNpdidWellbore} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT wlbNpdidWellbore,dateSyncNPD FROM wellbore_development_all WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00362:Literal:company_reserves:cmpRecoverableNGL
target    npd:company/{cmpNpdidCompany}/reserve/{fldNpdidField} npdv:recoverableNGL {cmpRecoverableNGL}^^xsd:decimal . 
source    SELECT cmpNpdidCompany,fldNpdidField,cmpRecoverableNGL FROM company_reserves

mappingId Mapping:00363:Literal:discovery:dscDateUpdated
target    npd:discovery/{dscNpdidDiscovery} npdv:dateUpdated {dscDateUpdated}^^xsd:dateTime . 
source    SELECT dscNpdidDiscovery,dscDateUpdated FROM discovery WHERE dscDateUpdated <> '9999-12-31'

mappingId Mapping:00365:Literal:bsns_arr_area_area_poly_hst:baaAreaPolyBlockName
target    npd:baa/{baaNpdidBsnsArrArea}/block/{baaAreaPolyBlockName}/polyno/{baaAreaPolyNo}/history/{baaAreaPolyDateValidFrom}/{baaAreaPolyDateValidTo} npdv:blockLocation npd:block/{baaAreaPolyBlockName} . 
source    SELECT baaNpdidBsnsArrArea,baaAreaPolyBlockName,baaAreaPolyNo,baaAreaPolyDateValidFrom,baaAreaPolyDateValidTo FROM bsns_arr_area_area_poly_hst

mappingId Mapping:00366:Literal:wellbore_exploration_all:wlbStatus
target    npd:wellbore/{wlbNpdidWellbore} npdv:status {wlbStatus} . 
source    SELECT wlbNpdidWellbore,wlbStatus FROM wellbore_exploration_all

mappingId Mapping:00367:Literal:wellbore_shallow_all:wlbNsDeg
target    npd:wellbore/{wlbNpdidWellbore} npdv:degreesNS {wlbNsDeg}^^xsd:integer . 
source    SELECT wlbNpdidWellbore,wlbNsDeg FROM wellbore_shallow_all

mappingId Mapping:00368:Literal:seis_acquisition:dateSyncNPD
target    npd:survey/{seaName} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT seaName,dateSyncNPD FROM seis_acquisition WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00369:Literal:tuf_petreg_licence_licencee:dateSyncNPD
target    npd:petreg/facility/{tufNpdidTuf}/licencee/{cmpNpdidCompany} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT tufNpdidTuf,cmpNpdidCompany,dateSyncNPD FROM tuf_petreg_licence_licencee WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00370:Literal:wellbore_core_photo:wlbCorePhotoImgUrl
target    npd:wellbore/{wlbNpdidWellbore}/core/{wlbCoreNumber}/photo/{wellbore_core_photo_id}/{wlbCorePhotoTitle} npdv:corePhotoURL {wlbCorePhotoImgUrl} . 
source    SELECT wellbore_core_photo_id,wlbNpdidWellbore,wlbCoreNumber,wlbCorePhotoTitle,wlbCorePhotoImgUrl FROM wellbore_core_photo

mappingId Mapping:00371:Literal:wellbore_development_all:wlbNsCode
target    npd:wellbore/{wlbNpdidWellbore} npdv:codeNS {wlbNsCode} . 
source    SELECT wlbNpdidWellbore,wlbNsCode FROM wellbore_development_all

mappingId Mapping:00372:Literal:facility_fixed:fclEwDeg
target    npd:facility/{fclNpdidFacility} npdv:degreesEW {fclEwDeg}^^xsd:integer . 
source    SELECT fclNpdidFacility,fclEwDeg FROM facility_fixed

mappingId Mapping:00373:Literal:Trans:wellbore_exploration_all:wlbAgeAtTd
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeTD isc:Campanian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeAtTd='CAMPANIAN'

mappingId Mapping:00374:Literal:Trans:wellbore_exploration_all:wlbAgeAtTd
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeTD isc:Carboniferous . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeAtTd='CARBONIFEROUS'

mappingId Mapping:00375:Literal:Trans:wellbore_exploration_all:wlbAgeAtTd
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeTD isc:Cretaceous . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeAtTd='CRETACEOUS'

mappingId Mapping:00376:Literal:Trans:wellbore_exploration_all:wlbAgeAtTd
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeTD isc:Danian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeAtTd='DANIAN'

mappingId Mapping:00377:Literal:Trans:wellbore_exploration_all:wlbAgeAtTd
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeTD isc:Devonian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeAtTd='DEVONIAN'

mappingId Mapping:00378:Literal:Trans:wellbore_exploration_all:wlbAgeAtTd
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeTD isc:Mississippian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeAtTd='EARLY CARBONIFEROUS'

mappingId Mapping:00379:Literal:Trans:wellbore_exploration_all:wlbAgeAtTd
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeTD isc:LowerCretaceous . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeAtTd='EARLY CRETACEOUS'

mappingId Mapping:00380:Literal:Trans:wellbore_exploration_all:wlbAgeAtTd
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeTD isc:LowerJurassic . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeAtTd='EARLY JURASSIC'

mappingId Mapping:00381:Literal:Trans:wellbore_exploration_all:wlbAgeAtTd
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeTD isc:Cisuralian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeAtTd='EARLY PERMIAN'

mappingId Mapping:00382:Literal:Trans:wellbore_exploration_all:wlbAgeAtTd
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeTD isc:LowerTriassic . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeAtTd='EARLY TRIASSIC'

mappingId Mapping:00383:Literal:Trans:wellbore_exploration_all:wlbAgeAtTd
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeTD isc:Eocene . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeAtTd='EOCENE'

mappingId Mapping:00384:Literal:Trans:wellbore_exploration_all:wlbAgeAtTd
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeTD isc:Jurassic . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeAtTd='JURASSIC'

mappingId Mapping:00385:Literal:Trans:wellbore_exploration_all:wlbAgeAtTd
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeTD isc:Pennsylvanian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeAtTd='LATE CARBONIFEROUS'

mappingId Mapping:00386:Literal:Trans:wellbore_exploration_all:wlbAgeAtTd
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeTD isc:UpperCretaceous . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeAtTd='LATE CRETACEOUS'

mappingId Mapping:00387:Literal:Trans:wellbore_exploration_all:wlbAgeAtTd
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeTD isc:UpperJurassic . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeAtTd='LATE JURASSIC'

mappingId Mapping:00388:Literal:Trans:wellbore_exploration_all:wlbAgeAtTd
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeTD isc:Thanetian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeAtTd='LATE PALEOCENE'

mappingId Mapping:00389:Literal:Trans:wellbore_exploration_all:wlbAgeAtTd
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeTD isc:Lopingian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeAtTd='LATE PERMIAN'

mappingId Mapping:00390:Literal:Trans:wellbore_exploration_all:wlbAgeAtTd
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeTD isc:Piacenzian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeAtTd='LATE PLIOCENE'

mappingId Mapping:00391:Literal:Trans:wellbore_exploration_all:wlbAgeAtTd
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeTD isc:UpperTriassic . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeAtTd='LATE TRIASSIC'

mappingId Mapping:00392:Literal:Trans:wellbore_exploration_all:wlbAgeAtTd
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeTD isc:MiddleJurassic . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeAtTd='MIDDLE JURASSIC'

mappingId Mapping:00393:Literal:Trans:wellbore_exploration_all:wlbAgeAtTd
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeTD isc:MiddleTriassic . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeAtTd='MIDDLE TRIASSIC'

mappingId Mapping:00394:Literal:Trans:wellbore_exploration_all:wlbAgeAtTd
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeTD isc:Miocene . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeAtTd='MIOCENE'

mappingId Mapping:00395:Literal:Trans:wellbore_exploration_all:wlbAgeAtTd
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeTD isc:Oligocene . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeAtTd='OLIGOCENE'

mappingId Mapping:00396:Literal:Trans:wellbore_exploration_all:wlbAgeAtTd
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeTD isc:Paleocene . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeAtTd='PALEOCENE'

mappingId Mapping:00397:Literal:Trans:wellbore_exploration_all:wlbAgeAtTd
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeTD isc:Permian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeAtTd='PERMIAN'

mappingId Mapping:00398:Literal:Trans:wellbore_exploration_all:wlbAgeAtTd
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeTD isc:Pleistocene . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeAtTd='PLEISTOCENE'

mappingId Mapping:00399:Literal:Trans:wellbore_exploration_all:wlbAgeAtTd
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeTD isc:Pliocene . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeAtTd='PLIOCENE'

mappingId Mapping:00400:Literal:Trans:wellbore_exploration_all:wlbAgeAtTd
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeTD isc:Silurian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeAtTd='SILURIAN'

mappingId Mapping:00401:Literal:Trans:wellbore_exploration_all:wlbAgeAtTd
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeTD isc:Triassic . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeAtTd='TRIASSIC'

mappingId Mapping:00402:Literal:facility_moveable:fclDateUpdated
target    npd:facility/{fclNpdidFacility} npdv:dateUpdated {fclDateUpdated}^^xsd:dateTime . 
source    SELECT fclNpdidFacility,fclDateUpdated FROM facility_moveable WHERE fclDateUpdated <> '9999-12-31'

mappingId Mapping:00403:Literal:licence:prlDateUpdatedMax
target    npd:licence/{prlNpdidLicence} npdv:dateUpdatedMax {prlDateUpdatedMax}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,prlDateUpdatedMax FROM licence WHERE prlDateUpdatedMax <> '9999-12-31'

mappingId Mapping:00404:Literal:licence_transfer_hst:dateSyncNPD
target    npd:licence/{prlNpdidLicence}/transfer/{prlTransferDirection}/{cmpNpdidCompany}/history/{prlTransferDateValidFrom} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,prlTransferDirection,cmpNpdidCompany,prlTransferDateValidFrom,dateSyncNPD FROM licence_transfer_hst WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00405:Literal:wellbore_shallow_all:wlbNamePart1
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreNamePart1 {wlbNamePart1}^^xsd:integer . 
source    SELECT wlbNpdidWellbore,wlbNamePart1 FROM wellbore_shallow_all

mappingId Mapping:00406:Literal:wellbore_shallow_all:wlbEwSec
target    npd:wellbore/{wlbNpdidWellbore} npdv:secondsEW {wlbEwSec}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbEwSec FROM wellbore_shallow_all

mappingId Mapping:00407:Literal:wellbore_exploration_all:wlbEntryDate
target    npd:wellbore/{wlbNpdidWellbore} npdv:dateWellboreEntry {wlbEntryDate}^^xsd:dateTime . 
source    SELECT wlbNpdidWellbore,wlbEntryDate FROM wellbore_exploration_all WHERE wlbEntryDate <> '9999-12-31'

mappingId Mapping:00408:Literal:licence_area_poly_hst:prlAreaPolyPolyArea
target    npd:licence/{prlNpdidLicence}/block/{prlAreaPolyBlockName}/polyno/{prlAreaPolyPolyNo}/history/{prlAreaPolyDateValidFrom}/{prlAreaPolyDateValidTo} npdv:areaSize {prlAreaPolyPolyArea}^^xsd:decimal . 
source    SELECT prlNpdidLicence,prlAreaPolyBlockName,prlAreaPolyPolyNo,prlAreaPolyDateValidFrom,prlAreaPolyDateValidTo,prlAreaPolyPolyArea FROM licence_area_poly_hst

mappingId Mapping:00409:Literal:wellbore_shallow_all:dateSyncNPD
target    npd:wellbore/{wlbNpdidWellbore} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT wlbNpdidWellbore,dateSyncNPD FROM wellbore_shallow_all WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00410:Literal:wellbore_exploration_all:wlbWell
target    npd:wellbore/{wlbNpdidWellbore} npdv:belongsToWell npd:well/{wlbWell} . 
source    SELECT wlbNpdidWellbore,wlbWell FROM wellbore_exploration_all

mappingId Mapping:00411:Literal:wellbore_development_all:wlbEwCode
target    npd:wellbore/{wlbNpdidWellbore} npdv:codeEW {wlbEwCode} . 
source    SELECT wlbNpdidWellbore,wlbEwCode FROM wellbore_development_all

mappingId Mapping:00412:Literal:field_owner_hst:fldOwnerDateUpdated
target    npd:field/{fldNpdidField}/owner/{fldNpdidOwner}/history/{fldOwnershipFromDate}/{fldOwnershipToDate} npdv:dateUpdated {fldOwnerDateUpdated}^^xsd:dateTime . 
source    SELECT fldNpdidField,fldNpdidOwner,fldOwnershipFromDate,fldOwnershipToDate,fldOwnerDateUpdated FROM field_owner_hst WHERE fldOwnerDateUpdated <> '9999-12-31'

mappingId Mapping:00413:Literal:licence_phase_hst:prlPhase
target    npd:licence/{prlNpdidLicence}/phase/{prlPhase}/history/{prlDatePhaseValidFrom}/{prlDatePhaseValidTo} npdv:status {prlPhase} . 
source    SELECT prlNpdidLicence,prlPhase,prlDatePhaseValidFrom,prlDatePhaseValidTo FROM licence_phase_hst

mappingId Mapping:00414:Literal:Trans:company:cmpLicenceOperCurrent
target    npd:company/{cmpNpdidCompany} npdv:isCurrentLicenceOperator "true"^^rdfs:Literal . 
source    SELECT cmpNpdidCompany FROM company WHERE cmpLicenceOperCurrent='Y'

mappingId Mapping:00415:Literal:Trans:company:cmpLicenceOperCurrent
target    npd:company/{cmpNpdidCompany} npdv:isCurrentLicenceOperator "false"^^rdfs:Literal . 
source    SELECT cmpNpdidCompany FROM company WHERE cmpLicenceOperCurrent='N'

mappingId Mapping:00416:Literal:licence_transfer_hst:prlTransferDirection
target    npd:licence/{prlNpdidLicence}/transfer/{prlTransferDirection}/{cmpNpdidCompany}/history/{prlTransferDateValidFrom} npdv:transferDirection {prlTransferDirection} . 
source    SELECT prlNpdidLicence,prlTransferDirection,cmpNpdidCompany,prlTransferDateValidFrom FROM licence_transfer_hst

mappingId Mapping:00417:Literal:Trans:bsns_arr_area_area_poly_hst:baaAreaPolyNationCode2
target    npd:baa/{baaNpdidBsnsArrArea}/block/{baaAreaPolyBlockName}/polyno/{baaAreaPolyNo}/history/{baaAreaPolyDateValidFrom}/{baaAreaPolyDateValidTo} npdv:country <http://dbpedia.org/resource/Norway> . 
source    SELECT baaNpdidBsnsArrArea,baaAreaPolyBlockName,baaAreaPolyNo,baaAreaPolyDateValidFrom,baaAreaPolyDateValidTo FROM bsns_arr_area_area_poly_hst WHERE baaAreaPolyNationCode2='NO'

mappingId Mapping:00418:Literal:tuf_petreg_message:ptlMessageKindDesc
target    npd:petreg/facility/{tufNpdidTuf}/message/{ptlMessageDocumentNo} ptl:messageType {ptlMessageKindDesc}^^xsd:string . 
source    SELECT tufNpdidTuf,ptlMessageDocumentNo,ptlMessageKindDesc FROM tuf_petreg_message

mappingId Mapping:00419:Literal:licence_area_poly_hst:prlAreaPolyPolyNo
target    npd:licence/{prlNpdidLicence}/block/{prlAreaPolyBlockName}/polyno/{prlAreaPolyPolyNo}/history/{prlAreaPolyDateValidFrom}/{prlAreaPolyDateValidTo} npdv:polygonNo {prlAreaPolyPolyNo}^^xsd:integer . 
source    SELECT prlNpdidLicence,prlAreaPolyBlockName,prlAreaPolyPolyNo,prlAreaPolyDateValidFrom,prlAreaPolyDateValidTo FROM licence_area_poly_hst

mappingId Mapping:00420:Literal:seaMultiline:seaPlanBoatKm
target    npd:survey/{seaSurveyName}/multiline npdv:lengthPlannedBoatKm {seaPlanBoatKm}^^xsd:integer . 
source    SELECT seaSurveyName,seaPlanBoatKm FROM seaMultiline

mappingId Mapping:00421:Literal:wellbore_npdid_overview:wlbWell
target    npd:wellbore/{wlbNpdidWellbore} npdv:belongsToWell npd:well/{wlbWell} . 
source    SELECT wlbNpdidWellbore,wlbWell FROM wellbore_npdid_overview

mappingId Mapping:00422:Literal:baaArea:baaNpdidBsnsArrAreaPoly
target    npd:baa/{baaNpdidBsnsArrArea}/polygon/{baaNpdidBsnsArrAreaPoly} npdv:idNPD {baaNpdidBsnsArrAreaPoly}^^xsd:integer . 
source    SELECT baaNpdidBsnsArrArea,baaNpdidBsnsArrAreaPoly FROM baaArea

mappingId Mapping:00423:Literal:wellbore_exploration_all:wlbPurpose
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellborePurpose {wlbPurpose}^^xsd:string . 
source    SELECT wlbNpdidWellbore,wlbPurpose FROM wellbore_exploration_all

mappingId Mapping:00424:Literal:wellbore_coordinates:wlbEwMin
target    npd:wellbore/{wlbNpdidWellbore}/point npdv:minutesEW {wlbEwMin}^^xsd:integer . 
source    SELECT wlbNpdidWellbore,wlbEwMin FROM wellbore_coordinates

mappingId Mapping:00425:Literal:licence_task:prlTaskName
target    npd:licence/{prlNpdidLicence}/task/{prlTaskID} npdv:name {prlTaskName} . 
source    SELECT prlNpdidLicence,prlTaskID,prlTaskName FROM licence_task

mappingId Mapping:00426:Literal:prlAreaSplitByBlock:prlAreaPolyDateValidFrom
target    npd:licence/{prlNpdidLicence}/block/{blcName}/polyno/{prlAreaPolyPolyNo}/history/{prlAreaPolyDateValidFrom}/{prlAreaPolyDateValidTo} npdv:dateLicenceAreaValidFrom {prlAreaPolyDateValidFrom}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,blcName,prlAreaPolyPolyNo,prlAreaPolyDateValidFrom,prlAreaPolyDateValidTo FROM prlAreaSplitByBlock WHERE prlAreaPolyDateValidFrom <> '9999-12-31'

mappingId Mapping:00427:Literal:licence_phase_hst:prlDateInitialPeriodExpires
target    npd:licence/{prlNpdidLicence}/phase/{prlPhase}/history/{prlDatePhaseValidFrom}/{prlDatePhaseValidTo} npdv:dateInitialStatusTo {prlDateInitialPeriodExpires}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,prlPhase,prlDatePhaseValidFrom,prlDatePhaseValidTo,prlDateInitialPeriodExpires FROM licence_phase_hst WHERE prlDateInitialPeriodExpires <> '9999-12-31'

mappingId Mapping:00428:Literal:field:fldFactMapUrl
target    npd:field/{fldNpdidField} npdv:factMapURL {fldFactMapUrl} . 
source    SELECT fldNpdidField,fldFactMapUrl FROM field

mappingId Mapping:00429:Literal:strat_litho_wellbore_core:lsuNpdidLithoStrat
target    npd:wellbore/{wlbNpdidWellbore}/stratum/{lsuNpdidLithoStrat}/cores npdv:inLithostratigraphicUnit npd:stratum/{lsuNpdidLithoStrat} . 
source    SELECT wlbNpdidWellbore,lsuNpdidLithoStrat FROM strat_litho_wellbore_core

mappingId Mapping:00430:Literal:licence_phase_hst:prlDatePhaseValidFrom
target    npd:licence/{prlNpdidLicence}/phase/{prlPhase}/history/{prlDatePhaseValidFrom}/{prlDatePhaseValidTo} npdv:dateStatusValidFrom {prlDatePhaseValidFrom}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,prlPhase,prlDatePhaseValidFrom,prlDatePhaseValidTo FROM licence_phase_hst WHERE prlDatePhaseValidFrom <> '9999-12-31'

mappingId Mapping:00431:Literal:field:fldCurrentActivitySatus
target    npd:field/{fldNpdidField} npdv:status {fldCurrentActivitySatus} . 
source    SELECT fldNpdidField,fldCurrentActivitySatus FROM field

mappingId Mapping:00433:Literal:wellbore_shallow_all:wlbSeismicLocation
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreSeismicLocation {wlbSeismicLocation}^^xsd:string . 
source    SELECT wlbNpdidWellbore,wlbSeismicLocation FROM wellbore_shallow_all

mappingId Mapping:00434:Literal:discovery:dscName
target    npd:discovery/{dscNpdidDiscovery} npdv:name {dscName} . 
source    SELECT dscNpdidDiscovery,dscName FROM discovery

mappingId Mapping:00435:Literal:bsns_arr_area_transfer_hst:baaTransferDateValidFrom
target    npd:baa/{baaNpdidBsnsArrArea}/transfer/{baaTransferDirection}/{cmpNpdidCompany}/history/{baaTransferDateValidFrom} npdv:dateTransferValidFrom {baaTransferDateValidFrom}^^xsd:dateTime . 
source    SELECT baaNpdidBsnsArrArea,baaTransferDirection,cmpNpdidCompany,baaTransferDateValidFrom FROM bsns_arr_area_transfer_hst WHERE baaTransferDateValidFrom <> '9999-12-31'

mappingId Mapping:00436:Literal:field_operator_hst:fldOperatorDateUpdated
target    npd:field/{fldNpdidField}/operator/{cmpNpdidCompany}/history/{fldOperatorFrom}/{fldOperatorTo} npdv:dateUpdated {fldOperatorDateUpdated}^^xsd:dateTime . 
source    SELECT fldNpdidField,cmpNpdidCompany,fldOperatorFrom,fldOperatorTo,fldOperatorDateUpdated FROM field_operator_hst WHERE fldOperatorDateUpdated <> '9999-12-31'

mappingId Mapping:00437:Literal:prlArea:prlAreaPolyDateValidTo
target    npd:licence/{prlNpdidLicence}/area/{prlArea_id}/history/{prlAreaPolyDateValidFrom}/{prlAreaPolyDateValidTo} npdv:dateLicenceAreaValidTo {prlAreaPolyDateValidTo}^^xsd:dateTime . 
source    SELECT prlArea_id,prlNpdidLicence,prlAreaPolyDateValidFrom,prlAreaPolyDateValidTo FROM prlArea WHERE prlAreaPolyDateValidTo <> '9999-12-31'

mappingId Mapping:00438:Literal:bsns_arr_area:baaFactPageUrl
target    npd:baa/{baaNpdidBsnsArrArea} npdv:factPageURL {baaFactPageUrl} . 
source    SELECT baaNpdidBsnsArrArea,baaFactPageUrl FROM bsns_arr_area

mappingId Mapping:00439:Literal:bsns_arr_area_transfer_hst:dateSyncNPD
target    npd:baa/{baaNpdidBsnsArrArea}/transfer/{baaTransferDirection}/{cmpNpdidCompany}/history/{baaTransferDateValidFrom} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT baaNpdidBsnsArrArea,baaTransferDirection,cmpNpdidCompany,baaTransferDateValidFrom,dateSyncNPD FROM bsns_arr_area_transfer_hst WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00440:Literal:field_licensee_hst:fldOwnerTo
target    npd:field/{fldNpdidField}/licensee/{cmpNpdidCompany}/history/{fldLicenseeFrom}/{fldLicenseeTo} npdv:dateFieldOwnerTo {fldOwnerTo}^^xsd:dateTime . 
source    SELECT fldNpdidField,cmpNpdidCompany,fldLicenseeFrom,fldLicenseeTo,fldOwnerTo FROM field_licensee_hst WHERE fldOwnerTo <> '9999-12-31'

mappingId Mapping:00441:Literal:Trans:wellbore_shallow_all:wlbMainArea
target    npd:wellbore/{wlbNpdidWellbore} npdv:mainAreaLocation npd:ncs/mainarea/1 . 
source    SELECT wlbNpdidWellbore FROM wellbore_shallow_all WHERE wlbMainArea='Barents sea'

mappingId Mapping:00442:Literal:Trans:wellbore_shallow_all:wlbMainArea
target    npd:wellbore/{wlbNpdidWellbore} npdv:mainAreaLocation npd:ncs/mainarea/2 . 
source    SELECT wlbNpdidWellbore FROM wellbore_shallow_all WHERE wlbMainArea='Norwegian sea'

mappingId Mapping:00443:Literal:Trans:wellbore_shallow_all:wlbMainArea
target    npd:wellbore/{wlbNpdidWellbore} npdv:mainAreaLocation npd:ncs/mainarea/3 . 
source    SELECT wlbNpdidWellbore FROM wellbore_shallow_all WHERE wlbMainArea='North sea'

mappingId Mapping:00444:Literal:wellbore_development_all:wlbEntryYear
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreEntryYear {wlbEntryYear}^^xsd:integer . 
source    SELECT wlbNpdidWellbore,wlbEntryYear FROM wellbore_development_all

mappingId Mapping:00445:Literal:pipLine:pipMainGrouping
target    npd:pipeline/{pipNpdidPipe} npdv:pipelineMainGrouping {pipMainGrouping}^^xsd:string . 
source    SELECT pipNpdidPipe,pipMainGrouping FROM pipLine

mappingId Mapping:00446:Literal:seis_acquisition:seaStatus
target    npd:survey/{seaName} npdv:currentStatus {seaStatus}^^xsd:string . 
source    SELECT seaName,seaStatus FROM seis_acquisition

mappingId Mapping:00447:Literal:field_production_yearly:prfPrdNGLNetMillSm3
target    npd:field/{prfNpdidInformationCarrier}/production/{prfYear} npdv:producedNGL {prfPrdNGLNetMillSm3}^^xsd:decimal . 
source    SELECT prfNpdidInformationCarrier,prfYear,prfPrdNGLNetMillSm3 FROM field_production_yearly

mappingId Mapping:00448:Literal:field:fldDateUpdated
target    npd:field/{fldNpdidField} npdv:dateUpdated {fldDateUpdated}^^xsd:dateTime . 
source    SELECT fldNpdidField,fldDateUpdated FROM field WHERE fldDateUpdated <> '9999-12-31'

mappingId Mapping:00449:Literal:discovery_reserves:dscRecoverableOil
target    npd:discovery/{dscNpdidDiscovery}/{dscReservesRC} npdv:recoverableOil {dscRecoverableOil}^^xsd:decimal . 
source    SELECT dscNpdidDiscovery,dscReservesRC,dscRecoverableOil FROM discovery_reserves

mappingId Mapping:00450:Literal:wellbore_exploration_all:wlbEwDeg
target    npd:wellbore/{wlbNpdidWellbore} npdv:degreesEW {wlbEwDeg}^^xsd:integer . 
source    SELECT wlbNpdidWellbore,wlbEwDeg FROM wellbore_exploration_all

mappingId Mapping:00451:Literal:licence_petreg_message:ptlMessageRegisteredDate
target    npd:petreg/licence/{prlNpdidLicence}/message/{ptlMessageDocumentNo} ptl:dateMessageRegistered {ptlMessageRegisteredDate}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,ptlMessageDocumentNo,ptlMessageRegisteredDate FROM licence_petreg_message WHERE ptlMessageRegisteredDate <> '9999-12-31'

mappingId Mapping:00452:Literal:apaAreaNet:blkId
target    npd:quadrant/{qdrName}/block/{blkName}/award/{prvName}/area/{apaAreaNet_id} npdv:blockId {blkId}^^xsd:integer . 
source    SELECT apaAreaNet_id,qdrName,blkName,prvName,blkId FROM apaAreaNet

mappingId Mapping:00453:Literal:field_reserves:dateSyncNPD
target    npd:field/{fldNpdidField}/reserve npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT fldNpdidField,dateSyncNPD FROM field_reserves WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00454:Literal:wellbore_exploration_all:wlbFactMapUrl
target    npd:wellbore/{wlbNpdidWellbore} npdv:factMapURL {wlbFactMapUrl} . 
source    SELECT wlbNpdidWellbore,wlbFactMapUrl FROM wellbore_exploration_all

mappingId Mapping:00455:Literal:strat_litho_wellbore:lsuNpdidLithoStrat
target    npd:wellbore/{wlbNpdidWellbore}/stratum/{lsuNpdidLithoStrat}/depth/{lsuTopDepth}/{lsuBottomDepth} npdv:inLithostratigraphicUnit npd:stratum/{lsuNpdidLithoStrat} . 
source    SELECT wlbNpdidWellbore,lsuNpdidLithoStrat,lsuTopDepth,lsuBottomDepth FROM strat_litho_wellbore

mappingId Mapping:00456:Literal:licence_task:prlTaskExpiryDate
target    npd:licence/{prlNpdidLicence}/task/{prlTaskID} npdv:dateTaskExpiry {prlTaskExpiryDate}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,prlTaskID,prlTaskExpiryDate FROM licence_task WHERE prlTaskExpiryDate <> '9999-12-31'

mappingId Mapping:00457:Literal:tuf_petreg_licence:ptlDateUpdatedMax
target    npd:petreg/facility/{tufNpdidTuf} ptl:dateUpdatedMax {ptlDateUpdatedMax}^^xsd:dateTime . 
source    SELECT tufNpdidTuf,ptlDateUpdatedMax FROM tuf_petreg_licence WHERE ptlDateUpdatedMax <> '9999-12-31'

mappingId Mapping:00458:Literal:wellbore_shallow_all:wlbTotalDepth
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreTotalDepth {wlbTotalDepth}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbTotalDepth FROM wellbore_shallow_all

mappingId Mapping:00459:Literal:field_operator_hst:dateSyncNPD
target    npd:field/{fldNpdidField}/operator/{cmpNpdidCompany}/history/{fldOperatorFrom}/{fldOperatorTo} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT fldNpdidField,cmpNpdidCompany,fldOperatorFrom,fldOperatorTo,dateSyncNPD FROM field_operator_hst WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00460:Literal:field_licensee_hst:fldLicenseeDateUpdated
target    npd:field/{fldNpdidField}/licensee/{cmpNpdidCompany}/history/{fldLicenseeFrom}/{fldLicenseeTo} npdv:dateUpdated {fldLicenseeDateUpdated}^^xsd:dateTime . 
source    SELECT fldNpdidField,cmpNpdidCompany,fldLicenseeFrom,fldLicenseeTo,fldLicenseeDateUpdated FROM field_licensee_hst WHERE fldLicenseeDateUpdated <> '9999-12-31'

mappingId Mapping:00461:Literal:facility_fixed:fclNpdidFacility
target    npd:facility/{fclNpdidFacility} npdv:idNPD {fclNpdidFacility}^^xsd:integer . 
source    SELECT fclNpdidFacility FROM facility_fixed

mappingId Mapping:00462:Literal:wellbore_coordinates:wlbEwDeg
target    npd:wellbore/{wlbNpdidWellbore}/point npdv:degreesEW {wlbEwDeg}^^xsd:integer . 
source    SELECT wlbNpdidWellbore,wlbEwDeg FROM wellbore_coordinates

mappingId Mapping:00463:Literal:wellbore_exploration_all:wlbLicensingActivity
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreLicensingActivity {wlbLicensingActivity}^^xsd:string . 
source    SELECT wlbNpdidWellbore,wlbLicensingActivity FROM wellbore_exploration_all

mappingId Mapping:00464:Literal:field_production_totalt_NCS_month:prfPrdCondensateNetMillSm3
target    npd:ncs/production/{prfYear}/{prfMonth} npdv:producedCondensate {prfPrdCondensateNetMillSm3}^^xsd:decimal . 
source    SELECT prfYear,prfMonth,prfPrdCondensateNetMillSm3 FROM field_production_totalt_NCS_month

mappingId Mapping:00465:Literal:pipLine:pipNpdidFromFacility
target    npd:pipeline/{pipNpdidPipe} npdv:pipelineFromFacility npd:facility/{pipNpdidFromFacility} . 
source    SELECT pipNpdidPipe,pipNpdidFromFacility FROM pipLine

mappingId Mapping:00466:Literal:company_reserves:cmpRemainingOil
target    npd:company/{cmpNpdidCompany}/reserve/{fldNpdidField} npdv:remainingOil {cmpRemainingOil}^^xsd:decimal . 
source    SELECT cmpNpdidCompany,fldNpdidField,cmpRemainingOil FROM company_reserves

mappingId Mapping:00467:Literal:wellbore_exploration_all:wlbReentryExplorationActivity
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreReentryExplorationActivity {wlbReentryExplorationActivity}^^xsd:string . 
source    SELECT wlbNpdidWellbore,wlbReentryExplorationActivity FROM wellbore_exploration_all

mappingId Mapping:00469:Literal:field_licensee_hst:fldLicenseeFrom
target    npd:field/{fldNpdidField}/licensee/{cmpNpdidCompany}/history/{fldLicenseeFrom}/{fldLicenseeTo} npdv:dateFieldLicenseeFrom {fldLicenseeFrom}^^xsd:dateTime . 
source    SELECT fldNpdidField,cmpNpdidCompany,fldLicenseeFrom,fldLicenseeTo FROM field_licensee_hst WHERE fldLicenseeFrom <> '9999-12-31'

mappingId Mapping:00470:Literal:company:cmpLongName
target    npd:company/{cmpNpdidCompany} npdv:name {cmpLongName} . 
source    SELECT cmpNpdidCompany,cmpLongName FROM company

mappingId Mapping:00471:Literal:wellbore_exploration_all:wlbKellyBushElevation
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreKellyBushElevation {wlbKellyBushElevation}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbKellyBushElevation FROM wellbore_exploration_all

mappingId Mapping:00472:Literal:Trans:facility_moveable:fclNationName
target    npd:facility/{fclNpdidFacility} npdv:registeredInCountry <http://dbpedia.org/resource/Denmark> . 
source    SELECT fclNpdidFacility FROM facility_moveable WHERE fclNationName='Denmark'

mappingId Mapping:00473:Literal:Trans:facility_moveable:fclNationName
target    npd:facility/{fclNpdidFacility} npdv:registeredInCountry <http://dbpedia.org/resource/Norway> . 
source    SELECT fclNpdidFacility FROM facility_moveable WHERE fclNationName='NORWAY'

mappingId Mapping:00474:Literal:Trans:facility_moveable:fclNationName
target    npd:facility/{fclNpdidFacility} npdv:registeredInCountry <http://dbpedia.org/resource/China> . 
source    SELECT fclNpdidFacility FROM facility_moveable WHERE fclNationName='China'

mappingId Mapping:00475:Literal:Trans:facility_moveable:fclNationName
target    npd:facility/{fclNpdidFacility} npdv:registeredInCountry <http://dbpedia.org/resource/Marshall_Islands> . 
source    SELECT fclNpdidFacility FROM facility_moveable WHERE fclNationName='Marshall islands'

mappingId Mapping:00476:Literal:Trans:facility_moveable:fclNationName
target    npd:facility/{fclNpdidFacility} npdv:registeredInCountry <http://dbpedia.org/resource/The_Bahamas> . 
source    SELECT fclNpdidFacility FROM facility_moveable WHERE fclNationName='Bahamas'

mappingId Mapping:00477:Literal:Trans:facility_moveable:fclNationName
target    npd:facility/{fclNpdidFacility} npdv:registeredInCountry <http://dbpedia.org/resource/Russia> . 
source    SELECT fclNpdidFacility FROM facility_moveable WHERE fclNationName='Russian federation'

mappingId Mapping:00478:Literal:Trans:facility_moveable:fclNationName
target    npd:facility/{fclNpdidFacility} npdv:registeredInCountry <http://dbpedia.org/resource/Liberia> . 
source    SELECT fclNpdidFacility FROM facility_moveable WHERE fclNationName='Liberia'

mappingId Mapping:00479:Literal:Trans:facility_moveable:fclNationName
target    npd:facility/{fclNpdidFacility} npdv:registeredInCountry <http://dbpedia.org/resource/Panama> . 
source    SELECT fclNpdidFacility FROM facility_moveable WHERE fclNationName='Panama'

mappingId Mapping:00480:Literal:Trans:facility_moveable:fclNationName
target    npd:facility/{fclNpdidFacility} npdv:registeredInCountry <http://dbpedia.org/resource/Great_Britain> . 
source    SELECT fclNpdidFacility FROM facility_moveable WHERE fclNationName='GREAT BRITAIN'

mappingId Mapping:00481:Literal:Trans:facility_moveable:fclNationName
target    npd:facility/{fclNpdidFacility} npdv:registeredInCountry <http://dbpedia.org/resource/Singapore> . 
source    SELECT fclNpdidFacility FROM facility_moveable WHERE fclNationName='Singapore'

mappingId Mapping:00482:Literal:wellbore_coordinates:wlbNsUtm
target    npd:wellbore/{wlbNpdidWellbore}/point npdv:utmNS {wlbNsUtm}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbNsUtm FROM wellbore_coordinates

mappingId Mapping:00483:Literal:prlArea:prlAreaPolyDateValidFrom
target    npd:licence/{prlNpdidLicence}/area/{prlArea_id}/history/{prlAreaPolyDateValidFrom}/{prlAreaPolyDateValidTo} npdv:dateLicenceAreaValidFrom {prlAreaPolyDateValidFrom}^^xsd:dateTime . 
source    SELECT prlArea_id,prlNpdidLicence,prlAreaPolyDateValidFrom,prlAreaPolyDateValidTo FROM prlArea WHERE prlAreaPolyDateValidFrom <> '9999-12-31'

mappingId Mapping:00484:Literal:wellbore_shallow_all:wlbNamePart3
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreNamePart3 {wlbNamePart3}^^xsd:string . 
source    SELECT wlbNpdidWellbore,wlbNamePart3 FROM wellbore_shallow_all

mappingId Mapping:00485:Literal:field_production_totalt_NCS_month:prfPrdNGLNetMillSm3
target    npd:ncs/production/{prfYear}/{prfMonth} npdv:producedNGL {prfPrdNGLNetMillSm3}^^xsd:decimal . 
source    SELECT prfYear,prfMonth,prfPrdNGLNetMillSm3 FROM field_production_totalt_NCS_month

mappingId Mapping:00486:Literal:seaMultiline:seaSensorType
target    npd:survey/{seaSurveyName}/multiline npdv:sensorType {seaSensorType}^^xsd:string . 
source    SELECT seaSurveyName,seaSensorType FROM seaMultiline

mappingId Mapping:00487:Literal:field:dateSyncNPD
target    npd:field/{fldNpdidField} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT fldNpdidField,dateSyncNPD FROM field WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00488:Literal:licence:prlDateUpdated
target    npd:licence/{prlNpdidLicence} npdv:dateUpdated {prlDateUpdated}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,prlDateUpdated FROM licence WHERE prlDateUpdated <> '9999-12-31'

mappingId Mapping:00489:Literal:Trans:company:cmpLicenceLicenseeFormer
target    npd:company/{cmpNpdidCompany} npdv:isFormerLicenceLicensee "true"^^rdfs:Literal . 
source    SELECT cmpNpdidCompany FROM company WHERE cmpLicenceLicenseeFormer='Y'

mappingId Mapping:00490:Literal:Trans:company:cmpLicenceLicenseeFormer
target    npd:company/{cmpNpdidCompany} npdv:isFormerLicenceLicensee "false"^^rdfs:Literal . 
source    SELECT cmpNpdidCompany FROM company WHERE cmpLicenceLicenseeFormer='N'

mappingId Mapping:00491:Literal:licence_licensee_hst:dateSyncNPD
target    npd:licence/{prlNpdidLicence}/licensee/{cmpNpdidCompany}/history/{prlLicenseeDateValidFrom}/{prlLicenseeDateValidTo} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,cmpNpdidCompany,prlLicenseeDateValidFrom,prlLicenseeDateValidTo,dateSyncNPD FROM licence_licensee_hst WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00492:Literal:pipLine:pipCurrentPhase
target    npd:pipeline/{pipNpdidPipe} npdv:currentStatus {pipCurrentPhase} . 
source    SELECT pipNpdidPipe,pipCurrentPhase FROM pipLine

mappingId Mapping:00493:Literal:bsns_arr_area_licensee_hst:baaLicenseeInterest
target    npd:baa/{baaNpdidBsnsArrArea}/licensee/{cmpNpdidCompany}/history/{baaLicenseeDateValidFrom}/{baaLicenseeDateValidTo} npdv:licenseeInterest {baaLicenseeInterest}^^xsd:decimal . 
source    SELECT baaNpdidBsnsArrArea,cmpNpdidCompany,baaLicenseeDateValidFrom,baaLicenseeDateValidTo,baaLicenseeInterest FROM bsns_arr_area_licensee_hst

mappingId Mapping:00494:Literal:wellbore_core:wlbCoreIntervalTop
target    npd:wellbore/{wlbNpdidWellbore}/core/{wlbCoreNumber} npdv:coreIntervalTop {wlbCoreIntervalTop}^^xsd:decimal . 
source    SELECT wellbore_core_id,wlbNpdidWellbore,wlbCoreNumber,wlbCoreIntervalTop FROM wellbore_core

mappingId Mapping:00495:Literal:field_production_totalt_NCS_year:prfPrdOeNetMillSm3
target    npd:ncs/production/{prfYear} npdv:producedOilEquivalents {prfPrdOeNetMillSm3}^^xsd:decimal . 
source    SELECT prfYear,prfPrdOeNetMillSm3 FROM field_production_totalt_NCS_year

mappingId Mapping:00496:Literal:Trans:wellbore_exploration_all:wlbDiscoveryWellbore
target    npd:wellbore/{wlbNpdidWellbore} npdv:isDiscoveryWellbore "true"^^rdfs:Literal . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbDiscoveryWellbore='YES'

mappingId Mapping:00497:Literal:Trans:wellbore_exploration_all:wlbDiscoveryWellbore
target    npd:wellbore/{wlbNpdidWellbore} npdv:isDiscoveryWellbore "false"^^rdfs:Literal . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbDiscoveryWellbore='NO'

mappingId Mapping:00498:Literal:wellbore_coordinates:wlbEwDesDeg
target    npd:wellbore/{wlbNpdidWellbore}/point npdv:decimalDegreesEW {wlbEwDesDeg}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbEwDesDeg FROM wellbore_coordinates

mappingId Mapping:00499:Literal:field_activity_status_hst:fldStatusDateUpdated
target    npd:field/{fldNpdidField}/activity/{fldStatus}/history/{fldStatusFromDate}/{fldStatusToDate} npdv:dateUpdated {fldStatusDateUpdated}^^xsd:dateTime . 
source    SELECT fldNpdidField,fldStatus,fldStatusFromDate,fldStatusToDate,fldStatusDateUpdated FROM field_activity_status_hst WHERE fldStatusDateUpdated <> '9999-12-31'

mappingId Mapping:00500:Literal:discovery:dscDateFromInclInField
target    npd:discovery/{dscNpdidDiscovery} npdv:dateIncludedInField {dscDateFromInclInField}^^xsd:dateTime . 
source    SELECT dscNpdidDiscovery,dscDateFromInclInField FROM discovery WHERE dscDateFromInclInField <> '9999-12-31'

mappingId Mapping:00501:Literal:field_reserves:fldRemainingCondensate
target    npd:field/{fldNpdidField}/reserve npdv:remainingCondensate {fldRemainingCondensate}^^xsd:decimal . 
source    SELECT fldNpdidField,fldRemainingCondensate FROM field_reserves

mappingId Mapping:00502:Literal:wellbore_shallow_all:wlbEwUtm
target    npd:wellbore/{wlbNpdidWellbore} npdv:utmEW {wlbEwUtm}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbEwUtm FROM wellbore_shallow_all

mappingId Mapping:00503:Literal:seaArea:seaSourceType
target    npd:survey/{seaSurveyName}/area npdv:sourceType {seaSourceType}^^xsd:string . 
source    SELECT seaArea_id,seaSurveyName,seaSourceType FROM seaArea

mappingId Mapping:00504:Literal:wellbore_shallow_all:wlbUtmZone
target    npd:wellbore/{wlbNpdidWellbore} npdv:utmZone {wlbUtmZone}^^xsd:integer . 
source    SELECT wlbNpdidWellbore,wlbUtmZone FROM wellbore_shallow_all

mappingId Mapping:00505:Literal:discovery_reserves:dscRecoverableCondensate
target    npd:discovery/{dscNpdidDiscovery}/{dscReservesRC} npdv:recoverableCondensate {dscRecoverableCondensate}^^xsd:decimal . 
source    SELECT dscNpdidDiscovery,dscReservesRC,dscRecoverableCondensate FROM discovery_reserves

mappingId Mapping:00506:Literal:baaArea:baaAreaPolyDateValidTo
target    npd:baa/{baaNpdidBsnsArrArea}/polygon/{baaNpdidBsnsArrAreaPoly} npdv:dateBaaAreaValidTo {baaAreaPolyDateValidTo}^^xsd:dateTime . 
source    SELECT baaNpdidBsnsArrArea,baaNpdidBsnsArrAreaPoly,baaAreaPolyDateValidTo FROM baaArea WHERE baaAreaPolyDateValidTo <> '9999-12-31'

mappingId Mapping:00507:Literal:wellbore_development_all:fclNpdidFacilityDrilling
target    npd:wellbore/{wlbNpdidWellbore} npdv:drillingFacility npd:facility/{fclNpdidFacilityDrilling} . 
source    SELECT wlbNpdidWellbore,fclNpdidFacilityDrilling FROM wellbore_development_all

mappingId Mapping:00508:Literal:licence_petreg_licence_oper:dateSyncNPD
target    npd:petreg/licence/{prlNpdidLicence} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,dateSyncNPD FROM licence_petreg_licence_oper WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00509:Literal:facility_fixed:dateSyncNPD
target    npd:facility/{fclNpdidFacility} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT fclNpdidFacility,dateSyncNPD FROM facility_fixed WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00510:Literal:bsns_arr_area_licensee_hst:baaLicenseeSdfi
target    npd:baa/{baaNpdidBsnsArrArea}/licensee/{cmpNpdidCompany}/history/{baaLicenseeDateValidFrom}/{baaLicenseeDateValidTo} npdv:SDFI {baaLicenseeSdfi}^^xsd:decimal . 
source    SELECT baaNpdidBsnsArrArea,cmpNpdidCompany,baaLicenseeDateValidFrom,baaLicenseeDateValidTo,baaLicenseeSdfi FROM bsns_arr_area_licensee_hst

mappingId Mapping:00511:Literal:licence_petreg_message:dateSyncNPD
target    npd:petreg/licence/{prlNpdidLicence}/message/{ptlMessageDocumentNo} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,ptlMessageDocumentNo,dateSyncNPD FROM licence_petreg_message WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00512:Literal:wellbore_core_photo:wlbCorePhotoTitle
target    npd:wellbore/{wlbNpdidWellbore}/core/{wlbCoreNumber}/photo/{wellbore_core_photo_id}/{wlbCorePhotoTitle} npdv:corePhotoTitle {wlbCorePhotoTitle}^^xsd:string . 
source    SELECT wellbore_core_photo_id,wlbNpdidWellbore,wlbCoreNumber,wlbCorePhotoTitle FROM wellbore_core_photo

mappingId Mapping:00513:Literal:Trans:seaMultiline:seaMarketAvailable
target    npd:survey/{seaSurveyName}/multiline npdv:isMarketAvailable "true"^^rdfs:Literal . 
source    SELECT seaSurveyName FROM seaMultiline WHERE seaMarketAvailable='Ja'

mappingId Mapping:00514:Literal:Trans:seaMultiline:seaMarketAvailable
target    npd:survey/{seaSurveyName}/multiline npdv:isMarketAvailable "false"^^rdfs:Literal . 
source    SELECT seaSurveyName FROM seaMultiline WHERE seaMarketAvailable='Nei'

mappingId Mapping:00515:Literal:field_production_monthly:prfYear
target    npd:field/{prfNpdidInformationCarrier}/production/{prfYear}/{prfMonth} npdv:productionYear {prfYear}^^xsd:integer . 
source    SELECT prfNpdidInformationCarrier,prfYear,prfMonth FROM field_production_monthly

mappingId Mapping:00516:Literal:licence:prlLicensingActivityName
target    npd:licence/{prlNpdidLicence} npdv:licensingActivityName {prlLicensingActivityName}^^xsd:string . 
source    SELECT prlNpdidLicence,prlLicensingActivityName FROM licence

mappingId Mapping:00517:Literal:wellbore_document:wlbDocumentSize
target    npd:wellbore/{wlbNpdidWellbore}/document/{wellbore_document_id}/{wlbDocumentName} npdv:documentSize {wlbDocumentSize}^^xsd:decimal . 
source    SELECT wellbore_document_id,wlbNpdidWellbore,wlbDocumentName,wlbDocumentSize FROM wellbore_document

mappingId Mapping:00519:Literal:tuf_owner_hst:tufOwnerDateValidFrom
target    npd:facility/{tufNpdidTuf}/owner/{cmpNpdidCompany}/history/{tufOwnerDateValidFrom}/{tufOwnerDateValidTo} npdv:dateTUFOwnerValidFrom {tufOwnerDateValidFrom}^^xsd:dateTime . 
source    SELECT tufNpdidTuf,cmpNpdidCompany,tufOwnerDateValidFrom,tufOwnerDateValidTo FROM tuf_owner_hst WHERE tufOwnerDateValidFrom <> '9999-12-31'

mappingId Mapping:00520:Literal:Trans:company:cmpLicenceLicenseeCurrent
target    npd:company/{cmpNpdidCompany} npdv:isCurrentLicenceLicensee "true"^^rdfs:Literal . 
source    SELECT cmpNpdidCompany FROM company WHERE cmpLicenceLicenseeCurrent='Y'

mappingId Mapping:00521:Literal:Trans:company:cmpLicenceLicenseeCurrent
target    npd:company/{cmpNpdidCompany} npdv:isCurrentLicenceLicensee "false"^^rdfs:Literal . 
source    SELECT cmpNpdidCompany FROM company WHERE cmpLicenceLicenseeCurrent='N'

mappingId Mapping:00522:Literal:field_production_monthly:prfPrdOilNetMillSm3
target    npd:field/{prfNpdidInformationCarrier}/production/{prfYear}/{prfMonth} npdv:producedOil {prfPrdOilNetMillSm3}^^xsd:decimal . 
source    SELECT prfNpdidInformationCarrier,prfYear,prfMonth,prfPrdOilNetMillSm3 FROM field_production_monthly

mappingId Mapping:00523:Literal:field_production_monthly:prfPrdOeNetMillSm3
target    npd:field/{prfNpdidInformationCarrier}/production/{prfYear}/{prfMonth} npdv:producedOilEquivalents {prfPrdOeNetMillSm3}^^xsd:decimal . 
source    SELECT prfNpdidInformationCarrier,prfYear,prfMonth,prfPrdOeNetMillSm3 FROM field_production_monthly

mappingId Mapping:00524:Literal:wellbore_oil_sample:wlbOilSampleTestType
target    npd:wellbore/{wlbNpdidWellbore}/test/oilsample/{wellbore_oil_sample_id} npdv:oilSampleTestType {wlbOilSampleTestType}^^xsd:string . 
source    SELECT wellbore_oil_sample_id,wlbNpdidWellbore,wlbOilSampleTestType FROM wellbore_oil_sample

mappingId Mapping:00525:Literal:licence_task:prlTaskStatusEn
target    npd:licence/{prlNpdidLicence}/task/{prlTaskID} npdv:status {prlTaskStatusEn} . 
source    SELECT prlNpdidLicence,prlTaskID,prlTaskStatusEn FROM licence_task

mappingId Mapping:00526:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc3
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel3 isc:Campanian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc3='CAMPANIAN'

mappingId Mapping:00527:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc3
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel3 isc:Carboniferous . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc3='CARBONIFEROUS'

mappingId Mapping:00528:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc3
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel3 isc:Cretaceous . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc3='CRETACEOUS'

mappingId Mapping:00529:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc3
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel3 isc:Danian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc3='DANIAN'

mappingId Mapping:00530:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc3
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel3 isc:Devonian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc3='DEVONIAN'

mappingId Mapping:00531:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc3
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel3 isc:Mississippian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc3='EARLY CARBONIFEROUS'

mappingId Mapping:00532:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc3
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel3 isc:LowerCretaceous . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc3='EARLY CRETACEOUS'

mappingId Mapping:00533:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc3
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel3 isc:LowerJurassic . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc3='EARLY JURASSIC'

mappingId Mapping:00534:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc3
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel3 isc:Cisuralian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc3='EARLY PERMIAN'

mappingId Mapping:00535:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc3
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel3 isc:LowerTriassic . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc3='EARLY TRIASSIC'

mappingId Mapping:00536:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc3
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel3 isc:Eocene . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc3='EOCENE'

mappingId Mapping:00537:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc3
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel3 isc:Jurassic . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc3='JURASSIC'

mappingId Mapping:00538:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc3
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel3 isc:Pennsylvanian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc3='LATE CARBONIFEROUS'

mappingId Mapping:00539:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc3
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel3 isc:UpperCretaceous . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc3='LATE CRETACEOUS'

mappingId Mapping:00540:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc3
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel3 isc:UpperJurassic . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc3='LATE JURASSIC'

mappingId Mapping:00541:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc3
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel3 isc:Thanetian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc3='LATE PALEOCENE'

mappingId Mapping:00542:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc3
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel3 isc:Lopingian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc3='LATE PERMIAN'

mappingId Mapping:00543:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc3
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel3 isc:Piacenzian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc3='LATE PLIOCENE'

mappingId Mapping:00544:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc3
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel3 isc:UpperTriassic . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc3='LATE TRIASSIC'

mappingId Mapping:00545:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc3
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel3 isc:MiddleJurassic . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc3='MIDDLE JURASSIC'

mappingId Mapping:00546:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc3
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel3 isc:MiddleTriassic . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc3='MIDDLE TRIASSIC'

mappingId Mapping:00547:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc3
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel3 isc:Miocene . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc3='MIOCENE'

mappingId Mapping:00548:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc3
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel3 isc:Oligocene . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc3='OLIGOCENE'

mappingId Mapping:00549:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc3
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel3 isc:Paleocene . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc3='PALEOCENE'

mappingId Mapping:00550:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc3
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel3 isc:Permian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc3='PERMIAN'

mappingId Mapping:00551:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc3
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel3 isc:Pleistocene . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc3='PLEISTOCENE'

mappingId Mapping:00552:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc3
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel3 isc:Pliocene . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc3='PLIOCENE'

mappingId Mapping:00553:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc3
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel3 isc:Silurian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc3='SILURIAN'

mappingId Mapping:00554:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc3
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel3 isc:Triassic . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc3='TRIASSIC'

mappingId Mapping:00555:Literal:seaArea:seaSensorLength
target    npd:survey/{seaSurveyName}/area npdv:sensorLength {seaSensorLength}^^rdfs:Literal . 
source    SELECT seaArea_id,seaSurveyName,seaSensorLength FROM seaArea

mappingId Mapping:00556:Literal:wellbore_coordinates:wlbNsDecDeg
target    npd:wellbore/{wlbNpdidWellbore}/point npdv:decimalDegreesNS {wlbNsDecDeg}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbNsDecDeg FROM wellbore_coordinates

mappingId Mapping:00557:Literal:Trans:seis_acquisition:seaGeotechnical
target    npd:survey/{seaName} npdv:isGeotechnicalMeasurement "true"^^rdfs:Literal . 
source    SELECT seaName FROM seis_acquisition WHERE seaGeotechnical='Ja'

mappingId Mapping:00558:Literal:Trans:seis_acquisition:seaGeotechnical
target    npd:survey/{seaName} npdv:isGeotechnicalMeasurement "false"^^rdfs:Literal . 
source    SELECT seaName FROM seis_acquisition WHERE seaGeotechnical='Nei'

mappingId Mapping:00559:Literal:Trans:baaArea:baaAreaPolyActive
target    npd:baa/{baaNpdidBsnsArrArea}/polygon/{baaNpdidBsnsArrAreaPoly} npdv:isActive "true"^^rdfs:Literal . 
source    SELECT baaNpdidBsnsArrArea,baaNpdidBsnsArrAreaPoly FROM baaArea WHERE baaAreaPolyActive='ACTIVE'

mappingId Mapping:00560:Literal:Trans:baaArea:baaAreaPolyActive
target    npd:baa/{baaNpdidBsnsArrArea}/polygon/{baaNpdidBsnsArrAreaPoly} npdv:isActive "false"^^rdfs:Literal . 
source    SELECT baaNpdidBsnsArrArea,baaNpdidBsnsArrAreaPoly FROM baaArea WHERE baaAreaPolyActive='INACTIVE'

mappingId Mapping:00561:Literal:field_production_monthly:prfPrdGasNetBillSm3
target    npd:field/{prfNpdidInformationCarrier}/production/{prfYear}/{prfMonth} npdv:producedGas {prfPrdGasNetBillSm3}^^xsd:decimal . 
source    SELECT prfNpdidInformationCarrier,prfYear,prfMonth,prfPrdGasNetBillSm3 FROM field_production_monthly

mappingId Mapping:00562:Literal:Trans:seis_acquisition:seaSampling
target    npd:survey/{seaName} npdv:isSamplingPerformed "true"^^rdfs:Literal . 
source    SELECT seaName FROM seis_acquisition WHERE seaSampling='Ja'

mappingId Mapping:00563:Literal:Trans:seis_acquisition:seaSampling
target    npd:survey/{seaName} npdv:isSamplingPerformed "false"^^rdfs:Literal . 
source    SELECT seaName FROM seis_acquisition WHERE seaSampling='Nei'

mappingId Mapping:00564:Literal:seis_acquisition:seaName
target    npd:survey/{seaName} npdv:name {seaName} . 
source    SELECT seaName FROM seis_acquisition

mappingId Mapping:00565:Literal:company_reserves:cmpRecoverableGas
target    npd:company/{cmpNpdidCompany}/reserve/{fldNpdidField} npdv:recoverableGas {cmpRecoverableGas}^^xsd:decimal . 
source    SELECT cmpNpdidCompany,fldNpdidField,cmpRecoverableGas FROM company_reserves

mappingId Mapping:00566:Literal:discovery:dscCurrentActivityStatus
target    npd:discovery/{dscNpdidDiscovery} npdv:status {dscCurrentActivityStatus} .
source    SELECT dscNpdidDiscovery,dscCurrentActivityStatus FROM discovery

mappingId Mapping:00567:Literal:company:cmpNpdidCompany
target    npd:company/{cmpNpdidCompany} npdv:idNPD {cmpNpdidCompany}^^xsd:integer . 
source    SELECT cmpNpdidCompany FROM company

mappingId Mapping:00568:Literal:wellbore_development_all:wlbKellyBushElevation
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreKellyBushElevation {wlbKellyBushElevation}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbKellyBushElevation FROM wellbore_development_all

mappingId Mapping:00569:Literal:wellbore_development_all:wlbEwDeg
target    npd:wellbore/{wlbNpdidWellbore} npdv:degreesEW {wlbEwDeg}^^xsd:integer . 
source    SELECT wlbNpdidWellbore,wlbEwDeg FROM wellbore_development_all

mappingId Mapping:00570:Literal:wellbore_coordinates:wlbNsCode
target    npd:wellbore/{wlbNpdidWellbore}/point npdv:codeNS {wlbNsCode} . 
source    SELECT wlbNpdidWellbore,wlbNsCode FROM wellbore_coordinates

mappingId Mapping:00571:Literal:facility_fixed:fclWaterDepth
target    npd:facility/{fclNpdidFacility} npdv:waterDepth {fclWaterDepth}^^xsd:decimal . 
source    SELECT fclNpdidFacility,fclWaterDepth FROM facility_fixed

mappingId Mapping:00572:Literal:wellbore_shallow_all:wlbEwMin
target    npd:wellbore/{wlbNpdidWellbore} npdv:minutesEW {wlbEwMin}^^xsd:integer . 
source    SELECT wlbNpdidWellbore,wlbEwMin FROM wellbore_shallow_all

mappingId Mapping:00573:Literal:field_production_monthly:prfMonth
target    npd:field/{prfNpdidInformationCarrier}/production/{prfYear}/{prfMonth} npdv:productionMonth {prfMonth}^^xsd:integer . 
source    SELECT prfNpdidInformationCarrier,prfYear,prfMonth FROM field_production_monthly

mappingId Mapping:00575:Literal:strat_litho_wellbore:lsuBottomDepth
target    npd:wellbore/{wlbNpdidWellbore}/stratum/{lsuNpdidLithoStrat}/depth/{lsuTopDepth}/{lsuBottomDepth} npdv:wellboreStratumBottomDepth {lsuBottomDepth}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,lsuNpdidLithoStrat,lsuTopDepth,lsuBottomDepth FROM strat_litho_wellbore

mappingId Mapping:00576:Literal:wellbore_exploration_all:wlbEntryYear
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreEntryYear {wlbEntryYear}^^xsd:integer . 
source    SELECT wlbNpdidWellbore,wlbEntryYear FROM wellbore_exploration_all

mappingId Mapping:00577:Literal:wellbore_exploration_all:wlbNsMin
target    npd:wellbore/{wlbNpdidWellbore} npdv:minutesNS {wlbNsMin}^^xsd:integer . 
source    SELECT wlbNpdidWellbore,wlbNsMin FROM wellbore_exploration_all

mappingId Mapping:00578:Literal:bsns_arr_area:baaNpdidBsnsArrArea
target    npd:baa/{baaNpdidBsnsArrArea} npdv:idNPD {baaNpdidBsnsArrArea}^^xsd:integer . 
source    SELECT baaNpdidBsnsArrArea FROM bsns_arr_area

mappingId Mapping:00579:Literal:field_production_totalt_NCS_month:prfPrdOilNetMillSm3
target    npd:ncs/production/{prfYear}/{prfMonth} npdv:producedOil {prfPrdOilNetMillSm3}^^xsd:decimal . 
source    SELECT prfYear,prfMonth,prfPrdOilNetMillSm3 FROM field_production_totalt_NCS_month

mappingId Mapping:00580:Literal:Trans:facility_fixed:fclSurface
target    npd:facility/{fclNpdidFacility} npdv:isSurfaceFacility "true"^^rdfs:Literal . 
source    SELECT fclNpdidFacility FROM facility_fixed WHERE fclSurface='Y'

mappingId Mapping:00581:Literal:Trans:facility_fixed:fclSurface
target    npd:facility/{fclNpdidFacility} npdv:isSurfaceFacility "false"^^rdfs:Literal . 
source    SELECT fclNpdidFacility FROM facility_fixed WHERE fclSurface='N'

mappingId Mapping:00582:Literal:wellbore_development_all:wlbEwMin
target    npd:wellbore/{wlbNpdidWellbore} npdv:minutesEW {wlbEwMin}^^xsd:integer . 
source    SELECT wlbNpdidWellbore,wlbEwMin FROM wellbore_development_all

mappingId Mapping:00583:Literal:company:cmpGroup
target    npd:company/{cmpNpdidCompany} npdv:companyGroup {cmpGroup}^^xsd:string . 
source    SELECT cmpNpdidCompany,cmpGroup FROM company

mappingId Mapping:00584:Literal:wellbore_casing_and_lot:wlbCasingDateUpdated
target    npd:wellbore/{wlbNpdidWellbore}/test/casingleakoff/{wellbore_casing_and_lot_id} npdv:dateUpdated {wlbCasingDateUpdated}^^xsd:dateTime . 
source    SELECT wellbore_casing_and_lot_id,wlbNpdidWellbore,wlbCasingDateUpdated FROM wellbore_casing_and_lot WHERE wlbCasingDateUpdated <> '9999-12-31'

mappingId Mapping:00585:Literal:wellbore_development_all:wlbWellboreName
target    npd:wellbore/{wlbNpdidWellbore} npdv:name {wlbWellboreName} . 
source    SELECT wlbNpdidWellbore,wlbWellboreName FROM wellbore_development_all

mappingId Mapping:00586:Literal:wellbore_exploration_all:wlbNamePart6
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreNamePart6 {wlbNamePart6}^^xsd:string . 
source    SELECT wlbNpdidWellbore,wlbNamePart6 FROM wellbore_exploration_all

mappingId Mapping:00587:Literal:wellbore_casing_and_lot:wlbCasingType
target    npd:wellbore/{wlbNpdidWellbore}/test/casingleakoff/{wellbore_casing_and_lot_id} npdv:casingType {wlbCasingType}^^xsd:string . 
source    SELECT wellbore_casing_and_lot_id,wlbNpdidWellbore,wlbCasingType FROM wellbore_casing_and_lot

mappingId Mapping:00588:Literal:wellbore_development_all:wlbPurposePlanned
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellborePlannedPurpose {wlbPurposePlanned}^^xsd:string . 
source    SELECT wlbNpdidWellbore,wlbPurposePlanned FROM wellbore_development_all

mappingId Mapping:00589:Literal:licence_licensee_hst:prlLicenseeSdfi
target    npd:licence/{prlNpdidLicence}/licensee/{cmpNpdidCompany}/history/{prlLicenseeDateValidFrom}/{prlLicenseeDateValidTo} npdv:SDFI {prlLicenseeSdfi}^^xsd:decimal . 
source    SELECT prlNpdidLicence,cmpNpdidCompany,prlLicenseeDateValidFrom,prlLicenseeDateValidTo,prlLicenseeSdfi FROM licence_licensee_hst

mappingId Mapping:00590:Literal:wellbore_npdid_overview:wlbWellType
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreWellType {wlbWellType} . 
source    SELECT wlbNpdidWellbore,wlbWellType FROM wellbore_npdid_overview

mappingId Mapping:00591:Literal:wellbore_document:dateSyncNPD
target    npd:wellbore/{wlbNpdidWellbore}/document/{wellbore_document_id}/{wlbDocumentName} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT wellbore_document_id,wlbNpdidWellbore,wlbDocumentName,dateSyncNPD FROM wellbore_document WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00592:Literal:prlAreaSplitByBlock:prlAreaPolyToZvalue
target    npd:licence/{prlNpdidLicence}/block/{blcName}/polyno/{prlAreaPolyPolyNo}/history/{prlAreaPolyDateValidFrom}/{prlAreaPolyDateValidTo} npdv:ZValueTo {prlAreaPolyToZvalue}^^xsd:integer . 
source    SELECT prlNpdidLicence,blcName,prlAreaPolyPolyNo,prlAreaPolyDateValidFrom,prlAreaPolyDateValidTo,prlAreaPolyToZvalue FROM prlAreaSplitByBlock

mappingId Mapping:00593:Literal:Trans:wellbore_exploration_all:wlbReentry
target    npd:wellbore/{wlbNpdidWellbore} npdv:isReentryWellbore "true"^^rdfs:Literal . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbReentry='YES'

mappingId Mapping:00594:Literal:Trans:wellbore_exploration_all:wlbReentry
target    npd:wellbore/{wlbNpdidWellbore} npdv:isReentryWellbore "false"^^rdfs:Literal . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbReentry='NO'

mappingId Mapping:00595:Literal:field_production_totalt_NCS_year:prfPrdCondensateNetMillSm3
target    npd:ncs/production/{prfYear} npdv:producedCondensate {prfPrdCondensateNetMillSm3}^^xsd:decimal . 
source    SELECT prfYear,prfPrdCondensateNetMillSm3 FROM field_production_totalt_NCS_year

mappingId Mapping:00596:Literal:field_reserves:fldRemainingGas
target    npd:field/{fldNpdidField}/reserve npdv:remainingGas {fldRemainingGas}^^xsd:decimal . 
source    SELECT fldNpdidField,fldRemainingGas FROM field_reserves

mappingId Mapping:00597:Literal:facility_fixed:fclDateUpdated
target    npd:facility/{fclNpdidFacility} npdv:dateUpdated {fclDateUpdated}^^xsd:dateTime . 
source    SELECT fclNpdidFacility,fclDateUpdated FROM facility_fixed WHERE fclDateUpdated <> '9999-12-31'

mappingId Mapping:00598:Literal:field_reserves:fldRecoverableOE
target    npd:field/{fldNpdidField}/reserve npdv:recoverableOilEquivalents {fldRecoverableOE}^^xsd:decimal . 
source    SELECT fldNpdidField,fldRecoverableOE FROM field_reserves

mappingId Mapping:00599:Literal:field_production_monthly:prfPrdProducedWaterInFieldMillSm3
target    npd:field/{prfNpdidInformationCarrier}/production/{prfYear}/{prfMonth} npdv:producedWater {prfPrdProducedWaterInFieldMillSm3}^^xsd:decimal . 
source    SELECT prfNpdidInformationCarrier,prfYear,prfMonth,prfPrdProducedWaterInFieldMillSm3 FROM field_production_monthly

mappingId Mapping:00600:Literal:Trans:licence_area_poly_hst:prlAreaPolyNationCode
target    npd:licence/{prlNpdidLicence}/block/{prlAreaPolyBlockName}/polyno/{prlAreaPolyPolyNo}/history/{prlAreaPolyDateValidFrom}/{prlAreaPolyDateValidTo} npdv:country <http://dbpedia.org/resource/Norway> . 
source    SELECT prlNpdidLicence,prlAreaPolyBlockName,prlAreaPolyPolyNo,prlAreaPolyDateValidFrom,prlAreaPolyDateValidTo FROM licence_area_poly_hst WHERE prlAreaPolyNationCode='NO'

mappingId Mapping:00601:Literal:field_reserves:fldRemainingOil
target    npd:field/{fldNpdidField}/reserve npdv:remainingOil {fldRemainingOil}^^xsd:decimal . 
source    SELECT fldNpdidField,fldRemainingOil FROM field_reserves

mappingId Mapping:00602:Literal:wellbore_oil_sample:wlbOilSampleTopDepth
target    npd:wellbore/{wlbNpdidWellbore}/test/oilsample/{wellbore_oil_sample_id} npdv:oilSampleTopDepth {wlbOilSampleTopDepth}^^xsd:decimal . 
source    SELECT wellbore_oil_sample_id,wlbNpdidWellbore,wlbOilSampleTopDepth FROM wellbore_oil_sample

mappingId Mapping:00603:Literal:field_production_totalt_NCS_year:prfPrdNGLNetMillSm3
target    npd:ncs/production/{prfYear} npdv:producedNGL {prfPrdNGLNetMillSm3}^^xsd:decimal . 
source    SELECT prfYear,prfPrdNGLNetMillSm3 FROM field_production_totalt_NCS_year

mappingId Mapping:00604:Literal:field_reserves:fldRecoverableOil
target    npd:field/{fldNpdidField}/reserve npdv:recoverableOil {fldRecoverableOil}^^xsd:decimal . 
source    SELECT fldNpdidField,fldRecoverableOil FROM field_reserves

mappingId Mapping:00605:Literal:field_reserves:fldRecoverableCondensate
target    npd:field/{fldNpdidField}/reserve npdv:recoverableCondensate {fldRecoverableCondensate}^^xsd:decimal . 
source    SELECT fldNpdidField,fldRecoverableCondensate FROM field_reserves

mappingId Mapping:00606:Literal:licence_area_poly_hst:prlAreaPolyDateValidFrom
target    npd:licence/{prlNpdidLicence}/block/{prlAreaPolyBlockName}/polyno/{prlAreaPolyPolyNo}/history/{prlAreaPolyDateValidFrom}/{prlAreaPolyDateValidTo} npdv:dateLicenceAreaValidFrom {prlAreaPolyDateValidFrom}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,prlAreaPolyBlockName,prlAreaPolyPolyNo,prlAreaPolyDateValidFrom,prlAreaPolyDateValidTo FROM licence_area_poly_hst WHERE prlAreaPolyDateValidFrom <> '9999-12-31'

mappingId Mapping:00607:Literal:wellbore_core_photo:wlbCorePhotoDateUpdated
target    npd:wellbore/{wlbNpdidWellbore}/core/{wlbCoreNumber}/photo/{wellbore_core_photo_id}/{wlbCorePhotoTitle} npdv:dateUpdated {wlbCorePhotoDateUpdated}^^xsd:dateTime . 
source    SELECT wellbore_core_photo_id,wlbNpdidWellbore,wlbCoreNumber,wlbCorePhotoTitle,wlbCorePhotoDateUpdated FROM wellbore_core_photo WHERE wlbCorePhotoDateUpdated <> '9999-12-31'

mappingId Mapping:00608:Literal:wellbore_dst:wlbDstGasOilRelation
target    npd:wellbore/{wlbNpdidWellbore}/test/drillstem/{wlbDstTestNumber} npdv:DSTGasOilRelation {wlbDstGasOilRelation}^^xsd:integer . 
source    SELECT wlbNpdidWellbore,wlbDstTestNumber,wlbDstGasOilRelation FROM wellbore_dst

mappingId Mapping:00609:Literal:wellbore_development_all:wlbNpdidWellbore
target    npd:wellbore/{wlbNpdidWellbore} npdv:idNPD {wlbNpdidWellbore}^^xsd:integer . 
source    SELECT wlbNpdidWellbore FROM wellbore_development_all

mappingId Mapping:00610:Literal:wellbore_development_all:wlbContent
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreContent {wlbContent}^^xsd:string . 
source    SELECT wlbNpdidWellbore,wlbContent FROM wellbore_development_all

mappingId Mapping:00611:Literal:licence:prlFactPageUrl
target    npd:licence/{prlNpdidLicence} npdv:factPageURL {prlFactPageUrl} . 
source    SELECT prlNpdidLicence,prlFactPageUrl FROM licence

mappingId Mapping:00612:Literal:wellbore_oil_sample:wlbOilSampleFluidType
target    npd:wellbore/{wlbNpdidWellbore}/test/oilsample/{wellbore_oil_sample_id} npdv:oilSampleFluidType {wlbOilSampleFluidType}^^xsd:string . 
source    SELECT wellbore_oil_sample_id,wlbNpdidWellbore,wlbOilSampleFluidType FROM wellbore_oil_sample

mappingId Mapping:00613:Literal:tuf_petreg_licence:tufName
target    npd:petreg/facility/{tufNpdidTuf} npdv:name {tufName} . 
source    SELECT tufNpdidTuf,tufName FROM tuf_petreg_licence

mappingId Mapping:00614:Literal:bsns_arr_area_area_poly_hst:baaAreaPolyDateUpdated
target    npd:baa/{baaNpdidBsnsArrArea}/block/{baaAreaPolyBlockName}/polyno/{baaAreaPolyNo}/history/{baaAreaPolyDateValidFrom}/{baaAreaPolyDateValidTo} npdv:dateUpdated {baaAreaPolyDateUpdated}^^xsd:dateTime . 
source    SELECT baaNpdidBsnsArrArea,baaAreaPolyBlockName,baaAreaPolyNo,baaAreaPolyDateValidFrom,baaAreaPolyDateValidTo,baaAreaPolyDateUpdated FROM bsns_arr_area_area_poly_hst WHERE baaAreaPolyDateUpdated <> '9999-12-31'

mappingId Mapping:00615:Literal:seis_acquisition:seaPlanToDate
target    npd:survey/{seaName} npdv:dateSurveyPlannedCompleted {seaPlanToDate}^^xsd:dateTime . 
source    SELECT seaName,seaPlanToDate FROM seis_acquisition WHERE seaPlanToDate <> '9999-12-31'

mappingId Mapping:00616:Literal:Trans:wellbore_exploration_all:wlbMultilateral
target    npd:wellbore/{wlbNpdidWellbore} npdv:isMultilateral "true"^^rdfs:Literal . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbMultilateral='YES'

mappingId Mapping:00617:Literal:Trans:wellbore_exploration_all:wlbMultilateral
target    npd:wellbore/{wlbNpdidWellbore} npdv:isMultilateral "false"^^rdfs:Literal . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbMultilateral='NO'

mappingId Mapping:00618:Literal:Trans:prlAreaSplitByBlock:prlAreaPolyStratigraphical
target    npd:licence/{prlNpdidLicence}/block/{blcName}/polyno/{prlAreaPolyPolyNo}/history/{prlAreaPolyDateValidFrom}/{prlAreaPolyDateValidTo} npdv:isStratigraphical "true"^^rdfs:Literal . 
source    SELECT prlNpdidLicence,blcName,prlAreaPolyPolyNo,prlAreaPolyDateValidFrom,prlAreaPolyDateValidTo FROM prlAreaSplitByBlock WHERE prlAreaPolyStratigraphical='YES'

mappingId Mapping:00619:Literal:Trans:prlAreaSplitByBlock:prlAreaPolyStratigraphical
target    npd:licence/{prlNpdidLicence}/block/{blcName}/polyno/{prlAreaPolyPolyNo}/history/{prlAreaPolyDateValidFrom}/{prlAreaPolyDateValidTo} npdv:isStratigraphical "false"^^rdfs:Literal . 
source    SELECT prlNpdidLicence,blcName,prlAreaPolyPolyNo,prlAreaPolyDateValidFrom,prlAreaPolyDateValidTo FROM prlAreaSplitByBlock WHERE prlAreaPolyStratigraphical='NO'

mappingId Mapping:00620:Literal:seis_acquisition:seaDateStarting
target    npd:survey/{seaName} npdv:dateSurveyActualStart {seaDateStarting}^^xsd:dateTime . 
source    SELECT seaName,seaDateStarting FROM seis_acquisition WHERE seaDateStarting <> '9999-12-31'

mappingId Mapping:00621:Literal:wellbore_exploration_all:wlbGeodeticDatum
target    npd:wellbore/{wlbNpdidWellbore} npdv:geodeticDatum {wlbGeodeticDatum}^^xsd:string . 
source    SELECT wlbNpdidWellbore,wlbGeodeticDatum FROM wellbore_exploration_all

mappingId Mapping:00622:Literal:facility_moveable:fclKind
target    npd:facility/{fclNpdidFacility} npdv:facilityType {fclKind}^^xsd:string . 
source    SELECT fclNpdidFacility,fclKind FROM facility_moveable

mappingId Mapping:00623:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc1
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel1 isc:Campanian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc1='CAMPANIAN'

mappingId Mapping:00624:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc1
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel1 isc:Carboniferous . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc1='CARBONIFEROUS'

mappingId Mapping:00625:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc1
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel1 isc:Cretaceous . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc1='CRETACEOUS'

mappingId Mapping:00626:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc1
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel1 isc:Danian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc1='DANIAN'

mappingId Mapping:00627:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc1
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel1 isc:Devonian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc1='DEVONIAN'

mappingId Mapping:00628:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc1
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel1 isc:Mississippian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc1='EARLY CARBONIFEROUS'

mappingId Mapping:00629:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc1
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel1 isc:LowerCretaceous . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc1='EARLY CRETACEOUS'

mappingId Mapping:00630:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc1
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel1 isc:LowerJurassic . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc1='EARLY JURASSIC'

mappingId Mapping:00631:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc1
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel1 isc:Cisuralian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc1='EARLY PERMIAN'

mappingId Mapping:00632:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc1
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel1 isc:LowerTriassic . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc1='EARLY TRIASSIC'

mappingId Mapping:00633:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc1
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel1 isc:Eocene . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc1='EOCENE'

mappingId Mapping:00634:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc1
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel1 isc:Jurassic . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc1='JURASSIC'

mappingId Mapping:00635:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc1
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel1 isc:Pennsylvanian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc1='LATE CARBONIFEROUS'

mappingId Mapping:00636:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc1
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel1 isc:UpperCretaceous . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc1='LATE CRETACEOUS'

mappingId Mapping:00637:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc1
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel1 isc:UpperJurassic . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc1='LATE JURASSIC'

mappingId Mapping:00638:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc1
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel1 isc:Thanetian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc1='LATE PALEOCENE'

mappingId Mapping:00639:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc1
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel1 isc:Lopingian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc1='LATE PERMIAN'

mappingId Mapping:00640:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc1
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel1 isc:Piacenzian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc1='LATE PLIOCENE'

mappingId Mapping:00641:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc1
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel1 isc:UpperTriassic . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc1='LATE TRIASSIC'

mappingId Mapping:00642:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc1
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel1 isc:MiddleJurassic . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc1='MIDDLE JURASSIC'

mappingId Mapping:00643:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc1
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel1 isc:MiddleTriassic . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc1='MIDDLE TRIASSIC'

mappingId Mapping:00644:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc1
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel1 isc:Miocene . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc1='MIOCENE'

mappingId Mapping:00645:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc1
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel1 isc:Oligocene . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc1='OLIGOCENE'

mappingId Mapping:00646:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc1
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel1 isc:Paleocene . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc1='PALEOCENE'

mappingId Mapping:00647:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc1
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel1 isc:Permian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc1='PERMIAN'

mappingId Mapping:00648:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc1
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel1 isc:Pleistocene . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc1='PLEISTOCENE'

mappingId Mapping:00649:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc1
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel1 isc:Pliocene . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc1='PLIOCENE'

mappingId Mapping:00650:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc1
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel1 isc:Silurian . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc1='SILURIAN'

mappingId Mapping:00651:Literal:Trans:wellbore_exploration_all:wlbAgeWithHc1
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreAgeHcLevel1 isc:Triassic . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbAgeWithHc1='TRIASSIC'

mappingId Mapping:00652:Literal:wellbore_exploration_all:wlbMaxInclation
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreMaxInclation {wlbMaxInclation}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbMaxInclation FROM wellbore_exploration_all

mappingId Mapping:00653:Literal:field_production_totalt_NCS_month:prfPrdOeNetMillSm3
target    npd:ncs/production/{prfYear}/{prfMonth} npdv:producedOilEquivalents {prfPrdOeNetMillSm3}^^xsd:decimal . 
source    SELECT prfYear,prfMonth,prfPrdOeNetMillSm3 FROM field_production_totalt_NCS_month

mappingId Mapping:00654:Literal:field_production_totalt_NCS_year:prfPrdProducedWaterInFieldMillSm3
target    npd:ncs/production/{prfYear} npdv:producedWater {prfPrdProducedWaterInFieldMillSm3}^^xsd:decimal . 
source    SELECT prfYear,prfPrdProducedWaterInFieldMillSm3 FROM field_production_totalt_NCS_year


mappingId Mapping:00657:Literal:apaAreaNet:urlNPD
target    npd:quadrant/{qdrName}/block/{blkName}/award/{prvName}/area/{apaAreaNet_id} npdv:npdPageURL {urlNPD} . 
source    SELECT apaAreaNet_id,qdrName,blkName,prvName,blkId,urlNPD FROM apaAreaNet

mappingId Mapping:00658:Literal:discovery_reserves:dscRecoverableGas
target    npd:discovery/{dscNpdidDiscovery}/{dscReservesRC} npdv:recoverableGas {dscRecoverableGas}^^xsd:decimal . 
source    SELECT dscNpdidDiscovery,dscReservesRC,dscRecoverableGas FROM discovery_reserves

mappingId Mapping:00659:Literal:wellbore_development_all:wlbNamePart2
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreNamePart2 {wlbNamePart2}^^xsd:integer . 
source    SELECT wlbNpdidWellbore,wlbNamePart2 FROM wellbore_development_all

mappingId Mapping:00660:Literal:wellbore_exploration_all:wlbDrillPermit
target    npd:wellbore/{wlbNpdidWellbore} npdv:drillPermit {wlbDrillPermit}^^xsd:string . 
source    SELECT wlbNpdidWellbore,wlbDrillPermit FROM wellbore_exploration_all

mappingId Mapping:00661:Literal:wellbore_document:wlbDocumentFormat
target    npd:wellbore/{wlbNpdidWellbore}/document/{wellbore_document_id}/{wlbDocumentName} npdv:documentFormat {wlbDocumentFormat}^^xsd:string . 
source    SELECT wellbore_document_id,wlbNpdidWellbore,wlbDocumentName,wlbDocumentFormat FROM wellbore_document

mappingId Mapping:00662:Literal:licence_task:prlTaskID
target    npd:licence/{prlNpdidLicence}/task/{prlTaskID} npdv:taskID {prlTaskID}^^xsd:integer . 
source    SELECT prlNpdidLicence,prlTaskID FROM licence_task

mappingId Mapping:00663:Literal:tuf_operator_hst:tufOperDateValidFrom
target    npd:facility/{tufNpdidTuf}/operator/{cmpNpdidCompany}/history/{tufOperDateValidFrom}/{tufOperDateValidTo} npdv:dateTUFOperatorValidFrom {tufOperDateValidFrom}^^xsd:dateTime . 
source    SELECT tufNpdidTuf,cmpNpdidCompany,tufOperDateValidFrom,tufOperDateValidTo FROM tuf_operator_hst WHERE tufOperDateValidFrom <> '9999-12-31'

mappingId Mapping:00665:Literal:wellbore_exploration_all:wlbPurposePlanned
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellborePlannedPurpose {wlbPurposePlanned}^^xsd:string . 
source    SELECT wlbNpdidWellbore,wlbPurposePlanned FROM wellbore_exploration_all

mappingId Mapping:00666:Literal:bsns_arr_area_transfer_hst:baaTransferSdfi
target    npd:baa/{baaNpdidBsnsArrArea}/transfer/{baaTransferDirection}/{cmpNpdidCompany}/history/{baaTransferDateValidFrom} npdv:SDFI {baaTransferSdfi}^^xsd:decimal . 
source    SELECT baaNpdidBsnsArrArea,baaTransferDirection,cmpNpdidCompany,baaTransferDateValidFrom,baaTransferSdfi FROM bsns_arr_area_transfer_hst

mappingId Mapping:00667:Literal:bsns_arr_area_transfer_hst:baaTransferDirection
target    npd:baa/{baaNpdidBsnsArrArea}/transfer/{baaTransferDirection}/{cmpNpdidCompany}/history/{baaTransferDateValidFrom} npdv:transferDirection {baaTransferDirection}^^xsd:string . 
source    SELECT baaNpdidBsnsArrArea,baaTransferDirection,cmpNpdidCompany,baaTransferDateValidFrom FROM bsns_arr_area_transfer_hst

mappingId Mapping:00669:Literal:tuf_petreg_message:dateSyncNPD
target    npd:petreg/facility/{tufNpdidTuf}/message/{ptlMessageDocumentNo} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT tufNpdidTuf,ptlMessageDocumentNo,dateSyncNPD FROM tuf_petreg_message WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00670:Literal:wellbore_exploration_all:wlbPressReleaseUrl
target    npd:wellbore/{wlbNpdidWellbore} npdv:pressReleaseURL {wlbPressReleaseUrl} . 
source    SELECT wlbNpdidWellbore,wlbPressReleaseUrl FROM wellbore_exploration_all

mappingId Mapping:00671:Literal:discovery:dscNpdidDiscovery
target    npd:discovery/{dscNpdidDiscovery} npdv:idNPD {dscNpdidDiscovery}^^xsd:integer . 
source    SELECT dscNpdidDiscovery FROM discovery

mappingId Mapping:00672:Literal:tuf_petreg_message:ptlMessageDocumentNo
target    npd:petreg/facility/{tufNpdidTuf}/message/{ptlMessageDocumentNo} ptl:messageNo {ptlMessageDocumentNo}^^xsd:integer . 
source    SELECT tufNpdidTuf,ptlMessageDocumentNo FROM tuf_petreg_message

mappingId Mapping:00673:Literal:field_activity_status_hst:fldStatusToDate
target    npd:field/{fldNpdidField}/activity/{fldStatus}/history/{fldStatusFromDate}/{fldStatusToDate} npdv:dateStatusTo {fldStatusToDate}^^xsd:dateTime . 
source    SELECT fldNpdidField,fldStatus,fldStatusFromDate,fldStatusToDate FROM field_activity_status_hst WHERE fldStatusToDate <> '9999-12-31'

mappingId Mapping:00674:Literal:tuf_petreg_message:ptlMessageRegisteredDate
target    npd:petreg/facility/{tufNpdidTuf}/message/{ptlMessageDocumentNo} ptl:dateMessageRegistered {ptlMessageRegisteredDate}^^xsd:dateTime . 
source    SELECT tufNpdidTuf,ptlMessageDocumentNo,ptlMessageRegisteredDate FROM tuf_petreg_message WHERE ptlMessageRegisteredDate <> '9999-12-31'

mappingId Mapping:00675:Literal:field_reserves:fldNpdidField
target    npd:field/{fldNpdidField}/reserve npdv:idNPD {fldNpdidField}^^xsd:integer . 
source    SELECT fldNpdidField FROM field_reserves

mappingId Mapping:00676:Literal:wellbore_exploration_all:wlbNsDeg
target    npd:wellbore/{wlbNpdidWellbore} npdv:degreesNS {wlbNsDeg}^^xsd:integer . 
source    SELECT wlbNpdidWellbore,wlbNsDeg FROM wellbore_exploration_all

mappingId Mapping:00677:Literal:wellbore_exploration_all:wlbNsCode
target    npd:wellbore/{wlbNpdidWellbore} npdv:codeNS {wlbNsCode} . 
source    SELECT wlbNpdidWellbore,wlbNsCode FROM wellbore_exploration_all

mappingId Mapping:00678:Literal:wellbore_formation_top:lsuTopDepth
target    npd:wellbore/{wlbNpdidWellbore}/stratum/{lsuNpdidLithoStrat}/depth/{lsuTopDepth}/{lsuBottomDepth} npdv:wellboreStratumTopDepth {lsuTopDepth}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,lsuNpdidLithoStrat,lsuTopDepth,lsuBottomDepth FROM wellbore_formation_top

mappingId Mapping:00679:Literal:bsns_arr_area:baaDateValidTo
target    npd:baa/{baaNpdidBsnsArrArea} npdv:dateBaaValidTo {baaDateValidTo}^^xsd:dateTime . 
source    SELECT baaNpdidBsnsArrArea,baaDateValidTo FROM bsns_arr_area WHERE baaDateValidTo <> '9999-12-31'

mappingId Mapping:00680:Literal:field_owner_hst:fldOwnershipToDate
target    npd:field/{fldNpdidField}/owner/{fldNpdidOwner}/history/{fldOwnershipFromDate}/{fldOwnershipToDate} npdv:dateFieldOwnerTo {fldOwnershipToDate}^^xsd:dateTime . 
source    SELECT fldNpdidField,fldNpdidOwner,fldOwnershipFromDate,fldOwnershipToDate FROM field_owner_hst WHERE fldOwnershipToDate <> '9999-12-31'

mappingId Mapping:00681:Literal:licence:dateSyncNPD
target    npd:licence/{prlNpdidLicence} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,dateSyncNPD FROM licence WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00682:Literal:wellbore_development_all:wlbCompletionDate
target    npd:wellbore/{wlbNpdidWellbore} npdv:dateWellboreCompletion {wlbCompletionDate}^^xsd:dateTime . 
source    SELECT wlbNpdidWellbore,wlbCompletionDate FROM wellbore_development_all WHERE wlbCompletionDate <> '9999-12-31'

mappingId Mapping:00683:Literal:bsns_arr_area_licensee_hst:dateSyncNPD
target    npd:baa/{baaNpdidBsnsArrArea}/licensee/{cmpNpdidCompany}/history/{baaLicenseeDateValidFrom}/{baaLicenseeDateValidTo} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT baaNpdidBsnsArrArea,cmpNpdidCompany,baaLicenseeDateValidFrom,baaLicenseeDateValidTo,dateSyncNPD FROM bsns_arr_area_licensee_hst WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00684:Literal:wellbore_exploration_all:wlbNamePart2
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreNamePart2 {wlbNamePart2}^^xsd:integer . 
source    SELECT wlbNpdidWellbore,wlbNamePart2 FROM wellbore_exploration_all

mappingId Mapping:00685:Literal:company_reserves:cmpRecoverableOE
target    npd:company/{cmpNpdidCompany}/reserve/{fldNpdidField} npdv:recoverableOilEquivalents {cmpRecoverableOE}^^xsd:decimal . 
source    SELECT cmpNpdidCompany,fldNpdidField,cmpRecoverableOE FROM company_reserves

mappingId Mapping:00686:Literal:tuf_operator_hst:dateSyncNPD
target    npd:facility/{tufNpdidTuf}/operator/{cmpNpdidCompany}/history/{tufOperDateValidFrom}/{tufOperDateValidTo} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT tufNpdidTuf,cmpNpdidCompany,tufOperDateValidFrom,tufOperDateValidTo,dateSyncNPD FROM tuf_operator_hst WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00687:Literal:wellbore_shallow_all:wlbNsSec
target    npd:wellbore/{wlbNpdidWellbore} npdv:secondsNS {wlbNsSec}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbNsSec FROM wellbore_shallow_all

mappingId Mapping:00688:Literal:wellbore_exploration_all:fclNpdidFacilityDrilling
target    npd:wellbore/{wlbNpdidWellbore} npdv:drillingFacility npd:facility/{fclNpdidFacilityDrilling} . 
source    SELECT wlbNpdidWellbore,fclNpdidFacilityDrilling FROM wellbore_exploration_all

mappingId Mapping:00689:Literal:seis_acquisition_coordinates_inc_turnarea:seaPolygonEWDeg
target    npd:survey/{seaSurveyName}/point/{seaPolygonPointNumber} npdv:degreesEW {seaPolygonEWDeg}^^xsd:integer . 
source    SELECT seaSurveyName,seaPolygonPointNumber,seaPolygonEWDeg FROM seis_acquisition_coordinates_inc_turnarea

mappingId Mapping:00690:Literal:wellbore_shallow_all:wlbCompletionDate
target    npd:wellbore/{wlbNpdidWellbore} npdv:dateWellboreCompletion {wlbCompletionDate}^^xsd:dateTime . 
source    SELECT wlbNpdidWellbore,wlbCompletionDate FROM wellbore_shallow_all WHERE wlbCompletionDate <> '9999-12-31'

mappingId Mapping:00691:Literal:apaAreaNet:prvName
target    npd:quadrant/{qdrName}/block/{blkName}/award/{prvName}/area/{apaAreaNet_id} npdv:provinceLocation npd:province/{prvName} . 
source    SELECT apaAreaNet_id,qdrName,blkName,prvName,blkId FROM apaAreaNet

mappingId Mapping:00692:Literal:prlAreaSplitByBlock:prlAreaPolyDateValidTo
target    npd:licence/{prlNpdidLicence}/block/{blcName}/polyno/{prlAreaPolyPolyNo}/history/{prlAreaPolyDateValidFrom}/{prlAreaPolyDateValidTo} npdv:dateLicenceAreaValidTo {prlAreaPolyDateValidTo}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,blcName,prlAreaPolyPolyNo,prlAreaPolyDateValidFrom,prlAreaPolyDateValidTo FROM prlAreaSplitByBlock WHERE prlAreaPolyDateValidTo <> '9999-12-31'

mappingId Mapping:00693:Literal:bsns_arr_area:baaDateUpdatedMax
target    npd:baa/{baaNpdidBsnsArrArea} npdv:dateUpdatedMax {baaDateUpdatedMax}^^xsd:dateTime . 
source    SELECT baaNpdidBsnsArrArea,baaDateUpdatedMax FROM bsns_arr_area WHERE baaDateUpdatedMax <> '9999-12-31'

mappingId Mapping:00694:Literal:licence:prlNpdidLicence
target    npd:licence/{prlNpdidLicence} npdv:idNPD {prlNpdidLicence}^^xsd:integer . 
source    SELECT prlNpdidLicence FROM licence

mappingId Mapping:00695:Literal:facility_fixed:fclFactPageUrl
target    npd:facility/{fclNpdidFacility} npdv:factPageURL {fclFactPageUrl} . 
source    SELECT fclNpdidFacility,fclFactPageUrl FROM facility_fixed

mappingId Mapping:00696:Literal:wellbore_development_all:wlbEwSec
target    npd:wellbore/{wlbNpdidWellbore} npdv:secondsEW {wlbEwSec}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbEwSec FROM wellbore_development_all

mappingId Mapping:00697:Literal:licence:prlName
target    npd:licence/{prlNpdidLicence} npdv:name {prlName} . 
source    SELECT prlNpdidLicence,prlName FROM licence

mappingId Mapping:00698:Literal:wellbore_development_all:wlbEntryDate
target    npd:wellbore/{wlbNpdidWellbore} npdv:dateWellboreEntry {wlbEntryDate}^^xsd:dateTime . 
source    SELECT wlbNpdidWellbore,wlbEntryDate FROM wellbore_development_all WHERE wlbEntryDate <> '9999-12-31'

mappingId Mapping:00699:Literal:licence_task:prlTaskStatusNo
target    npd:licence/{prlNpdidLicence}/task/{prlTaskID} npdv:status {prlTaskStatusNo} . 
source    SELECT prlNpdidLicence,prlTaskID,prlTaskStatusNo FROM licence_task

mappingId Mapping:00700:Literal:licence_area_poly_hst:prlAreaPolyDateValidTo
target    npd:licence/{prlNpdidLicence}/block/{prlAreaPolyBlockName}/polyno/{prlAreaPolyPolyNo}/history/{prlAreaPolyDateValidFrom}/{prlAreaPolyDateValidTo} npdv:dateLicenceAreaValidTo {prlAreaPolyDateValidTo}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,prlAreaPolyBlockName,prlAreaPolyPolyNo,prlAreaPolyDateValidFrom,prlAreaPolyDateValidTo FROM licence_area_poly_hst WHERE prlAreaPolyDateValidTo <> '9999-12-31'

mappingId Mapping:00702:Literal:wellbore_development_all:wlbWaterDepth
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreWaterDepth {wlbWaterDepth}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbWaterDepth FROM wellbore_development_all

mappingId Mapping:00703:Literal:licence_area_poly_hst:prlAreaPolyBlockName
target    npd:licence/{prlNpdidLicence}/block/{prlAreaPolyBlockName}/polyno/{prlAreaPolyPolyNo}/history/{prlAreaPolyDateValidFrom}/{prlAreaPolyDateValidTo} npdv:blockLocation npd:block/{prlAreaPolyBlockName} . 
source    SELECT prlNpdidLicence,prlAreaPolyBlockName,prlAreaPolyPolyNo,prlAreaPolyDateValidFrom,prlAreaPolyDateValidTo FROM licence_area_poly_hst

mappingId Mapping:00704:Literal:wellbore_document:wlbDocumentUrl
target    npd:wellbore/{wlbNpdidWellbore}/document/{wellbore_document_id}/{wlbDocumentName} npdv:documentURL {wlbDocumentUrl} . 
source    SELECT wellbore_document_id,wlbNpdidWellbore,wlbDocumentName,wlbDocumentUrl FROM wellbore_document

mappingId Mapping:00705:Literal:licence_phase_hst:prlDateValidTo
target    npd:licence/{prlNpdidLicence}/phase/{prlPhase}/history/{prlDatePhaseValidFrom}/{prlDatePhaseValidTo} npdv:dateLicenceValidTo {prlDateValidTo}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,prlPhase,prlDatePhaseValidFrom,prlDatePhaseValidTo,prlDateValidTo FROM licence_phase_hst WHERE prlDateValidTo <> '9999-12-31'

mappingId Mapping:00706:Literal:licence_petreg_licence_licencee:ptlLicenseeDateUpdated
target    npd:petreg/licence/{prlNpdidLicence}/licencee/{cmpNpdidCompany} ptl:dateUpdated {ptlLicenseeDateUpdated}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,cmpNpdidCompany,ptlLicenseeDateUpdated FROM licence_petreg_licence_licencee WHERE ptlLicenseeDateUpdated <> '9999-12-31'

mappingId Mapping:00707:Literal:facility_fixed:fclNsCode
target    npd:facility/{fclNpdidFacility} npdv:codeNS {fclNsCode}^^xsd:string . 
source    SELECT fclNpdidFacility,fclNsCode FROM facility_fixed

mappingId Mapping:00708:Literal:facility_fixed:fclFactMapUrl
target    npd:facility/{fclNpdidFacility} npdv:factMapURL {fclFactMapUrl} . 
source    SELECT fclNpdidFacility,fclFactMapUrl FROM facility_fixed

mappingId Mapping:00709:Literal:tuf_owner_hst:tufOwnerShare
target    npd:facility/{tufNpdidTuf}/owner/{cmpNpdidCompany}/history/{tufOwnerDateValidFrom}/{tufOwnerDateValidTo} npdv:TUFOwnerShare {tufOwnerShare}^^xsd:decimal . 
source    SELECT tufNpdidTuf,cmpNpdidCompany,tufOwnerDateValidFrom,tufOwnerDateValidTo,tufOwnerShare FROM tuf_owner_hst

mappingId Mapping:00710:Literal:licence_area_poly_hst:prlAreaDateUpdated
target    npd:licence/{prlNpdidLicence}/block/{prlAreaPolyBlockName}/polyno/{prlAreaPolyPolyNo}/history/{prlAreaPolyDateValidFrom}/{prlAreaPolyDateValidTo} npdv:dateUpdated {prlAreaDateUpdated}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,prlAreaPolyBlockName,prlAreaPolyPolyNo,prlAreaPolyDateValidFrom,prlAreaPolyDateValidTo,prlAreaDateUpdated FROM licence_area_poly_hst WHERE prlAreaDateUpdated <> '9999-12-31'

mappingId Mapping:00711:Literal:licence_petreg_message:ptlMessageKindDesc
target    npd:petreg/licence/{prlNpdidLicence}/message/{ptlMessageDocumentNo} ptl:messageType {ptlMessageKindDesc}^^xsd:string . 
source    SELECT prlNpdidLicence,ptlMessageDocumentNo,ptlMessageKindDesc FROM licence_petreg_message

mappingId Mapping:00712:Literal:wellbore_dst:wlbDstGasProd
target    npd:wellbore/{wlbNpdidWellbore}/test/drillstem/{wlbDstTestNumber} npdv:DSTGasProducedRate {wlbDstGasProd}^^xsd:integer . 
source    SELECT wlbNpdidWellbore,wlbDstTestNumber,wlbDstGasProd FROM wellbore_dst

mappingId Mapping:00713:Literal:wellbore_npdid_overview:dateSyncNPD
target    npd:wellbore/{wlbNpdidWellbore} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT wlbNpdidWellbore,dateSyncNPD FROM wellbore_npdid_overview WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00714:Literal:prlAreaSplitByBlock:blcName
target    npd:licence/{prlNpdidLicence}/block/{blcName}/polyno/{prlAreaPolyPolyNo}/history/{prlAreaPolyDateValidFrom}/{prlAreaPolyDateValidTo} npdv:blockLocation npd:block/{blcName} . 
source    SELECT prlNpdidLicence,blcName,prlAreaPolyPolyNo,prlAreaPolyDateValidFrom,prlAreaPolyDateValidTo FROM prlAreaSplitByBlock

mappingId Mapping:00715:Literal:seaArea:seaSensorType
target    npd:survey/{seaSurveyName}/area npdv:sensorType {seaSensorType}^^xsd:string . 
source    SELECT seaArea_id,seaSurveyName,seaSensorType FROM seaArea

mappingId Mapping:00716:Literal:wellbore_exploration_all:wlbEwUtm
target    npd:wellbore/{wlbNpdidWellbore} npdv:utmEW {wlbEwUtm}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbEwUtm FROM wellbore_exploration_all

mappingId Mapping:00717:Literal:licence_petreg_message:ptlMessageDateUpdated
target    npd:petreg/licence/{prlNpdidLicence}/message/{ptlMessageDocumentNo} ptl:dateUpdated {ptlMessageDateUpdated}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,ptlMessageDocumentNo,ptlMessageDateUpdated FROM licence_petreg_message WHERE ptlMessageDateUpdated <> '9999-12-31'

mappingId Mapping:00718:Literal:Trans:seis_acquisition:seaGeographicalArea
target    npd:survey/{seaName} npdv:mainAreaLocation npd:ncs/mainarea/1 . 
source    SELECT seaName FROM seis_acquisition WHERE seaGeographicalArea='Barentshavet'

mappingId Mapping:00719:Literal:Trans:seis_acquisition:seaGeographicalArea
target    npd:survey/{seaName} npdv:mainAreaLocation npd:ncs/mainarea/2 . 
source    SELECT seaName FROM seis_acquisition WHERE seaGeographicalArea='Norskehavet'

mappingId Mapping:00720:Literal:Trans:seis_acquisition:seaGeographicalArea
target    npd:survey/{seaName} npdv:mainAreaLocation npd:ncs/mainarea/3 . 
source    SELECT seaName FROM seis_acquisition WHERE seaGeographicalArea='Nordsjøen'

mappingId Mapping:00721:Literal:wellbore_development_all:wlbNamePart4
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreNamePart4 {wlbNamePart4}^^xsd:integer . 
source    SELECT wlbNpdidWellbore,wlbNamePart4 FROM wellbore_development_all

mappingId Mapping:00722:Literal:wellbore_core:wlbCoreDateUpdated
target    npd:wellbore/{wlbNpdidWellbore}/core/{wlbCoreNumber} npdv:dateUpdated {wlbCoreDateUpdated}^^xsd:dateTime . 
source    SELECT wellbore_core_id,wlbNpdidWellbore,wlbCoreNumber,wlbCoreDateUpdated FROM wellbore_core WHERE wlbCoreDateUpdated <> '9999-12-31'

mappingId Mapping:00723:Literal:wellbore_exploration_all:wlbNsDecDeg
target    npd:wellbore/{wlbNpdidWellbore} npdv:decimalDegreesNS {wlbNsDecDeg}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbNsDecDeg FROM wellbore_exploration_all

mappingId Mapping:00724:Literal:field_investment_yearly:dateSyncNPD
target    npd:field/{prfNpdidInformationCarrier}/investment/{prfYear} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT prfNpdidInformationCarrier,prfYear,dateSyncNPD FROM field_investment_yearly WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00725:Literal:pipLine:pipDimension
target    npd:pipeline/{pipNpdidPipe} npdv:pipelineDimension {pipDimension}^^xsd:decimal . 
source    SELECT pipNpdidPipe,pipDimension FROM pipLine

mappingId Mapping:00726:Literal:Trans:wellbore_exploration_all:wlbMainArea
target    npd:wellbore/{wlbNpdidWellbore} npdv:mainAreaLocation npd:ncs/mainarea/1 . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbMainArea='Barents sea'

mappingId Mapping:00727:Literal:Trans:wellbore_exploration_all:wlbMainArea
target    npd:wellbore/{wlbNpdidWellbore} npdv:mainAreaLocation npd:ncs/mainarea/2 . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbMainArea='Norwegian sea'

mappingId Mapping:00728:Literal:Trans:wellbore_exploration_all:wlbMainArea
target    npd:wellbore/{wlbNpdidWellbore} npdv:mainAreaLocation npd:ncs/mainarea/3 . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbMainArea='North sea'

mappingId Mapping:00729:Literal:company_reserves:cmpRemainingGas
target    npd:company/{cmpNpdidCompany}/reserve/{fldNpdidField} npdv:remainingGas {cmpRemainingGas}^^xsd:decimal . 
source    SELECT cmpNpdidCompany,fldNpdidField,cmpRemainingGas FROM company_reserves

mappingId Mapping:00730:Literal:baaArea:baaAreaPolyDateValidFrom
target    npd:baa/{baaNpdidBsnsArrArea}/polygon/{baaNpdidBsnsArrAreaPoly} npdv:dateBaaAreaValidFrom {baaAreaPolyDateValidFrom}^^xsd:dateTime . 
source    SELECT baaNpdidBsnsArrArea,baaNpdidBsnsArrAreaPoly,baaAreaPolyDateValidFrom FROM baaArea WHERE baaAreaPolyDateValidFrom <> '9999-12-31'

mappingId Mapping:00731:Literal:pipLine:pipNpdidToFacility
target    npd:pipeline/{pipNpdidPipe} npdv:pipelineToFacility npd:facility/{pipNpdidToFacility} . 
source    SELECT pipNpdidPipe,pipNpdidToFacility FROM pipLine

mappingId Mapping:00732:Literal:seaMultiline:seaSourceSize
target    npd:survey/{seaSurveyName}/multiline npdv:sourceSize {seaSourceSize}^^rdfs:Literal . 
source    SELECT seaSurveyName,seaSourceSize FROM seaMultiline

mappingId Mapping:00733:Literal:wellbore_mud:wlbMudDateMeasured
target    npd:wellbore/{wlbNpdidWellbore}/test/mud/{wellbore_mud_id} npdv:dateMudMeasured {wlbMudDateMeasured}^^xsd:dateTime . 
source    SELECT wellbore_mud_id,wlbNpdidWellbore,wlbMudDateMeasured FROM wellbore_mud WHERE wlbMudDateMeasured <> '9999-12-31'

mappingId Mapping:00734:Literal:wellbore_mud:wlbYieldPointAtMD
target    npd:wellbore/{wlbNpdidWellbore}/test/mud/{wellbore_mud_id} npdv:mudYieldPoint {wlbYieldPointAtMD}^^xsd:decimal . 
source    SELECT wellbore_mud_id,wlbNpdidWellbore,wlbYieldPointAtMD FROM wellbore_mud

mappingId Mapping:00735:Literal:field_reserves:fldRecoverableNGL
target    npd:field/{fldNpdidField}/reserve npdv:recoverableNGL {fldRecoverableNGL}^^xsd:decimal . 
source    SELECT fldNpdidField,fldRecoverableNGL FROM field_reserves

mappingId Mapping:00736:Literal:facility_fixed:fclDesignLifetime
target    npd:facility/{fclNpdidFacility} npdv:designLifetime {fclDesignLifetime}^^xsd:integer . 
source    SELECT fclNpdidFacility,fclDesignLifetime FROM facility_fixed

mappingId Mapping:00737:Literal:Trans:apaAreaNet:apaAreaType
target    npd:quadrant/{qdrName}/block/{blkName}/award/{prvName}/area/{apaAreaNet_id} npdv:isStratigraphical "true"^^rdfs:Literal . 
source    SELECT apaAreaNet_id,qdrName,blkName,prvName,blkId FROM apaAreaNet WHERE apaAreaType='Stratigraphic'

mappingId Mapping:00738:Literal:Trans:apaAreaNet:apaAreaType
target    npd:quadrant/{qdrName}/block/{blkName}/award/{prvName}/area/{apaAreaNet_id} npdv:isStratigraphical "false"^^rdfs:Literal . 
source    SELECT apaAreaNet_id,qdrName,blkName,prvName,blkId FROM apaAreaNet WHERE apaAreaType='null'

mappingId Mapping:00739:Literal:tuf_petreg_licence_oper:ptlOperDateUpdated
target    npd:petreg/facility/{tufNpdidTuf} ptl:dateUpdated {ptlOperDateUpdated}^^xsd:dateTime . 
source    SELECT tufNpdidTuf,ptlOperDateUpdated FROM tuf_petreg_licence_oper WHERE ptlOperDateUpdated <> '9999-12-31'

mappingId Mapping:00740:Literal:bsns_arr_area_operator:dateSyncNPD
target    npd:baa/{baaNpdidBsnsArrArea} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT baaNpdidBsnsArrArea,dateSyncNPD FROM bsns_arr_area_operator WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00741:Literal:field_activity_status_hst:dateSyncNPD
target    npd:field/{fldNpdidField}/activity/{fldStatus}/history/{fldStatusFromDate}/{fldStatusToDate} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT fldNpdidField,fldStatus,fldStatusFromDate,fldStatusToDate,dateSyncNPD FROM field_activity_status_hst WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00742:Literal:field_activity_status_hst:fldStatusFromDate
target    npd:field/{fldNpdidField}/activity/{fldStatus}/history/{fldStatusFromDate}/{fldStatusToDate} npdv:dateStatusFrom {fldStatusFromDate}^^xsd:dateTime . 
source    SELECT fldNpdidField,fldStatus,fldStatusFromDate,fldStatusToDate FROM field_activity_status_hst WHERE fldStatusFromDate <> '9999-12-31'

mappingId Mapping:00743:Literal:strat_litho_wellbore:dateSyncNPD
target    npd:wellbore/{wlbNpdidWellbore}/stratum/{lsuNpdidLithoStrat}/depth/{lsuTopDepth}/{lsuBottomDepth} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT wlbNpdidWellbore,lsuNpdidLithoStrat,lsuTopDepth,lsuBottomDepth,dateSyncNPD FROM strat_litho_wellbore WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00744:Literal:bsns_arr_area_area_poly_hst:baaAreaPolyDateValidFrom
target    npd:baa/{baaNpdidBsnsArrArea}/block/{baaAreaPolyBlockName}/polyno/{baaAreaPolyNo}/history/{baaAreaPolyDateValidFrom}/{baaAreaPolyDateValidTo} npdv:dateBaaAreaValidFrom {baaAreaPolyDateValidFrom}^^xsd:dateTime . 
source    SELECT baaNpdidBsnsArrArea,baaAreaPolyBlockName,baaAreaPolyNo,baaAreaPolyDateValidFrom,baaAreaPolyDateValidTo FROM bsns_arr_area_area_poly_hst WHERE baaAreaPolyDateValidFrom <> '9999-12-31'

mappingId Mapping:00745:Literal:wellbore_formation_top:lsuBottomDepth
target    npd:wellbore/{wlbNpdidWellbore}/stratum/{lsuNpdidLithoStrat}/depth/{lsuTopDepth}/{lsuBottomDepth} npdv:wellboreStratumBottomDepth {lsuBottomDepth}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,lsuNpdidLithoStrat,lsuTopDepth,lsuBottomDepth FROM wellbore_formation_top

mappingId Mapping:00746:Literal:wellbore_shallow_all:wlbDateUpdated
target    npd:wellbore/{wlbNpdidWellbore} npdv:dateUpdated {wlbDateUpdated}^^xsd:dateTime . 
source    SELECT wlbNpdidWellbore,wlbDateUpdated FROM wellbore_shallow_all WHERE wlbDateUpdated <> '9999-12-31'

mappingId Mapping:00747:Literal:Trans:licence_area_poly_hst:prlAreaPolyStratigraphical
target    npd:licence/{prlNpdidLicence}/block/{prlAreaPolyBlockName}/polyno/{prlAreaPolyPolyNo}/history/{prlAreaPolyDateValidFrom}/{prlAreaPolyDateValidTo} npdv:isStratigraphical "true"^^rdfs:Literal . 
source    SELECT prlNpdidLicence,prlAreaPolyBlockName,prlAreaPolyPolyNo,prlAreaPolyDateValidFrom,prlAreaPolyDateValidTo FROM licence_area_poly_hst WHERE prlAreaPolyStratigraphical='YES'

mappingId Mapping:00748:Literal:Trans:licence_area_poly_hst:prlAreaPolyStratigraphical
target    npd:licence/{prlNpdidLicence}/block/{prlAreaPolyBlockName}/polyno/{prlAreaPolyPolyNo}/history/{prlAreaPolyDateValidFrom}/{prlAreaPolyDateValidTo} npdv:isStratigraphical "false"^^rdfs:Literal . 
source    SELECT prlNpdidLicence,prlAreaPolyBlockName,prlAreaPolyPolyNo,prlAreaPolyDateValidFrom,prlAreaPolyDateValidTo FROM licence_area_poly_hst WHERE prlAreaPolyStratigraphical='NO'

mappingId Mapping:00749:Literal:strat_litho_wellbore_core:lsuCoreLenght
target    npd:wellbore/{wlbNpdidWellbore}/stratum/{lsuNpdidLithoStrat}/cores npdv:coresTotalLength {lsuCoreLenght}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,lsuNpdidLithoStrat,lsuCoreLenght FROM strat_litho_wellbore_core

mappingId Mapping:00750:Literal:licence_petreg_licence_licencee:ptlLicenseeInterest
target    npd:petreg/licence/{prlNpdidLicence}/licencee/{cmpNpdidCompany} ptl:licenseeInterest {ptlLicenseeInterest}^^xsd:decimal . 
source    SELECT prlNpdidLicence,cmpNpdidCompany,ptlLicenseeInterest FROM licence_petreg_licence_licencee

mappingId Mapping:00751:Literal:seaMultiline:seaSourceType
target    npd:survey/{seaSurveyName}/multiline npdv:sourceType {seaSourceType}^^xsd:string . 
source    SELECT seaSurveyName,seaSourceType FROM seaMultiline

mappingId Mapping:00752:Literal:wellbore_exploration_all:dateSyncNPD
target    npd:wellbore/{wlbNpdidWellbore} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT wlbNpdidWellbore,dateSyncNPD FROM wellbore_exploration_all WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00753:Literal:seis_acquisition:seaNpdidSurvey
target    npd:survey/{seaName} npdv:idNPD {seaNpdidSurvey}^^xsd:integer . 
source    SELECT seaName,seaNpdidSurvey FROM seis_acquisition

mappingId Mapping:00754:Literal:licence_transfer_hst:prlTransferDateValidFrom
target    npd:licence/{prlNpdidLicence}/transfer/{prlTransferDirection}/{cmpNpdidCompany}/history/{prlTransferDateValidFrom} npdv:dateTransferValidFrom {prlTransferDateValidFrom}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,prlTransferDirection,cmpNpdidCompany,prlTransferDateValidFrom FROM licence_transfer_hst WHERE prlTransferDateValidFrom <> '9999-12-31'

mappingId Mapping:00755:Literal:facility_moveable:fclName
target    npd:facility/{fclNpdidFacility} npdv:name {fclName} . 
source    SELECT fclNpdidFacility,fclName FROM facility_moveable

mappingId Mapping:00756:Literal:field_licensee_hst:dateSyncNPD
target    npd:field/{fldNpdidField}/licensee/{cmpNpdidCompany}/history/{fldLicenseeFrom}/{fldLicenseeTo} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT fldNpdidField,cmpNpdidCompany,fldLicenseeFrom,fldLicenseeTo,dateSyncNPD FROM field_licensee_hst WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00757:Literal:prlAreaSplitByBlock:prlAreaPolyPolyNo
target    npd:licence/{prlNpdidLicence}/block/{blcName}/polyno/{prlAreaPolyPolyNo}/history/{prlAreaPolyDateValidFrom}/{prlAreaPolyDateValidTo} npdv:polygonNo {prlAreaPolyPolyNo}^^xsd:integer . 
source    SELECT prlNpdidLicence,blcName,prlAreaPolyPolyNo,prlAreaPolyDateValidFrom,prlAreaPolyDateValidTo FROM prlAreaSplitByBlock

mappingId Mapping:00758:Literal:licence_licensee_hst:prlLicenseeDateValidTo
target    npd:licence/{prlNpdidLicence}/licensee/{cmpNpdidCompany}/history/{prlLicenseeDateValidFrom}/{prlLicenseeDateValidTo} npdv:dateLicenseeValidTo {prlLicenseeDateValidTo}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,cmpNpdidCompany,prlLicenseeDateValidFrom,prlLicenseeDateValidTo FROM licence_licensee_hst WHERE prlLicenseeDateValidTo <> '9999-12-31'

mappingId Mapping:00759:Literal:wellbore_development_all:wlbFinalVerticalDepth
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreFinalVerticalDepth {wlbFinalVerticalDepth}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbFinalVerticalDepth FROM wellbore_development_all

mappingId Mapping:00760:Literal:wellbore_exploration_all:wlbNamePart4
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreNamePart4 {wlbNamePart4}^^xsd:integer . 
source    SELECT wlbNpdidWellbore,wlbNamePart4 FROM wellbore_exploration_all

mappingId Mapping:00761:Literal:licence_area_poly_hst:dateSyncNPD
target    npd:licence/{prlNpdidLicence}/block/{prlAreaPolyBlockName}/polyno/{prlAreaPolyPolyNo}/history/{prlAreaPolyDateValidFrom}/{prlAreaPolyDateValidTo} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,prlAreaPolyBlockName,prlAreaPolyPolyNo,prlAreaPolyDateValidFrom,prlAreaPolyDateValidTo,dateSyncNPD FROM licence_area_poly_hst WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00762:Literal:tuf_operator_hst:tufOperDateValidTo
target    npd:facility/{tufNpdidTuf}/operator/{cmpNpdidCompany}/history/{tufOperDateValidFrom}/{tufOperDateValidTo} npdv:dateTUFOperatorValidTo {tufOperDateValidTo}^^xsd:dateTime . 
source    SELECT tufNpdidTuf,cmpNpdidCompany,tufOperDateValidFrom,tufOperDateValidTo FROM tuf_operator_hst WHERE tufOperDateValidTo <> '9999-12-31'

mappingId Mapping:00763:Literal:wellbore_development_all:wlbEwDesDeg
target    npd:wellbore/{wlbNpdidWellbore} npdv:decimalDegreesEW {wlbEwDesDeg}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore,wlbEwDesDeg FROM wellbore_development_all

mappingId Mapping:00764:Literal:wellbore_shallow_all:wlbNamePart5
target    npd:wellbore/{wlbNpdidWellbore} npdv:wellboreNamePart5 {wlbNamePart5}^^xsd:string . 
source    SELECT wlbNpdidWellbore,wlbNamePart5 FROM wellbore_shallow_all

mappingId Mapping:00765:Literal:seis_acquisition_coordinates_inc_turnarea:dateSyncNPD
target    npd:survey/{seaSurveyName}/point/{seaPolygonPointNumber} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT seaSurveyName,seaPolygonPointNumber,dateSyncNPD FROM seis_acquisition_coordinates_inc_turnarea WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00766:Literal:licence_petreg_licence:ptlDateUpdatedMax
target    npd:petreg/licence/{prlNpdidLicence} ptl:dateUpdatedMax {ptlDateUpdatedMax}^^xsd:dateTime . 
source    SELECT prlNpdidLicence,ptlDateUpdatedMax FROM licence_petreg_licence WHERE ptlDateUpdatedMax <> '9999-12-31'

mappingId Mapping:00767:Literal:wellbore_casing_and_lot:wlbHoleDepth
target    npd:wellbore/{wlbNpdidWellbore}/test/casingleakoff/{wellbore_casing_and_lot_id} npdv:wellboreHoleDepth {wlbHoleDepth}^^xsd:decimal . 
source    SELECT wellbore_casing_and_lot_id,wlbNpdidWellbore,wlbHoleDepth FROM wellbore_casing_and_lot

mappingId Mapping:00768:Literal:prlArea:prlAreaPolyToZvalue
target    npd:licence/{prlNpdidLicence}/area/{prlArea_id}/history/{prlAreaPolyDateValidFrom}/{prlAreaPolyDateValidTo} npdv:ZValueTo {prlAreaPolyToZvalue}^^xsd:integer . 
source    SELECT prlArea_id,prlNpdidLicence,prlAreaPolyDateValidFrom,prlAreaPolyDateValidTo,prlAreaPolyToZvalue FROM prlArea

mappingId Mapping:00769:Literal:Extra:ex7:dateSyncNPD
target    npd:quadrant/{wlbNamePart1} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT wlbNamePart1,dateSyncNPD FROM wellbore_shallow_all WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00770:Literal:Extra:ex10:wlbNamePart1
target    npd:block/{wlbNamePart1}/{wlbNamePart2} npdv:quadrantLocation npd:quadrant/{wlbNamePart1} . 
source    SELECT wlbNamePart1,wlbNamePart2 FROM wellbore_shallow_all

mappingId Mapping:00771:Literal:Extra:ex10:dateSyncNPD
target    npd:block/{wlbNamePart1}/{wlbNamePart2} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT wlbNamePart1,wlbNamePart2,dateSyncNPD FROM wellbore_shallow_all WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00772:Literal:Extra:ex6:wlbNamePart1
target    npd:quadrant/{wlbNamePart1} npdv:name {wlbNamePart1} .
source    SELECT wlbNamePart1 FROM wellbore_exploration_all

mappingId Mapping:00773:Literal:Extra:ex12:dateSyncNPD
target    npd:facility/{tufNpdidTuf} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT tufNpdidTuf,dateSyncNPD FROM tuf_operator_hst WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00774:Literal:Extra:ex12:tufName
target    npd:facility/{tufNpdidTuf} npdv:name {tufName} . 
source    SELECT tufNpdidTuf,tufName FROM tuf_operator_hst

mappingId Mapping:00775:Literal:Extra:ex9:dateSyncNPD
target    npd:block/{wlbNamePart1}/{wlbNamePart2} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT wlbNamePart1,wlbNamePart2,dateSyncNPD FROM wellbore_exploration_all WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00776:Literal:Extra:ex13:wlbNpdidWellbore
target    npd:wellbore/{wlbNpdidWellbore}/cores npdv:coresForWellbore npd:wellbore/{wlbNpdidWellbore} . 
source    SELECT wlbNpdidWellbore FROM wellbore_core

mappingId Mapping:00777:Literal:Extra:ex11:dateSyncNPD
target    npd:facility/{tufNpdidTuf} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT tufNpdidTuf,dateSyncNPD FROM tuf_owner_hst WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00778:Literal:Extra:ex8:wlbNpdidWellbore
target    npd:block/{wlbNamePart1}/{wlbNamePart2} npdv:containsWellbore npd:wellbore/{wlbNpdidWellbore} . 
source    SELECT wlbNamePart1,wlbNamePart2,wlbNpdidWellbore FROM wellbore_development_all

mappingId Mapping:00779:Literal:Extra:ex8:wlbNamePart1
target    npd:block/{wlbNamePart1}/{wlbNamePart2} npdv:quadrantLocation npd:quadrant/{wlbNamePart1} . 
source    SELECT wlbNamePart1,wlbNamePart2 FROM wellbore_development_all

mappingId Mapping:00780:Literal:Extra:ex3:lsuLevel
target    npd:stratum/{lsuNpdidLithoStrat} npdv:stratigraphicLevel {lsuLevel} . 
source    SELECT lsuNpdidLithoStrat,lsuLevel FROM wellbore_formation_top

mappingId Mapping:00781:Literal:Extra:ex3:lsuNpdidLithoStratParent
target    npd:stratum/{lsuNpdidLithoStrat} npdv:stratigraphicParent npd:stratum/{lsuNpdidLithoStratParent} . 
source    SELECT lsuNpdidLithoStrat,lsuNpdidLithoStratParent FROM wellbore_formation_top

mappingId Mapping:00782:Literal:Extra:ex9:wlbNamePart2
target    npd:block/{wlbNamePart1}/{wlbNamePart2} npdv:name {wlbNamePart2} .
source    SELECT wlbNamePart1,wlbNamePart2 FROM wellbore_exploration_all

mappingId Mapping:00783:Literal:Extra:ex9:wlbNamePart1
target    npd:block/{wlbNamePart1}/{wlbNamePart2} npdv:quadrantLocation npd:quadrant/{wlbNamePart1} . 
source    SELECT wlbNamePart1,wlbNamePart2 FROM wellbore_exploration_all

mappingId Mapping:00784:Literal:Extra:ex5:wlbNamePart1
target    npd:quadrant/{wlbNamePart1} npdv:name {wlbNamePart1} .
source    SELECT wlbNamePart1 FROM wellbore_development_all

mappingId Mapping:00785:Literal:Extra:ex10:wlbNpdidWellbore
target    npd:block/{wlbNamePart1}/{wlbNamePart2} npdv:containsWellbore npd:wellbore/{wlbNpdidWellbore} . 
source    SELECT wlbNamePart1,wlbNamePart2,wlbNpdidWellbore FROM wellbore_shallow_all

mappingId Mapping:00786:Literal:Extra:ex5:dateSyncNPD
target    npd:quadrant/{wlbNamePart1} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT wlbNamePart1,dateSyncNPD FROM wellbore_development_all WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00787:Literal:Extra:ex3:dateSyncNPD
target    npd:stratum/{lsuNpdidLithoStrat} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT lsuNpdidLithoStrat,dateSyncNPD FROM wellbore_formation_top WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00788:Literal:Extra:ex4:dateSyncNPD
target    npd:well/{wlbWell} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT wlbWell,dateSyncNPD FROM wellbore_npdid_overview WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00789:Literal:Extra:ex3:lsuNpdidLithoStrat
target    npd:stratum/{lsuNpdidLithoStrat} npdv:idNPD {lsuNpdidLithoStrat}^^xsd:integer . 
source    SELECT lsuNpdidLithoStrat FROM wellbore_formation_top

mappingId Mapping:00791:Literal:Extra:ex4:wlbWellType
target    npd:well/{wlbWell} npdv:wellType {wlbWellType} . 
source    SELECT wlbWell,wlbWellType FROM wellbore_npdid_overview

mappingId Mapping:00792:Literal:Extra:ex9:wlbNpdidWellbore
target    npd:block/{wlbNamePart1}/{wlbNamePart2} npdv:containsWellbore npd:wellbore/{wlbNpdidWellbore} . 
source    SELECT wlbNamePart1,wlbNamePart2,wlbNpdidWellbore FROM wellbore_exploration_all

mappingId Mapping:00793:Literal:Extra:ex3:lsuName
target    npd:stratum/{lsuNpdidLithoStrat} npdv:name {lsuName} . 
source    SELECT lsuNpdidLithoStrat,lsuName FROM wellbore_formation_top

mappingId Mapping:00794:Literal:Extra:ex12:tufNpdidTuf
target    npd:facility/{tufNpdidTuf} npdv:idNPD {tufNpdidTuf}^^xsd:integer . 
source    SELECT tufNpdidTuf FROM tuf_operator_hst

mappingId Mapping:00795:Literal:Extra:ex11:tufName
target    npd:facility/{tufNpdidTuf} npdv:name {tufName} . 
source    SELECT tufNpdidTuf,tufName FROM tuf_owner_hst

mappingId Mapping:00796:Literal:Extra:ex3:lsuWellboreUpdatedDate
target    npd:stratum/{lsuNpdidLithoStrat} npdv:dateUpdated {lsuWellboreUpdatedDate}^^xsd:dateTime . 
source    SELECT lsuNpdidLithoStrat,lsuWellboreUpdatedDate FROM wellbore_formation_top WHERE lsuWellboreUpdatedDate <> '9999-12-31'

mappingId Mapping:00797:Literal:Extra:ex6:dateSyncNPD
target    npd:quadrant/{wlbNamePart1} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT wlbNamePart1,dateSyncNPD FROM wellbore_exploration_all WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00798:Literal:Extra:ex11:tufNpdidTuf
target    npd:facility/{tufNpdidTuf} npdv:idNPD {tufNpdidTuf}^^xsd:integer . 
source    SELECT tufNpdidTuf FROM tuf_owner_hst

mappingId Mapping:00799:Literal:Extra:ex4:wlbWell
target    npd:well/{wlbWell} npdv:name {wlbWell} . 
source    SELECT wlbWell FROM wellbore_npdid_overview

mappingId Mapping:00800:Literal:Extra:ex10:wlbNamePart2
target    npd:block/{wlbNamePart1}/{wlbNamePart2} npdv:name {wlbNamePart2} .
source    SELECT wlbNamePart1,wlbNamePart2 FROM wellbore_shallow_all

mappingId Mapping:00801:Literal:Extra:ex13:wlbNumberOfCores
target    npd:wellbore/{wlbNpdidWellbore}/cores npdv:coresTotalNo {wlbNumberOfCores}^^xsd:integer . 
source    SELECT wlbNpdidWellbore,wlbNumberOfCores FROM wellbore_core

mappingId Mapping:00802:Literal:Extra:ex8:wlbNamePart2
target    npd:block/{wlbNamePart1}/{wlbNamePart2} npdv:name {wlbNamePart2} .
source    SELECT wlbNamePart1,wlbNamePart2 FROM wellbore_development_all

mappingId Mapping:00803:Literal:Extra:ex8:dateSyncNPD
target    npd:block/{wlbNamePart1}/{wlbNamePart2} npdv:dateSyncNPD {dateSyncNPD}^^xsd:dateTime . 
source    SELECT wlbNamePart1,wlbNamePart2,dateSyncNPD FROM wellbore_development_all WHERE dateSyncNPD <> '9999-12-31'

mappingId Mapping:00804:Table:npdv:BAA
target    npd:baa/{baaNpdidBsnsArrArea} a npdv:BAA . 
source    SELECT baaNpdidBsnsArrArea FROM bsns_arr_area

mappingId Mapping:00805:Table:npdv:BAAArea
target    npd:baa/{baaNpdidBsnsArrArea}/block/{baaAreaPolyBlockName}/polyno/{baaAreaPolyNo}/history/{baaAreaPolyDateValidFrom}/{baaAreaPolyDateValidTo} a npdv:BAAArea . 
source    SELECT baaNpdidBsnsArrArea,baaAreaPolyBlockName,baaAreaPolyNo,baaAreaPolyDateValidFrom,baaAreaPolyDateValidTo FROM bsns_arr_area_area_poly_hst

mappingId Mapping:00806:Table:npdv:BAALicensee
target    npd:baa/{baaNpdidBsnsArrArea}/licensee/{cmpNpdidCompany}/history/{baaLicenseeDateValidFrom}/{baaLicenseeDateValidTo} a npdv:BAALicensee . 
source    SELECT baaNpdidBsnsArrArea,cmpNpdidCompany,baaLicenseeDateValidFrom,baaLicenseeDateValidTo FROM bsns_arr_area_licensee_hst

mappingId Mapping:00807:Table:npdv:BAA
target    npd:baa/{baaNpdidBsnsArrArea} a npdv:BAA . 
source    SELECT baaNpdidBsnsArrArea FROM bsns_arr_area_operator

mappingId Mapping:00808:Table:npdv:BAATransfer
target    npd:baa/{baaNpdidBsnsArrArea}/transfer/{baaTransferDirection}/{cmpNpdidCompany}/history/{baaTransferDateValidFrom} a npdv:BAATransfer . 
source    SELECT baaNpdidBsnsArrArea,baaTransferDirection,cmpNpdidCompany,baaTransferDateValidFrom FROM bsns_arr_area_transfer_hst

mappingId Mapping:00809:Table:npdv:Company
target    npd:company/{cmpNpdidCompany} a npdv:Company . 
source    SELECT cmpNpdidCompany FROM company

mappingId Mapping:00810:Table:npdv:CompanyReserve
target    npd:company/{cmpNpdidCompany}/reserve/{fldNpdidField} a npdv:CompanyReserve . 
source    SELECT cmpNpdidCompany,fldNpdidField FROM company_reserves

mappingId Mapping:00811:Table:npdv:Discovery
target    npd:discovery/{dscNpdidDiscovery} a npdv:Discovery . 
source    SELECT dscNpdidDiscovery FROM discovery

mappingId Mapping:00812:Table:npdv:DiscoveryReserve
target    npd:discovery/{dscNpdidDiscovery}/{dscReservesRC} a npdv:DiscoveryReserve . 
source    SELECT dscNpdidDiscovery,dscReservesRC FROM discovery_reserves

mappingId Mapping:00813:Table:npdv:FixedFacility
target    npd:facility/{fclNpdidFacility} a npdv:FixedFacility . 
source    SELECT fclNpdidFacility FROM facility_fixed

mappingId Mapping:00814:Table:npdv:MoveableFacility
target    npd:facility/{fclNpdidFacility} a npdv:MoveableFacility . 
source    SELECT fclNpdidFacility FROM facility_moveable

mappingId Mapping:00815:Table:npdv:Field
target    npd:field/{fldNpdidField} a npdv:Field . 
source    SELECT fldNpdidField FROM field

mappingId Mapping:00816:Table:npdv:FieldStatus
target    npd:field/{fldNpdidField}/activity/{fldStatus}/history/{fldStatusFromDate}/{fldStatusToDate} a npdv:FieldStatus . 
source    SELECT fldNpdidField,fldStatus,fldStatusFromDate,fldStatusToDate FROM field_activity_status_hst

mappingId Mapping:00817:Table:npdv:FieldInvestment
target    npd:field/{prfNpdidInformationCarrier}/investment/{prfYear} a npdv:FieldInvestment . 
source    SELECT prfNpdidInformationCarrier,prfYear FROM field_investment_yearly

mappingId Mapping:00818:Table:npdv:FieldLicensee
target    npd:field/{fldNpdidField}/licensee/{cmpNpdidCompany}/history/{fldLicenseeFrom}/{fldLicenseeTo} a npdv:FieldLicensee . 
source    SELECT fldNpdidField,cmpNpdidCompany,fldLicenseeFrom,fldLicenseeTo FROM field_licensee_hst

mappingId Mapping:00819:Table:npdv:FieldOperator
target    npd:field/{fldNpdidField}/operator/{cmpNpdidCompany}/history/{fldOperatorFrom}/{fldOperatorTo} a npdv:FieldOperator . 
source    SELECT fldNpdidField,cmpNpdidCompany,fldOperatorFrom,fldOperatorTo FROM field_operator_hst

mappingId Mapping:00820:Table:npdv:FieldOwner
target    npd:field/{fldNpdidField}/owner/{fldNpdidOwner}/history/{fldOwnershipFromDate}/{fldOwnershipToDate} a npdv:FieldOwner . 
source    SELECT fldNpdidField,fldNpdidOwner,fldOwnershipFromDate,fldOwnershipToDate FROM field_owner_hst

mappingId Mapping:00821:Table:npdv:FieldMonthlyProduction
target    npd:field/{prfNpdidInformationCarrier}/production/{prfYear}/{prfMonth} a npdv:FieldMonthlyProduction . 
source    SELECT prfNpdidInformationCarrier,prfYear,prfMonth FROM field_production_monthly

mappingId Mapping:00822:Table:npdv:NCSMonthlyProduction
target    npd:ncs/production/{prfYear}/{prfMonth} a npdv:NCSMonthlyProduction . 
source    SELECT prfYear,prfMonth FROM field_production_totalt_NCS_month

mappingId Mapping:00823:Table:npdv:NCSYearlyProduction
target    npd:ncs/production/{prfYear} a npdv:NCSYearlyProduction . 
source    SELECT prfYear FROM field_production_totalt_NCS_year

mappingId Mapping:00824:Table:npdv:FieldYearlyProduction
target    npd:field/{prfNpdidInformationCarrier}/production/{prfYear} a npdv:FieldYearlyProduction . 
source    SELECT prfNpdidInformationCarrier,prfYear FROM field_production_yearly

mappingId Mapping:00825:Table:npdv:FieldReserve
target    npd:field/{fldNpdidField}/reserve a npdv:FieldReserve . 
source    SELECT fldNpdidField FROM field_reserves

mappingId Mapping:00826:Table:npdv:ProductionLicence
target    npd:licence/{prlNpdidLicence} a npdv:ProductionLicence . 
source    SELECT prlNpdidLicence FROM licence

mappingId Mapping:00827:Table:npdv:ProductionLicenceAreaPerBlock
target    npd:licence/{prlNpdidLicence}/block/{prlAreaPolyBlockName}/polyno/{prlAreaPolyPolyNo}/history/{prlAreaPolyDateValidFrom}/{prlAreaPolyDateValidTo} a npdv:ProductionLicenceAreaPerBlock . 
source    SELECT prlNpdidLicence,prlAreaPolyBlockName,prlAreaPolyPolyNo,prlAreaPolyDateValidFrom,prlAreaPolyDateValidTo FROM licence_area_poly_hst

mappingId Mapping:00828:Table:npdv:ProductionLicenceLicensee
target    npd:licence/{prlNpdidLicence}/licensee/{cmpNpdidCompany}/history/{prlLicenseeDateValidFrom}/{prlLicenseeDateValidTo} a npdv:ProductionLicenceLicensee . 
source    SELECT prlNpdidLicence,cmpNpdidCompany,prlLicenseeDateValidFrom,prlLicenseeDateValidTo FROM licence_licensee_hst

mappingId Mapping:00829:Table:npdv:ProductionLicenceOperator
target    npd:licence/{prlNpdidLicence}/operator/{cmpNpdidCompany}/history/{prlOperDateValidFrom}/{prlOperDateValidTo} a npdv:ProductionLicenceOperator . 
source    SELECT prlNpdidLicence,cmpNpdidCompany,prlOperDateValidFrom,prlOperDateValidTo FROM licence_oper_hst

mappingId Mapping:00830:Table:ptl:ProductionLicence
target    npd:petreg/licence/{prlNpdidLicence} a ptl:ProductionLicence . 
source    SELECT prlNpdidLicence FROM licence_petreg_licence

mappingId Mapping:00831:Table:ptl:ProductionLicenceLicensee
target    npd:petreg/licence/{prlNpdidLicence}/licencee/{cmpNpdidCompany} a ptl:ProductionLicenceLicensee . 
source    SELECT prlNpdidLicence,cmpNpdidCompany FROM licence_petreg_licence_licencee

mappingId Mapping:00832:Table:ptl:ProductionLicence
target    npd:petreg/licence/{prlNpdidLicence} a ptl:ProductionLicence . 
source    SELECT prlNpdidLicence FROM licence_petreg_licence_oper

mappingId Mapping:00833:Table:ptl:ProductionLicenceNotification
target    npd:petreg/licence/{prlNpdidLicence}/message/{ptlMessageDocumentNo} a ptl:ProductionLicenceNotification . 
source    SELECT prlNpdidLicence,ptlMessageDocumentNo FROM licence_petreg_message

mappingId Mapping:00834:Table:npdv:ProductionLicenceStatus
target    npd:licence/{prlNpdidLicence}/phase/{prlPhase}/history/{prlDatePhaseValidFrom}/{prlDatePhaseValidTo} a npdv:ProductionLicenceStatus . 
source    SELECT prlNpdidLicence,prlPhase,prlDatePhaseValidFrom,prlDatePhaseValidTo FROM licence_phase_hst

mappingId Mapping:00835:Table:npdv:ProductionLicenceWorkObligation
target    npd:licence/{prlNpdidLicence}/task/{prlTaskID} a npdv:ProductionLicenceWorkObligation . 
source    SELECT prlNpdidLicence,prlTaskID FROM licence_task

mappingId Mapping:00836:Table:npdv:ProductionLicenceTransfer
target    npd:licence/{prlNpdidLicence}/transfer/{prlTransferDirection}/{cmpNpdidCompany}/history/{prlTransferDateValidFrom} a npdv:ProductionLicenceTransfer . 
source    SELECT prlNpdidLicence,prlTransferDirection,cmpNpdidCompany,prlTransferDateValidFrom FROM licence_transfer_hst

mappingId Mapping:00837:Table:npdv:SeismicSurvey
target    npd:survey/{seaName} a npdv:SeismicSurvey . 
source    SELECT seaName FROM seis_acquisition

mappingId Mapping:00838:Table:npdv:SeismicSurveyCoordinate
target    npd:survey/{seaSurveyName}/point/{seaPolygonPointNumber} a npdv:SeismicSurveyCoordinate . 
source    SELECT seaSurveyName,seaPolygonPointNumber FROM seis_acquisition_coordinates_inc_turnarea

mappingId Mapping:00839:Table:npdv:SeismicSurveyProgress
target    npd:survey/{seaProgressText2}/status/{seis_acquisition_progress_id} a npdv:SeismicSurveyProgress . 
source    SELECT seis_acquisition_progress_id,seaProgressText2 FROM seis_acquisition_progress

mappingId Mapping:00840:Table:npdv:WellboreStratigraphicCoreSet
target    npd:wellbore/{wlbNpdidWellbore}/stratum/{lsuNpdidLithoStrat}/cores a npdv:WellboreStratigraphicCoreSet . 
source    SELECT wlbNpdidWellbore,lsuNpdidLithoStrat FROM strat_litho_wellbore_core

mappingId Mapping:00841:Table:npdv:WellboreStratum
target    npd:wellbore/{wlbNpdidWellbore}/stratum/{lsuNpdidLithoStrat}/depth/{lsuTopDepth}/{lsuBottomDepth} a npdv:WellboreStratum . 
source    SELECT wlbNpdidWellbore,lsuNpdidLithoStrat,lsuTopDepth,lsuBottomDepth FROM strat_litho_wellbore

mappingId Mapping:00842:Table:npdv:TUFOperator
target    npd:facility/{tufNpdidTuf}/operator/{cmpNpdidCompany}/history/{tufOperDateValidFrom}/{tufOperDateValidTo} a npdv:TUFOperator . 
source    SELECT tufNpdidTuf,cmpNpdidCompany,tufOperDateValidFrom,tufOperDateValidTo FROM tuf_operator_hst

mappingId Mapping:00843:Table:npdv:TUFOwner
target    npd:facility/{tufNpdidTuf}/owner/{cmpNpdidCompany}/history/{tufOwnerDateValidFrom}/{tufOwnerDateValidTo} a npdv:TUFOwner . 
source    SELECT tufNpdidTuf,cmpNpdidCompany,tufOwnerDateValidFrom,tufOwnerDateValidTo FROM tuf_owner_hst

mappingId Mapping:00844:Table:ptl:TUFacility
target    npd:petreg/facility/{tufNpdidTuf} a ptl:TUFacility . 
source    SELECT tufNpdidTuf FROM tuf_petreg_licence

mappingId Mapping:00845:Table:ptl:TUFLicensee
target    npd:petreg/facility/{tufNpdidTuf}/licencee/{cmpNpdidCompany} a ptl:TUFLicensee . 
source    SELECT tufNpdidTuf,cmpNpdidCompany FROM tuf_petreg_licence_licencee

mappingId Mapping:00846:Table:ptl:TUFacility
target    npd:petreg/facility/{tufNpdidTuf} a ptl:TUFacility . 
source    SELECT tufNpdidTuf FROM tuf_petreg_licence_oper

mappingId Mapping:00847:Table:ptl:TUFNotification
target    npd:petreg/facility/{tufNpdidTuf}/message/{ptlMessageDocumentNo} a ptl:TUFNotification . 
source    SELECT tufNpdidTuf,ptlMessageDocumentNo FROM tuf_petreg_message

mappingId Mapping:00848:Table:npdv:WellboreCasingAndLeakoffTest
target    npd:wellbore/{wlbNpdidWellbore}/test/casingleakoff/{wellbore_casing_and_lot_id} a npdv:WellboreCasingAndLeakoffTest . 
source    SELECT wellbore_casing_and_lot_id,wlbNpdidWellbore FROM wellbore_casing_and_lot

mappingId Mapping:00849:Table:npdv:WellboreCoordinate
target    npd:wellbore/{wlbNpdidWellbore}/point a npdv:WellboreCoordinate . 
source    SELECT wlbNpdidWellbore FROM wellbore_coordinates

mappingId Mapping:00850:Table:npdv:WellboreCore
target    npd:wellbore/{wlbNpdidWellbore}/core/{wlbCoreNumber} a npdv:WellboreCore . 
source    SELECT wellbore_core_id,wlbNpdidWellbore,wlbCoreNumber FROM wellbore_core

mappingId Mapping:00851:Table:npdv:WellboreCorePhoto
target    npd:wellbore/{wlbNpdidWellbore}/core/{wlbCoreNumber}/photo/{wellbore_core_photo_id}/{wlbCorePhotoTitle} a npdv:WellboreCorePhoto . 
source    SELECT wellbore_core_photo_id,wlbNpdidWellbore,wlbCoreNumber,wlbCorePhotoTitle FROM wellbore_core_photo

mappingId Mapping:00852:Table:npdv:DevelopmentWellbore
target    npd:wellbore/{wlbNpdidWellbore} a npdv:DevelopmentWellbore . 
source    SELECT wlbNpdidWellbore FROM wellbore_development_all

mappingId Mapping:00853:Table:npdv:WellboreDocument
target    npd:wellbore/{wlbNpdidWellbore}/document/{wellbore_document_id}/{wlbDocumentName} a npdv:WellboreDocument . 
source    SELECT wellbore_document_id,wlbNpdidWellbore,wlbDocumentName FROM wellbore_document

mappingId Mapping:00854:Table:npdv:WellboreDrillStemTest
target    npd:wellbore/{wlbNpdidWellbore}/test/drillstem/{wlbDstTestNumber} a npdv:WellboreDrillStemTest . 
source    SELECT wlbNpdidWellbore,wlbDstTestNumber FROM wellbore_dst

mappingId Mapping:00855:Table:npdv:ExplorationWellbore
target    npd:wellbore/{wlbNpdidWellbore} a npdv:ExplorationWellbore . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all

mappingId Mapping:00856:Table:npdv:WellboreStratum
target    npd:wellbore/{wlbNpdidWellbore}/stratum/{lsuNpdidLithoStrat}/depth/{lsuTopDepth}/{lsuBottomDepth} a npdv:WellboreStratum . 
source    SELECT wlbNpdidWellbore,lsuNpdidLithoStrat,lsuTopDepth,lsuBottomDepth FROM wellbore_formation_top

mappingId Mapping:00857:Table:npdv:WellboreDrillingMudSample
target    npd:wellbore/{wlbNpdidWellbore}/test/mud/{wellbore_mud_id} a npdv:WellboreDrillingMudSample . 
source    SELECT wellbore_mud_id,wlbNpdidWellbore FROM wellbore_mud

mappingId Mapping:00858:Table:npdv:Wellbore
target    npd:wellbore/{wlbNpdidWellbore} a npdv:Wellbore . 
source    SELECT wlbNpdidWellbore FROM wellbore_npdid_overview

mappingId Mapping:00859:Table:npdv:WellboreOilSample
target    npd:wellbore/{wlbNpdidWellbore}/test/oilsample/{wellbore_oil_sample_id} a npdv:WellboreOilSample . 
source    SELECT wellbore_oil_sample_id,wlbNpdidWellbore FROM wellbore_oil_sample

mappingId Mapping:00860:Table:npdv:ShallowWellbore
target    npd:wellbore/{wlbNpdidWellbore} a npdv:ShallowWellbore . 
source    SELECT wlbNpdidWellbore FROM wellbore_shallow_all

mappingId Mapping:00861:Table:npdv:MainArea
target    npd:mainarea/{apaAreaGross_id} a npdv:MainArea . 
source    SELECT apaAreaGross_id FROM apaAreaGross

mappingId Mapping:00862:Table:npdv:AwardArea
target    npd:quadrant/{qdrName}/block/{blkName}/award/{prvName}/area/{apaAreaNet_id} a npdv:AwardArea . 
source    SELECT apaAreaNet_id,qdrName,blkName,prvName,blkId FROM apaAreaNet

mappingId Mapping:00863:Table:npdv:BAAArea
target    npd:baa/{baaNpdidBsnsArrArea}/polygon/{baaNpdidBsnsArrAreaPoly} a npdv:BAAArea . 
source    SELECT baaNpdidBsnsArrArea,baaNpdidBsnsArrAreaPoly FROM baaArea

mappingId Mapping:00864:Table:npdv:DiscoveryArea
target    npd:discovery/{dscNpdidDiscovery}/area/hctype/{dscHcType} a npdv:DiscoveryArea . 
source    SELECT dscNpdidDiscovery,dscHcType FROM dscArea

mappingId Mapping:00865:Table:npdv:FacilityPoint
target    npd:facility/{fclNpdidFacility}/point a npdv:FacilityPoint . 
source    SELECT fclNpdidFacility FROM fclPoint

mappingId Mapping:00866:Table:npdv:FieldArea
target    npd:discovery/{dscNpdidDiscovery}/area/hctype/{dscHcType} a npdv:FieldArea . 
source    SELECT dscNpdidDiscovery,dscHcType FROM fldArea

mappingId Mapping:00867:Table:npdv:Pipeline
target    npd:pipeline/{pipNpdidPipe} a npdv:Pipeline . 
source    SELECT pipNpdidPipe FROM pipLine

mappingId Mapping:00868:Table:npdv:ProductionLicenceAreaPerBlock
target    npd:licence/{prlNpdidLicence}/block/{blcName}/polyno/{prlAreaPolyPolyNo}/history/{prlAreaPolyDateValidFrom}/{prlAreaPolyDateValidTo} a npdv:ProductionLicenceAreaPerBlock . 
source    SELECT prlNpdidLicence,blcName,prlAreaPolyPolyNo,prlAreaPolyDateValidFrom,prlAreaPolyDateValidTo FROM prlAreaSplitByBlock

mappingId Mapping:00869:Table:npdv:ProductionLicenceArea
target    npd:licence/{prlNpdidLicence}/area/{prlArea_id}/history/{prlAreaPolyDateValidFrom}/{prlAreaPolyDateValidTo} a npdv:ProductionLicenceArea . 
source    SELECT prlArea_id,prlNpdidLicence,prlAreaPolyDateValidFrom,prlAreaPolyDateValidTo FROM prlArea

mappingId Mapping:00870:Table:npdv:SurveyArea
target    npd:survey/{seaSurveyName}/area a npdv:SurveyArea . 
source    SELECT seaArea_id,seaSurveyName FROM seaArea

mappingId Mapping:00871:Table:npdv:SurveyMultilineArea
target    npd:survey/{seaSurveyName}/multiline a npdv:SurveyMultilineArea . 
source    SELECT seaSurveyName FROM seaMultiline

mappingId Mapping:00872:Table:npdv:WellborePoint
target    npd:wellbore/{wlbNpdidWellbore}/point a npdv:WellborePoint . 
source    SELECT wlbNpdidWellbore FROM wlbPoint

mappingId Mapping:00873:Table:Extra:ex9:npdv:Block
target    npd:block/{wlbNamePart1}/{wlbNamePart2} a npdv:Block . 
source    SELECT wlbNamePart1,wlbNamePart2 FROM wellbore_exploration_all

mappingId Mapping:00874:Table:Extra:ex4:npdv:Well
target    npd:well/{wlbWell} a npdv:Well . 
source    SELECT wlbWell FROM wellbore_npdid_overview

mappingId Mapping:00875:Table:Extra:ex7:npdv:Quadrant
target    npd:quadrant/{wlbNamePart1} a npdv:Quadrant . 
source    SELECT wlbNamePart1 FROM wellbore_shallow_all

mappingId Mapping:00876:Table:Extra:ex13:npdv:WellboreCoreSet
target    npd:wellbore/{wlbNpdidWellbore}/cores a npdv:WellboreCoreSet . 
source    SELECT wlbNpdidWellbore FROM wellbore_core

mappingId Mapping:00877:Table:Extra:ex5:npdv:Quadrant
target    npd:quadrant/{wlbNamePart1} a npdv:Quadrant . 
source    SELECT wlbNamePart1 FROM wellbore_development_all

mappingId Mapping:00878:Table:Extra:ex6:npdv:Quadrant
target    npd:quadrant/{wlbNamePart1} a npdv:Quadrant . 
source    SELECT wlbNamePart1 FROM wellbore_exploration_all

mappingId Mapping:00879:Table:Extra:ex11:npdv:TUFacility
target    npd:facility/{tufNpdidTuf} a npdv:TUFacility . 
source    SELECT tufNpdidTuf FROM tuf_owner_hst

mappingId Mapping:00880:Table:Extra:ex3:npdv:LithostratigraphicUnit
target    npd:stratum/{lsuNpdidLithoStrat} a npdv:LithostratigraphicUnit . 
source    SELECT lsuNpdidLithoStrat FROM wellbore_formation_top

mappingId Mapping:00881:Table:Extra:ex12:npdv:TUFacility
target    npd:facility/{tufNpdidTuf} a npdv:TUFacility . 
source    SELECT tufNpdidTuf FROM tuf_operator_hst

mappingId Mapping:00882:Table:Extra:ex8:npdv:Block
target    npd:block/{wlbNamePart1}/{wlbNamePart2} a npdv:Block . 
source    SELECT wlbNamePart1,wlbNamePart2 FROM wellbore_development_all

mappingId Mapping:00883:Table:Extra:ex10:npdv:Block
target    npd:block/{wlbNamePart1}/{wlbNamePart2} a npdv:Block . 
source    SELECT wlbNamePart1,wlbNamePart2 FROM wellbore_shallow_all

mappingId Mapping:00884:ForeignKey
target    npd:wellbore/{wellbore_development_all.wlbNpdidWellbore} npdv:developmentWellboreForLicence npd:licence/{licence.prlNpdidLicence} . 
source    SELECT wellbore_development_all.wlbNpdidWellbore, licence.prlNpdidLicence FROM wellbore_development_all INNER JOIN licence ON wellbore_development_all.prlNpdidProductionLicence = licence.prlNpdidLicence

mappingId Mapping:00885:ForeignKey
target    npd:licence/{prlAreaSplitByBlock.prlNpdidLicence}/block/{prlAreaSplitByBlock.blcName}/polyno/{prlAreaSplitByBlock.prlAreaPolyPolyNo}/history/{prlAreaSplitByBlock.prlAreaPolyDateValidFrom}/{prlAreaSplitByBlock.prlAreaPolyDateValidTo} npdv:lastOperatorCompany npd:company/{company.cmpNpdidCompany} . 
source    SELECT prlAreaSplitByBlock.prlNpdidLicence, prlAreaSplitByBlock.blcName, prlAreaSplitByBlock.prlAreaPolyPolyNo, prlAreaSplitByBlock.prlAreaPolyDateValidFrom, prlAreaSplitByBlock.prlAreaPolyDateValidTo, company.cmpNpdidCompany FROM prlAreaSplitByBlock INNER JOIN company ON prlAreaSplitByBlock.prlLastOperatorNpdidCompany = company.cmpNpdidCompany

mappingId Mapping:00886:ForeignKey
target    npd:licence/{licence_transfer_hst.prlNpdidLicence}/transfer/{licence_transfer_hst.prlTransferDirection}/{licence_transfer_hst.cmpNpdidCompany}/history/{licence_transfer_hst.prlTransferDateValidFrom} npdv:transferredLicence npd:licence/{licence.prlNpdidLicence} . 
source    SELECT licence_transfer_hst.prlNpdidLicence, licence_transfer_hst.prlTransferDirection, licence_transfer_hst.cmpNpdidCompany, licence_transfer_hst.prlTransferDateValidFrom, licence.prlNpdidLicence FROM licence_transfer_hst INNER JOIN licence ON licence_transfer_hst.prlNpdidLicence = licence.prlNpdidLicence

mappingId Mapping:00887:ForeignKey
target    npd:wellbore/{wellbore_development_all.wlbNpdidWellbore} npdv:drillingOperatorCompany npd:company/{company.cmpNpdidCompany} . 
source    SELECT wellbore_development_all.wlbNpdidWellbore, company.cmpNpdidCompany FROM wellbore_development_all INNER JOIN company ON wellbore_development_all.wlbDrillingOperator = company.cmpLongName

mappingId Mapping:00888:ForeignKey
target    npd:petreg/facility/{tuf_petreg_licence_oper.tufNpdidTuf} ptl:TUFOperatorCompany npd:company/{company.cmpNpdidCompany} . 
source    SELECT tuf_petreg_licence_oper.tufNpdidTuf, company.cmpNpdidCompany FROM tuf_petreg_licence_oper INNER JOIN company ON tuf_petreg_licence_oper.cmpNpdidCompany = company.cmpNpdidCompany

mappingId Mapping:00889:ForeignKey
target    npd:pipeline/{pipLine.pipNpdidPipe} npdv:pipelineOperator npd:company/{company.cmpNpdidCompany} . 
source    SELECT pipLine.pipNpdidPipe, company.cmpNpdidCompany FROM pipLine INNER JOIN company ON pipLine.pipNpdidOperator = company.cmpNpdidCompany

mappingId Mapping:00890:ForeignKey
target    npd:wellbore/{wellbore_exploration_all.wlbNpdidWellbore} npdv:explorationWellboreForField npd:field/{field.fldNpdidField} . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, field.fldNpdidField FROM wellbore_exploration_all INNER JOIN field ON wellbore_exploration_all.fldNpdidField = field.fldNpdidField

mappingId Mapping:00891:ForeignKey
target    npd:wellbore/{wellbore_dst.wlbNpdidWellbore}/test/drillstem/{wellbore_dst.wlbDstTestNumber} npdv:DSTForWellbore npd:wellbore/{wellbore_npdid_overview.wlbNpdidWellbore} . 
source    SELECT wellbore_dst.wlbNpdidWellbore, wellbore_dst.wlbDstTestNumber, wellbore_npdid_overview.wlbNpdidWellbore FROM wellbore_dst INNER JOIN wellbore_npdid_overview ON wellbore_dst.wlbNpdidWellbore = wellbore_npdid_overview.wlbNpdidWellbore

mappingId Mapping:00892:ForeignKey
target    npd:wellbore/{wellbore_development_all.wlbNpdidWellbore} npdv:wellboreForDiscovery npd:discovery/{discovery.dscNpdidDiscovery} . 
source    SELECT wellbore_development_all.wlbNpdidWellbore, discovery.dscNpdidDiscovery FROM wellbore_development_all INNER JOIN discovery ON wellbore_development_all.dscNpdidDiscovery = discovery.dscNpdidDiscovery

mappingId Mapping:00893:ForeignKey
target    npd:discovery/{dscArea.dscNpdidDiscovery}/area/hctype/{dscArea.dscHcType} npdv:resourcesIncludedInDiscovery npd:discovery/{discovery.dscNpdidDiscovery} . 
source    SELECT dscArea.dscNpdidDiscovery, dscArea.dscHcType, discovery.dscNpdidDiscovery FROM dscArea INNER JOIN discovery ON dscArea.dscNpdidResInclInDiscovery = discovery.dscNpdidDiscovery

mappingId Mapping:00894:ForeignKey
target    npd:baa/{bsns_arr_area_transfer_hst.baaNpdidBsnsArrArea}/transfer/{bsns_arr_area_transfer_hst.baaTransferDirection}/{bsns_arr_area_transfer_hst.cmpNpdidCompany}/history/{bsns_arr_area_transfer_hst.baaTransferDateValidFrom} npdv:baaTransferCompany npd:company/{company.cmpNpdidCompany} . 
source    SELECT bsns_arr_area_transfer_hst.baaNpdidBsnsArrArea, bsns_arr_area_transfer_hst.baaTransferDirection, bsns_arr_area_transfer_hst.cmpNpdidCompany, bsns_arr_area_transfer_hst.baaTransferDateValidFrom, company.cmpNpdidCompany FROM bsns_arr_area_transfer_hst INNER JOIN company ON bsns_arr_area_transfer_hst.cmpNpdidCompany = company.cmpNpdidCompany

mappingId Mapping:00895:ForeignKey
target    npd:discovery/{fldArea.dscNpdidDiscovery}/area/hctype/{fldArea.dscHcType} npdv:isGeometryOfFeature npd:discovery/{discovery.dscNpdidDiscovery} . 
source    SELECT fldArea.dscNpdidDiscovery, fldArea.dscHcType, discovery.dscNpdidDiscovery FROM fldArea INNER JOIN discovery ON fldArea.dscNpdidDiscovery = discovery.dscNpdidDiscovery

mappingId Mapping:00896:ForeignKey
target    npd:company/{company_reserves.cmpNpdidCompany}/reserve/{company_reserves.fldNpdidField} npdv:reservesForCompany npd:company/{company.cmpNpdidCompany} . 
source    SELECT company_reserves.cmpNpdidCompany, company_reserves.fldNpdidField, company.cmpNpdidCompany FROM company_reserves INNER JOIN company ON company_reserves.cmpNpdidCompany = company.cmpNpdidCompany

mappingId Mapping:00897:ForeignKey
target    npd:field/{field.fldNpdidField} npdv:currentFieldOwner npd:licence/{licence.prlNpdidLicence} . 
source    SELECT field.fldNpdidField, licence.prlNpdidLicence FROM field INNER JOIN licence ON field.fldNpdidOwner = licence.prlNpdidLicence

mappingId Mapping:00898:ForeignKey
target    npd:wellbore/{wellbore_development_all.wlbNpdidWellbore} npdv:developmentWellboreForLicence npd:licence/{licence.prlNpdidLicence} . 
source    SELECT wellbore_development_all.wlbNpdidWellbore, licence.prlNpdidLicence FROM wellbore_development_all INNER JOIN licence ON wellbore_development_all.wlbProductionLicence = licence.prlName

mappingId Mapping:00899:ForeignKey
target    npd:wellbore/{wellbore_casing_and_lot.wlbNpdidWellbore}/test/casingleakoff/{wellbore_casing_and_lot.wellbore_casing_and_lot_id} npdv:LOTForWellbore npd:wellbore/{wellbore_npdid_overview.wlbNpdidWellbore} . 
source    SELECT wellbore_casing_and_lot.wellbore_casing_and_lot_id, wellbore_casing_and_lot.wlbNpdidWellbore, wellbore_npdid_overview.wlbNpdidWellbore FROM wellbore_casing_and_lot INNER JOIN wellbore_npdid_overview ON wellbore_casing_and_lot.wlbNpdidWellbore = wellbore_npdid_overview.wlbNpdidWellbore

mappingId Mapping:00900:ForeignKey
target    npd:field/{field_investment_yearly.prfNpdidInformationCarrier}/investment/{field_investment_yearly.prfYear} npdv:investmentForField npd:field/{field.fldNpdidField} . 
source    SELECT field_investment_yearly.prfNpdidInformationCarrier, field_investment_yearly.prfYear, field.fldNpdidField FROM field_investment_yearly INNER JOIN field ON field_investment_yearly.prfNpdidInformationCarrier = field.fldNpdidField

mappingId Mapping:00901:ForeignKey
target    npd:field/{field_operator_hst.fldNpdidField}/operator/{field_operator_hst.cmpNpdidCompany}/history/{field_operator_hst.fldOperatorFrom}/{field_operator_hst.fldOperatorTo} npdv:fieldOperator npd:company/{company.cmpNpdidCompany} . 
source    SELECT field_operator_hst.fldNpdidField, field_operator_hst.cmpNpdidCompany, field_operator_hst.fldOperatorFrom, field_operator_hst.fldOperatorTo, company.cmpNpdidCompany FROM field_operator_hst INNER JOIN company ON field_operator_hst.cmpNpdidCompany = company.cmpNpdidCompany

mappingId Mapping:00902:ForeignKey
target    npd:licence/{prlArea.prlNpdidLicence}/area/{prlArea.prlArea_id}/history/{prlArea.prlAreaPolyDateValidFrom}/{prlArea.prlAreaPolyDateValidTo} npdv:lastOperatorCompany npd:company/{company.cmpNpdidCompany} . 
source    SELECT prlArea.prlArea_id, prlArea.prlNpdidLicence, prlArea.prlAreaPolyDateValidFrom, prlArea.prlAreaPolyDateValidTo, company.cmpNpdidCompany FROM prlArea INNER JOIN company ON prlArea.prlLastOperatorNpdidCompany = company.cmpNpdidCompany

mappingId Mapping:00903:ForeignKey
target    npd:wellbore/{wellbore_development_all.wlbNpdidWellbore} npdv:developmentWellboreForField npd:field/{field.fldNpdidField} . 
source    SELECT wellbore_development_all.wlbNpdidWellbore, field.fldNpdidField FROM wellbore_development_all INNER JOIN field ON wellbore_development_all.fldNpdidField = field.fldNpdidField

mappingId Mapping:00904:ForeignKey
target    npd:licence/{licence_phase_hst.prlNpdidLicence}/phase/{licence_phase_hst.prlPhase}/history/{licence_phase_hst.prlDatePhaseValidFrom}/{licence_phase_hst.prlDatePhaseValidTo} npdv:statusForLicence npd:licence/{licence.prlNpdidLicence} . 
source    SELECT licence_phase_hst.prlNpdidLicence, licence_phase_hst.prlPhase, licence_phase_hst.prlDatePhaseValidFrom, licence_phase_hst.prlDatePhaseValidTo, licence.prlNpdidLicence FROM licence_phase_hst INNER JOIN licence ON licence_phase_hst.prlNpdidLicence = licence.prlNpdidLicence

mappingId Mapping:00905:ForeignKey
target    npd:survey/{seis_acquisition_progress.seaProgressText2}/status/{seis_acquisition_progress.seis_acquisition_progress_id} npdv:statusForSurvey npd:survey/{seis_acquisition.seaName} . 
source    SELECT seis_acquisition_progress.seis_acquisition_progress_id, seis_acquisition_progress.seaProgressText2, seis_acquisition.seaName FROM seis_acquisition_progress INNER JOIN seis_acquisition ON seis_acquisition_progress.seaNpdidSurvey = seis_acquisition.seaNpdidSurvey

mappingId Mapping:00906:ForeignKey
target    npd:survey/{seaMultiline.seaSurveyName}/multiline npdv:isGeometryOfFeature npd:survey/{seis_acquisition.seaName} . 
source    SELECT seaMultiline.seaSurveyName, seis_acquisition.seaName FROM seaMultiline INNER JOIN seis_acquisition ON seaMultiline.seaSurveyName = seis_acquisition.seaName

mappingId Mapping:00907:ForeignKey
target    npd:facility/{tuf_owner_hst.tufNpdidTuf}/owner/{tuf_owner_hst.cmpNpdidCompany}/history/{tuf_owner_hst.tufOwnerDateValidFrom}/{tuf_owner_hst.tufOwnerDateValidTo} ptl:TUFOwnerCompany npd:company/{company.cmpNpdidCompany} . 
source    SELECT tuf_owner_hst.tufNpdidTuf, tuf_owner_hst.cmpNpdidCompany, tuf_owner_hst.tufOwnerDateValidFrom, tuf_owner_hst.tufOwnerDateValidTo, company.cmpNpdidCompany FROM tuf_owner_hst INNER JOIN company ON tuf_owner_hst.cmpNpdidCompany = company.cmpNpdidCompany

mappingId Mapping:00908:ForeignKey
target    npd:field/{field_owner_hst.fldNpdidField}/owner/{field_owner_hst.fldNpdidOwner}/history/{field_owner_hst.fldOwnershipFromDate}/{field_owner_hst.fldOwnershipToDate} npdv:ownerForField npd:field/{field.fldNpdidField} . 
source    SELECT field_owner_hst.fldNpdidField, field_owner_hst.fldNpdidOwner, field_owner_hst.fldOwnershipFromDate, field_owner_hst.fldOwnershipToDate, field.fldNpdidField FROM field_owner_hst INNER JOIN field ON field_owner_hst.fldNpdidField = field.fldNpdidField

mappingId Mapping:00909:ForeignKey
target    npd:field/{field.fldNpdidField} npdv:currentFieldOperator npd:company/{company.cmpNpdidCompany} . 
source    SELECT field.fldNpdidField, company.cmpNpdidCompany FROM field INNER JOIN company ON field.cmpNpdidCompany = company.cmpNpdidCompany

mappingId Mapping:00910:ForeignKey
target    npd:survey/{seaArea.seaSurveyName}/area npdv:isGeometryOfFeature npd:survey/{seis_acquisition.seaName} . 
source    SELECT seaArea.seaArea_id, seaArea.seaSurveyName, seis_acquisition.seaName FROM seaArea INNER JOIN seis_acquisition ON seaArea.seaNpdidSurvey = seis_acquisition.seaNpdidSurvey

mappingId Mapping:00911:ForeignKey
target    npd:wellbore/{wellbore_exploration_all.wlbNpdidWellbore} npdv:wellOperator npd:company/{company.cmpNpdidCompany} . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, company.cmpNpdidCompany FROM wellbore_exploration_all INNER JOIN company ON wellbore_exploration_all.wlbDiskosWellOperator = company.cmpShortName

mappingId Mapping:00912:ForeignKey
target    npd:wellbore/{wellbore_mud.wlbNpdidWellbore}/test/mud/{wellbore_mud.wellbore_mud_id} npdv:mudTestForWellbore npd:wellbore/{wellbore_npdid_overview.wlbNpdidWellbore} . 
source    SELECT wellbore_mud.wellbore_mud_id, wellbore_mud.wlbNpdidWellbore, wellbore_npdid_overview.wlbNpdidWellbore FROM wellbore_mud INNER JOIN wellbore_npdid_overview ON wellbore_mud.wlbNpdidWellbore = wellbore_npdid_overview.wlbNpdidWellbore

mappingId Mapping:00913:ForeignKey
target    npd:discovery/{fldArea.dscNpdidDiscovery}/area/hctype/{fldArea.dscHcType} npdv:resourcesIncludedInDiscovery npd:discovery/{discovery.dscNpdidDiscovery} . 
source    SELECT fldArea.dscNpdidDiscovery, fldArea.dscHcType, discovery.dscNpdidDiscovery FROM fldArea INNER JOIN discovery ON fldArea.dscNpdidResInclInDiscovery = discovery.dscNpdidDiscovery

mappingId Mapping:00914:ForeignKey
target    npd:field/{field_operator_hst.fldNpdidField}/operator/{field_operator_hst.cmpNpdidCompany}/history/{field_operator_hst.fldOperatorFrom}/{field_operator_hst.fldOperatorTo} npdv:operatorForField npd:field/{field.fldNpdidField} . 
source    SELECT field_operator_hst.fldNpdidField, field_operator_hst.cmpNpdidCompany, field_operator_hst.fldOperatorFrom, field_operator_hst.fldOperatorTo, field.fldNpdidField FROM field_operator_hst INNER JOIN field ON field_operator_hst.fldNpdidField = field.fldNpdidField

mappingId Mapping:00915:ForeignKey
target    npd:facility/{tuf_operator_hst.tufNpdidTuf}/operator/{tuf_operator_hst.cmpNpdidCompany}/history/{tuf_operator_hst.tufOperDateValidFrom}/{tuf_operator_hst.tufOperDateValidTo} ptl:TUFOperatorForLicence npd:petreg/facility/{tuf_petreg_licence.tufNpdidTuf} . 
source    SELECT tuf_operator_hst.tufNpdidTuf, tuf_operator_hst.cmpNpdidCompany, tuf_operator_hst.tufOperDateValidFrom, tuf_operator_hst.tufOperDateValidTo, tuf_petreg_licence.tufNpdidTuf FROM tuf_operator_hst INNER JOIN tuf_petreg_licence ON tuf_operator_hst.tufNpdidTuf = tuf_petreg_licence.tufNpdidTuf

mappingId Mapping:00916:ForeignKey
target    npd:wellbore/{wellbore_core.wlbNpdidWellbore}/core/{wellbore_core.wlbCoreNumber} npdv:coreForWellbore npd:wellbore/{wellbore_npdid_overview.wlbNpdidWellbore} . 
source    SELECT wellbore_core.wellbore_core_id, wellbore_core.wlbNpdidWellbore, wellbore_core.wlbCoreNumber, wellbore_npdid_overview.wlbNpdidWellbore FROM wellbore_core INNER JOIN wellbore_npdid_overview ON wellbore_core.wlbNpdidWellbore = wellbore_npdid_overview.wlbNpdidWellbore

mappingId Mapping:00917:ForeignKey
target    npd:wellbore/{wellbore_development_all.wlbNpdidWellbore} npdv:wellOperator npd:company/{company.cmpNpdidCompany} . 
source    SELECT wellbore_development_all.wlbNpdidWellbore, company.cmpNpdidCompany FROM wellbore_development_all INNER JOIN company ON wellbore_development_all.wlbDiskosWellOperator = company.cmpShortName

mappingId Mapping:00918:ForeignKey
target    npd:licence/{licence_task.prlNpdidLicence}/task/{licence_task.prlTaskID} npdv:taskForCompany npd:company/{company.cmpNpdidCompany} . 
source    SELECT licence_task.prlNpdidLicence, licence_task.prlTaskID, company.cmpNpdidCompany FROM licence_task INNER JOIN company ON licence_task.cmpNpdidCompany = company.cmpNpdidCompany

mappingId Mapping:00919:ForeignKey
target    npd:field/{field.fldNpdidField} npdv:discoveryWellbore npd:wellbore/{wellbore_npdid_overview.wlbNpdidWellbore} . 
source    SELECT field.fldNpdidField, wellbore_npdid_overview.wlbNpdidWellbore FROM field INNER JOIN wellbore_npdid_overview ON field.wlbNpdidWellbore = wellbore_npdid_overview.wlbNpdidWellbore

mappingId Mapping:00920:ForeignKey
target    npd:field/{field_activity_status_hst.fldNpdidField}/activity/{field_activity_status_hst.fldStatus}/history/{field_activity_status_hst.fldStatusFromDate}/{field_activity_status_hst.fldStatusToDate} npdv:statusForField npd:field/{field.fldNpdidField} . 
source    SELECT field_activity_status_hst.fldNpdidField, field_activity_status_hst.fldStatus, field_activity_status_hst.fldStatusFromDate, field_activity_status_hst.fldStatusToDate, field.fldNpdidField FROM field_activity_status_hst INNER JOIN field ON field_activity_status_hst.fldNpdidField = field.fldNpdidField

mappingId Mapping:00921:ForeignKey
target    npd:petreg/licence/{licence_petreg_licence_licencee.prlNpdidLicence}/licencee/{licence_petreg_licence_licencee.cmpNpdidCompany} ptl:licenceLicenceeCompany npd:company/{company.cmpNpdidCompany} . 
source    SELECT licence_petreg_licence_licencee.prlNpdidLicence, licence_petreg_licence_licencee.cmpNpdidCompany, company.cmpNpdidCompany FROM licence_petreg_licence_licencee INNER JOIN company ON licence_petreg_licence_licencee.cmpNpdidCompany = company.cmpNpdidCompany

mappingId Mapping:00922:ForeignKey
target    npd:discovery/{fldArea.dscNpdidDiscovery}/area/hctype/{fldArea.dscHcType} npdv:isGeometryOfFeature npd:field/{field.fldNpdidField} . 
source    SELECT fldArea.dscNpdidDiscovery, fldArea.dscHcType, field.fldNpdidField FROM fldArea INNER JOIN field ON fldArea.fldNpdidField = field.fldNpdidField

mappingId Mapping:00923:ForeignKey
target    npd:wellbore/{wellbore_exploration_all.wlbNpdidWellbore} npdv:reclassedFromWellbore npd:wellbore/{wellbore_npdid_overview.wlbNpdidWellbore} . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_npdid_overview.wlbNpdidWellbore FROM wellbore_exploration_all INNER JOIN wellbore_npdid_overview ON wellbore_exploration_all.wlbNpdidWellboreReclass = wellbore_npdid_overview.wlbNpdidWellbore

mappingId Mapping:00924:ForeignKey
target    npd:discovery/{discovery.dscNpdidDiscovery} npdv:includedInField npd:field/{field.fldNpdidField} . 
source    SELECT discovery.dscNpdidDiscovery, field.fldNpdidField FROM discovery INNER JOIN field ON discovery.fldNpdidField = field.fldNpdidField

mappingId Mapping:00925:ForeignKey
target    npd:baa/{bsns_arr_area_licensee_hst.baaNpdidBsnsArrArea}/licensee/{bsns_arr_area_licensee_hst.cmpNpdidCompany}/history/{bsns_arr_area_licensee_hst.baaLicenseeDateValidFrom}/{bsns_arr_area_licensee_hst.baaLicenseeDateValidTo} npdv:licenseeForBAA npd:baa/{bsns_arr_area.baaNpdidBsnsArrArea} . 
source    SELECT bsns_arr_area_licensee_hst.baaNpdidBsnsArrArea, bsns_arr_area_licensee_hst.cmpNpdidCompany, bsns_arr_area_licensee_hst.baaLicenseeDateValidFrom, bsns_arr_area_licensee_hst.baaLicenseeDateValidTo, bsns_arr_area.baaNpdidBsnsArrArea FROM bsns_arr_area_licensee_hst INNER JOIN bsns_arr_area ON bsns_arr_area_licensee_hst.baaNpdidBsnsArrArea = bsns_arr_area.baaNpdidBsnsArrArea

mappingId Mapping:00926:ForeignKey
target    npd:wellbore/{wellbore_shallow_all.wlbNpdidWellbore} npdv:shallowWellboreForLicence npd:licence/{licence.prlNpdidLicence} . 
source    SELECT wellbore_shallow_all.wlbNpdidWellbore, licence.prlNpdidLicence FROM wellbore_shallow_all INNER JOIN licence ON wellbore_shallow_all.wlbProductionLicence = licence.prlName

mappingId Mapping:00927:ForeignKey
target    npd:petreg/facility/{tuf_petreg_message.tufNpdidTuf}/message/{tuf_petreg_message.ptlMessageDocumentNo} ptl:messageForTUF npd:petreg/facility/{tuf_petreg_licence.tufNpdidTuf} . 
source    SELECT tuf_petreg_message.tufNpdidTuf, tuf_petreg_message.ptlMessageDocumentNo, tuf_petreg_licence.tufNpdidTuf FROM tuf_petreg_message INNER JOIN tuf_petreg_licence ON tuf_petreg_message.tufNpdidTuf = tuf_petreg_licence.tufNpdidTuf

mappingId Mapping:00928:ForeignKey
target    npd:petreg/facility/{tuf_petreg_licence_licencee.tufNpdidTuf}/licencee/{tuf_petreg_licence_licencee.cmpNpdidCompany} ptl:TUFLicenceeForTUF npd:petreg/facility/{tuf_petreg_licence.tufNpdidTuf} . 
source    SELECT tuf_petreg_licence_licencee.tufNpdidTuf, tuf_petreg_licence_licencee.cmpNpdidCompany, tuf_petreg_licence.tufNpdidTuf FROM tuf_petreg_licence_licencee INNER JOIN tuf_petreg_licence ON tuf_petreg_licence_licencee.tufNpdidTuf = tuf_petreg_licence.tufNpdidTuf

mappingId Mapping:00929:ForeignKey
target    npd:facility/{tuf_owner_hst.tufNpdidTuf}/owner/{tuf_owner_hst.cmpNpdidCompany}/history/{tuf_owner_hst.tufOwnerDateValidFrom}/{tuf_owner_hst.tufOwnerDateValidTo} ptl:TUFOwnerForLicence npd:petreg/facility/{tuf_petreg_licence.tufNpdidTuf} . 
source    SELECT tuf_owner_hst.tufNpdidTuf, tuf_owner_hst.cmpNpdidCompany, tuf_owner_hst.tufOwnerDateValidFrom, tuf_owner_hst.tufOwnerDateValidTo, tuf_petreg_licence.tufNpdidTuf FROM tuf_owner_hst INNER JOIN tuf_petreg_licence ON tuf_owner_hst.tufNpdidTuf = tuf_petreg_licence.tufNpdidTuf

mappingId Mapping:00930:ForeignKey
target    npd:wellbore/{wellbore_oil_sample.wlbNpdidWellbore}/test/oilsample/{wellbore_oil_sample.wellbore_oil_sample_id} npdv:oilSampleTestForWellbore npd:wellbore/{wellbore_npdid_overview.wlbNpdidWellbore} . 
source    SELECT wellbore_oil_sample.wellbore_oil_sample_id, wellbore_oil_sample.wlbNpdidWellbore, wellbore_npdid_overview.wlbNpdidWellbore FROM wellbore_oil_sample INNER JOIN wellbore_npdid_overview ON wellbore_oil_sample.wlbNpdidWellbore = wellbore_npdid_overview.wlbNpdidWellbore

mappingId Mapping:00931:ForeignKey
target    npd:licence/{licence_oper_hst.prlNpdidLicence}/operator/{licence_oper_hst.cmpNpdidCompany}/history/{licence_oper_hst.prlOperDateValidFrom}/{licence_oper_hst.prlOperDateValidTo} npdv:licenceOperatorCompany npd:company/{company.cmpNpdidCompany} . 
source    SELECT licence_oper_hst.prlNpdidLicence, licence_oper_hst.cmpNpdidCompany, licence_oper_hst.prlOperDateValidFrom, licence_oper_hst.prlOperDateValidTo, company.cmpNpdidCompany FROM licence_oper_hst INNER JOIN company ON licence_oper_hst.cmpNpdidCompany = company.cmpNpdidCompany

mappingId Mapping:00932:ForeignKey
target    npd:petreg/facility/{tuf_petreg_licence_licencee.tufNpdidTuf}/licencee/{tuf_petreg_licence_licencee.cmpNpdidCompany} ptl:TUFLicenceeCompany npd:company/{company.cmpNpdidCompany} . 
source    SELECT tuf_petreg_licence_licencee.tufNpdidTuf, tuf_petreg_licence_licencee.cmpNpdidCompany, company.cmpNpdidCompany FROM tuf_petreg_licence_licencee INNER JOIN company ON tuf_petreg_licence_licencee.cmpNpdidCompany = company.cmpNpdidCompany

mappingId Mapping:00933:ForeignKey
target    npd:field/{field_licensee_hst.fldNpdidField}/licensee/{field_licensee_hst.cmpNpdidCompany}/history/{field_licensee_hst.fldLicenseeFrom}/{field_licensee_hst.fldLicenseeTo} npdv:fieldLicensee npd:company/{company.cmpNpdidCompany} . 
source    SELECT field_licensee_hst.fldNpdidField, field_licensee_hst.cmpNpdidCompany, field_licensee_hst.fldLicenseeFrom, field_licensee_hst.fldLicenseeTo, company.cmpNpdidCompany FROM field_licensee_hst INNER JOIN company ON field_licensee_hst.cmpNpdidCompany = company.cmpNpdidCompany

mappingId Mapping:00934:ForeignKey
target    npd:baa/{baaArea.baaNpdidBsnsArrArea}/polygon/{baaArea.baaNpdidBsnsArrAreaPoly} npdv:isGeometryOfFeature npd:baa/{bsns_arr_area.baaNpdidBsnsArrArea} . 
source    SELECT baaArea.baaNpdidBsnsArrArea, baaArea.baaNpdidBsnsArrAreaPoly, bsns_arr_area.baaNpdidBsnsArrArea FROM baaArea INNER JOIN bsns_arr_area ON baaArea.baaNpdidBsnsArrArea = bsns_arr_area.baaNpdidBsnsArrArea

mappingId Mapping:00935:ForeignKey
target    npd:survey/{seis_acquisition_coordinates_inc_turnarea.seaSurveyName}/point/{seis_acquisition_coordinates_inc_turnarea.seaPolygonPointNumber} npdv:coordinateForSurvey npd:survey/{seis_acquisition.seaName} . 
source    SELECT seis_acquisition_coordinates_inc_turnarea.seaSurveyName, seis_acquisition_coordinates_inc_turnarea.seaPolygonPointNumber, seis_acquisition.seaName FROM seis_acquisition_coordinates_inc_turnarea INNER JOIN seis_acquisition ON seis_acquisition_coordinates_inc_turnarea.seaNpdidSurvey = seis_acquisition.seaNpdidSurvey

mappingId Mapping:00936:ForeignKey
target    npd:licence/{licence_task.prlNpdidLicence}/task/{licence_task.prlTaskID} npdv:taskForLicence npd:licence/{licence.prlNpdidLicence} . 
source    SELECT licence_task.prlNpdidLicence, licence_task.prlTaskID, licence.prlNpdidLicence FROM licence_task INNER JOIN licence ON licence_task.prlNpdidLicence = licence.prlNpdidLicence

mappingId Mapping:00937:ForeignKey
target    npd:licence/{licence_area_poly_hst.prlNpdidLicence}/block/{licence_area_poly_hst.prlAreaPolyBlockName}/polyno/{licence_area_poly_hst.prlAreaPolyPolyNo}/history/{licence_area_poly_hst.prlAreaPolyDateValidFrom}/{licence_area_poly_hst.prlAreaPolyDateValidTo} npdv:isGeometryOfFeature npd:licence/{licence.prlNpdidLicence} . 
source    SELECT licence_area_poly_hst.prlNpdidLicence, licence_area_poly_hst.prlAreaPolyBlockName, licence_area_poly_hst.prlAreaPolyPolyNo, licence_area_poly_hst.prlAreaPolyDateValidFrom, licence_area_poly_hst.prlAreaPolyDateValidTo, licence.prlNpdidLicence FROM licence_area_poly_hst INNER JOIN licence ON licence_area_poly_hst.prlNpdidLicence = licence.prlNpdidLicence

mappingId Mapping:00938:ForeignKey
target    npd:petreg/licence/{licence_petreg_licence_oper.prlNpdidLicence} ptl:licenceOperatorCompany npd:company/{company.cmpNpdidCompany} . 
source    SELECT licence_petreg_licence_oper.prlNpdidLicence, company.cmpNpdidCompany FROM licence_petreg_licence_oper INNER JOIN company ON licence_petreg_licence_oper.cmpNpdidCompany = company.cmpNpdidCompany

mappingId Mapping:00939:ForeignKey
target    npd:wellbore/{wellbore_core_photo.wlbNpdidWellbore}/core/{wellbore_core_photo.wlbCoreNumber}/photo/{wellbore_core_photo.wellbore_core_photo_id}/{wellbore_core_photo.wlbCorePhotoTitle} npdv:corePhotoForWellbore npd:wellbore/{wellbore_npdid_overview.wlbNpdidWellbore} . 
source    SELECT wellbore_core_photo.wellbore_core_photo_id, wellbore_core_photo.wlbNpdidWellbore, wellbore_core_photo.wlbCoreNumber, wellbore_core_photo.wlbCorePhotoTitle, wellbore_npdid_overview.wlbNpdidWellbore FROM wellbore_core_photo INNER JOIN wellbore_npdid_overview ON wellbore_core_photo.wlbNpdidWellbore = wellbore_npdid_overview.wlbNpdidWellbore

mappingId Mapping:00940:ForeignKey
target    npd:licence/{licence_licensee_hst.prlNpdidLicence}/licensee/{licence_licensee_hst.cmpNpdidCompany}/history/{licence_licensee_hst.prlLicenseeDateValidFrom}/{licence_licensee_hst.prlLicenseeDateValidTo} npdv:licenseeForLicence npd:licence/{licence.prlNpdidLicence} . 
source    SELECT licence_licensee_hst.prlNpdidLicence, licence_licensee_hst.cmpNpdidCompany, licence_licensee_hst.prlLicenseeDateValidFrom, licence_licensee_hst.prlLicenseeDateValidTo, licence.prlNpdidLicence FROM licence_licensee_hst INNER JOIN licence ON licence_licensee_hst.prlNpdidLicence = licence.prlNpdidLicence

mappingId Mapping:00941:ForeignKey
target    npd:wellbore/{wellbore_exploration_all.wlbNpdidWellbore} npdv:explorationWellboreForLicence npd:licence/{licence.prlNpdidLicence} . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, licence.prlNpdidLicence FROM wellbore_exploration_all INNER JOIN licence ON wellbore_exploration_all.prlNpdidProductionLicence = licence.prlNpdidLicence

mappingId Mapping:00942:ForeignKey
target    npd:survey/{seis_acquisition.seaName} npdv:reportingCompany npd:company/{company.cmpNpdidCompany} . 
source    SELECT seis_acquisition.seaName, company.cmpNpdidCompany FROM seis_acquisition INNER JOIN company ON seis_acquisition.seaCompanyReported = company.cmpLongName

mappingId Mapping:00943:ForeignKey
target    npd:wellbore/{wellbore_document.wlbNpdidWellbore}/document/{wellbore_document.wellbore_document_id}/{wellbore_document.wlbDocumentName} npdv:documentForWellbore npd:wellbore/{wellbore_npdid_overview.wlbNpdidWellbore} . 
source    SELECT wellbore_document.wellbore_document_id, wellbore_document.wlbNpdidWellbore, wellbore_document.wlbDocumentName, wellbore_npdid_overview.wlbNpdidWellbore FROM wellbore_document INNER JOIN wellbore_npdid_overview ON wellbore_document.wlbNpdidWellbore = wellbore_npdid_overview.wlbNpdidWellbore

mappingId Mapping:00944:ForeignKey
target    npd:licence/{licence_transfer_hst.prlNpdidLicence}/transfer/{licence_transfer_hst.prlTransferDirection}/{licence_transfer_hst.cmpNpdidCompany}/history/{licence_transfer_hst.prlTransferDateValidFrom} npdv:licenceTransferCompany npd:company/{company.cmpNpdidCompany} . 
source    SELECT licence_transfer_hst.prlNpdidLicence, licence_transfer_hst.prlTransferDirection, licence_transfer_hst.cmpNpdidCompany, licence_transfer_hst.prlTransferDateValidFrom, company.cmpNpdidCompany FROM licence_transfer_hst INNER JOIN company ON licence_transfer_hst.cmpNpdidCompany = company.cmpNpdidCompany

mappingId Mapping:00945:ForeignKey
target    npd:baa/{bsns_arr_area_transfer_hst.baaNpdidBsnsArrArea}/transfer/{bsns_arr_area_transfer_hst.baaTransferDirection}/{bsns_arr_area_transfer_hst.cmpNpdidCompany}/history/{bsns_arr_area_transfer_hst.baaTransferDateValidFrom} npdv:transferredBAA npd:baa/{bsns_arr_area.baaNpdidBsnsArrArea} . 
source    SELECT bsns_arr_area_transfer_hst.baaNpdidBsnsArrArea, bsns_arr_area_transfer_hst.baaTransferDirection, bsns_arr_area_transfer_hst.cmpNpdidCompany, bsns_arr_area_transfer_hst.baaTransferDateValidFrom, bsns_arr_area.baaNpdidBsnsArrArea FROM bsns_arr_area_transfer_hst INNER JOIN bsns_arr_area ON bsns_arr_area_transfer_hst.baaNpdidBsnsArrArea = bsns_arr_area.baaNpdidBsnsArrArea

mappingId Mapping:00946:ForeignKey
target    npd:licence/{prlAreaSplitByBlock.prlNpdidLicence}/block/{prlAreaSplitByBlock.blcName}/polyno/{prlAreaSplitByBlock.prlAreaPolyPolyNo}/history/{prlAreaSplitByBlock.prlAreaPolyDateValidFrom}/{prlAreaSplitByBlock.prlAreaPolyDateValidTo} npdv:isGeometryOfFeature npd:licence/{licence.prlNpdidLicence} . 
source    SELECT prlAreaSplitByBlock.prlNpdidLicence, prlAreaSplitByBlock.blcName, prlAreaSplitByBlock.prlAreaPolyPolyNo, prlAreaSplitByBlock.prlAreaPolyDateValidFrom, prlAreaSplitByBlock.prlAreaPolyDateValidTo, licence.prlNpdidLicence FROM prlAreaSplitByBlock INNER JOIN licence ON prlAreaSplitByBlock.prlNpdidLicence = licence.prlNpdidLicence

mappingId Mapping:00947:ForeignKey
target    npd:wellbore/{wlbPoint.wlbNpdidWellbore}/point npdv:isGeometryOfFeature npd:wellbore/{wellbore_npdid_overview.wlbNpdidWellbore} . 
source    SELECT wlbPoint.wlbNpdidWellbore, wellbore_npdid_overview.wlbNpdidWellbore FROM wlbPoint INNER JOIN wellbore_npdid_overview ON wlbPoint.wlbNpdidWellbore = wellbore_npdid_overview.wlbNpdidWellbore

mappingId Mapping:00948:ForeignKey
target    npd:wellbore/{wellbore_formation_top.wlbNpdidWellbore}/stratum/{wellbore_formation_top.lsuNpdidLithoStrat}/depth/{wellbore_formation_top.lsuTopDepth}/{wellbore_formation_top.lsuBottomDepth} npdv:stratumForWellbore npd:wellbore/{wellbore_npdid_overview.wlbNpdidWellbore} . 
source    SELECT wellbore_formation_top.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat, wellbore_formation_top.lsuTopDepth, wellbore_formation_top.lsuBottomDepth, wellbore_npdid_overview.wlbNpdidWellbore FROM wellbore_formation_top INNER JOIN wellbore_npdid_overview ON wellbore_formation_top.wlbNpdidWellbore = wellbore_npdid_overview.wlbNpdidWellbore

mappingId Mapping:00949:ForeignKey
target    npd:petreg/licence/{licence_petreg_licence_licencee.prlNpdidLicence}/licencee/{licence_petreg_licence_licencee.cmpNpdidCompany} ptl:licenceeForLicence npd:licence/{licence.prlNpdidLicence} . 
source    SELECT licence_petreg_licence_licencee.prlNpdidLicence, licence_petreg_licence_licencee.cmpNpdidCompany, licence.prlNpdidLicence FROM licence_petreg_licence_licencee INNER JOIN licence ON licence_petreg_licence_licencee.prlNpdidLicence = licence.prlNpdidLicence

mappingId Mapping:00950:ForeignKey
target    npd:discovery/{discovery.dscNpdidDiscovery} npdv:discoveryWellbore npd:wellbore/{wellbore_npdid_overview.wlbNpdidWellbore} . 
source    SELECT discovery.dscNpdidDiscovery, wellbore_npdid_overview.wlbNpdidWellbore FROM discovery INNER JOIN wellbore_npdid_overview ON discovery.wlbNpdidWellbore = wellbore_npdid_overview.wlbNpdidWellbore

mappingId Mapping:00951:ForeignKey
target    npd:baa/{bsns_arr_area_operator.baaNpdidBsnsArrArea} npdv:baaOperatorCompany npd:company/{company.cmpNpdidCompany} . 
source    SELECT bsns_arr_area_operator.baaNpdidBsnsArrArea, company.cmpNpdidCompany FROM bsns_arr_area_operator INNER JOIN company ON bsns_arr_area_operator.cmpNpdidCompany = company.cmpNpdidCompany

mappingId Mapping:00952:ForeignKey
target    npd:facility/{tuf_operator_hst.tufNpdidTuf}/operator/{tuf_operator_hst.cmpNpdidCompany}/history/{tuf_operator_hst.tufOperDateValidFrom}/{tuf_operator_hst.tufOperDateValidTo} ptl:TUFOperatorCompany npd:company/{company.cmpNpdidCompany} . 
source    SELECT tuf_operator_hst.tufNpdidTuf, tuf_operator_hst.cmpNpdidCompany, tuf_operator_hst.tufOperDateValidFrom, tuf_operator_hst.tufOperDateValidTo, company.cmpNpdidCompany FROM tuf_operator_hst INNER JOIN company ON tuf_operator_hst.cmpNpdidCompany = company.cmpNpdidCompany

mappingId Mapping:00953:ForeignKey
target    npd:wellbore/{wellbore_exploration_all.wlbNpdidWellbore} npdv:wellboreForDiscovery npd:discovery/{discovery.dscNpdidDiscovery} . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, discovery.dscNpdidDiscovery FROM wellbore_exploration_all INNER JOIN discovery ON wellbore_exploration_all.dscNpdidDiscovery = discovery.dscNpdidDiscovery

mappingId Mapping:00954:ForeignKey
target    npd:discovery/{discovery_reserves.dscNpdidDiscovery}/{discovery_reserves.dscReservesRC} npdv:reservesForDiscovery npd:discovery/{discovery.dscNpdidDiscovery} . 
source    SELECT discovery_reserves.dscNpdidDiscovery, discovery_reserves.dscReservesRC, discovery.dscNpdidDiscovery FROM discovery_reserves INNER JOIN discovery ON discovery_reserves.dscNpdidDiscovery = discovery.dscNpdidDiscovery

mappingId Mapping:00955:ForeignKey
target    npd:petreg/licence/{licence_petreg_message.prlNpdidLicence}/message/{licence_petreg_message.ptlMessageDocumentNo} npdv:messageForLicence npd:licence/{licence.prlNpdidLicence} . 
source    SELECT licence_petreg_message.prlNpdidLicence, licence_petreg_message.ptlMessageDocumentNo, licence.prlNpdidLicence FROM licence_petreg_message INNER JOIN licence ON licence_petreg_message.prlNpdidLicence = licence.prlNpdidLicence

mappingId Mapping:00956:ForeignKey
target    npd:licence/{licence_oper_hst.prlNpdidLicence}/operator/{licence_oper_hst.cmpNpdidCompany}/history/{licence_oper_hst.prlOperDateValidFrom}/{licence_oper_hst.prlOperDateValidTo} npdv:operatorForLicence npd:licence/{licence.prlNpdidLicence} . 
source    SELECT licence_oper_hst.prlNpdidLicence, licence_oper_hst.cmpNpdidCompany, licence_oper_hst.prlOperDateValidFrom, licence_oper_hst.prlOperDateValidTo, licence.prlNpdidLicence FROM licence_oper_hst INNER JOIN licence ON licence_oper_hst.prlNpdidLicence = licence.prlNpdidLicence

mappingId Mapping:00957:ForeignKey
target    npd:licence/{licence_licensee_hst.prlNpdidLicence}/licensee/{licence_licensee_hst.cmpNpdidCompany}/history/{licence_licensee_hst.prlLicenseeDateValidFrom}/{licence_licensee_hst.prlLicenseeDateValidTo} npdv:licenceLicensee npd:company/{company.cmpNpdidCompany} . 
source    SELECT licence_licensee_hst.prlNpdidLicence, licence_licensee_hst.cmpNpdidCompany, licence_licensee_hst.prlLicenseeDateValidFrom, licence_licensee_hst.prlLicenseeDateValidTo, company.cmpNpdidCompany FROM licence_licensee_hst INNER JOIN company ON licence_licensee_hst.cmpNpdidCompany = company.cmpNpdidCompany

mappingId Mapping:00958:ForeignKey
target    npd:baa/{bsns_arr_area_licensee_hst.baaNpdidBsnsArrArea}/licensee/{bsns_arr_area_licensee_hst.cmpNpdidCompany}/history/{bsns_arr_area_licensee_hst.baaLicenseeDateValidFrom}/{bsns_arr_area_licensee_hst.baaLicenseeDateValidTo} npdv:baaLicensee npd:company/{company.cmpNpdidCompany} . 
source    SELECT bsns_arr_area_licensee_hst.baaNpdidBsnsArrArea, bsns_arr_area_licensee_hst.cmpNpdidCompany, bsns_arr_area_licensee_hst.baaLicenseeDateValidFrom, bsns_arr_area_licensee_hst.baaLicenseeDateValidTo, company.cmpNpdidCompany FROM bsns_arr_area_licensee_hst INNER JOIN company ON bsns_arr_area_licensee_hst.cmpNpdidCompany = company.cmpNpdidCompany

mappingId Mapping:00959:ForeignKey
target    npd:wellbore/{wellbore_coordinates.wlbNpdidWellbore}/point npdv:coordinateForWellbore npd:wellbore/{wellbore_npdid_overview.wlbNpdidWellbore} . 
source    SELECT wellbore_coordinates.wlbNpdidWellbore, wellbore_npdid_overview.wlbNpdidWellbore FROM wellbore_coordinates INNER JOIN wellbore_npdid_overview ON wellbore_coordinates.wlbNpdidWellbore = wellbore_npdid_overview.wlbNpdidWellbore

mappingId Mapping:00960:ForeignKey
target    npd:wellbore/{wellbore_development_all.wlbNpdidWellbore} npdv:reclassedFromWellbore npd:wellbore/{wellbore_npdid_overview.wlbNpdidWellbore} . 
source    SELECT wellbore_development_all.wlbNpdidWellbore, wellbore_npdid_overview.wlbNpdidWellbore FROM wellbore_development_all INNER JOIN wellbore_npdid_overview ON wellbore_development_all.wlbNpdidWellboreReclass = wellbore_npdid_overview.wlbNpdidWellbore

mappingId Mapping:00961:ForeignKey
target    npd:discovery/{dscArea.dscNpdidDiscovery}/area/hctype/{dscArea.dscHcType} npdv:isGeometryOfFeature npd:discovery/{discovery.dscNpdidDiscovery} . 
source    SELECT dscArea.dscNpdidDiscovery, dscArea.dscHcType, discovery.dscNpdidDiscovery FROM dscArea INNER JOIN discovery ON dscArea.dscNpdidDiscovery = discovery.dscNpdidDiscovery

mappingId Mapping:00962:ForeignKey
target    npd:wellbore/{strat_litho_wellbore_core.wlbNpdidWellbore}/stratum/{strat_litho_wellbore_core.lsuNpdidLithoStrat}/cores npdv:coreForWellbore npd:wellbore/{wellbore_npdid_overview.wlbNpdidWellbore} . 
source    SELECT strat_litho_wellbore_core.wlbNpdidWellbore, strat_litho_wellbore_core.lsuNpdidLithoStrat, wellbore_npdid_overview.wlbNpdidWellbore FROM strat_litho_wellbore_core INNER JOIN wellbore_npdid_overview ON strat_litho_wellbore_core.wlbNpdidWellbore = wellbore_npdid_overview.wlbNpdidWellbore

mappingId Mapping:00963:ForeignKey
target    npd:field/{field_licensee_hst.fldNpdidField}/licensee/{field_licensee_hst.cmpNpdidCompany}/history/{field_licensee_hst.fldLicenseeFrom}/{field_licensee_hst.fldLicenseeTo} npdv:licenseeForField npd:field/{field.fldNpdidField} . 
source    SELECT field_licensee_hst.fldNpdidField, field_licensee_hst.cmpNpdidCompany, field_licensee_hst.fldLicenseeFrom, field_licensee_hst.fldLicenseeTo, field.fldNpdidField FROM field_licensee_hst INNER JOIN field ON field_licensee_hst.fldNpdidField = field.fldNpdidField

mappingId Mapping:00964:ForeignKey
target    npd:baa/{bsns_arr_area_area_poly_hst.baaNpdidBsnsArrArea}/block/{bsns_arr_area_area_poly_hst.baaAreaPolyBlockName}/polyno/{bsns_arr_area_area_poly_hst.baaAreaPolyNo}/history/{bsns_arr_area_area_poly_hst.baaAreaPolyDateValidFrom}/{bsns_arr_area_area_poly_hst.baaAreaPolyDateValidTo} npdv:isGeometryOfFeature npd:baa/{bsns_arr_area.baaNpdidBsnsArrArea} . 
source    SELECT bsns_arr_area_area_poly_hst.baaNpdidBsnsArrArea, bsns_arr_area_area_poly_hst.baaAreaPolyBlockName, bsns_arr_area_area_poly_hst.baaAreaPolyNo, bsns_arr_area_area_poly_hst.baaAreaPolyDateValidFrom, bsns_arr_area_area_poly_hst.baaAreaPolyDateValidTo, bsns_arr_area.baaNpdidBsnsArrArea FROM bsns_arr_area_area_poly_hst INNER JOIN bsns_arr_area ON bsns_arr_area_area_poly_hst.baaNpdidBsnsArrArea = bsns_arr_area.baaNpdidBsnsArrArea

mappingId Mapping:00965:ForeignKey
target    npd:licence/{prlArea.prlNpdidLicence}/area/{prlArea.prlArea_id}/history/{prlArea.prlAreaPolyDateValidFrom}/{prlArea.prlAreaPolyDateValidTo} npdv:isGeometryOfFeature npd:licence/{licence.prlNpdidLicence} . 
source    SELECT prlArea.prlArea_id, prlArea.prlNpdidLicence, prlArea.prlAreaPolyDateValidFrom, prlArea.prlAreaPolyDateValidTo, licence.prlNpdidLicence FROM prlArea INNER JOIN licence ON prlArea.prlNpdidLicence = licence.prlNpdidLicence

mappingId Mapping:00966:ForeignKey
target    npd:facility/{fclPoint.fclNpdidFacility}/point npdv:belongsToFacility npd:petreg/facility/{tuf_petreg_licence.tufNpdidTuf} . 
source    SELECT fclPoint.fclNpdidFacility, tuf_petreg_licence.tufNpdidTuf FROM fclPoint INNER JOIN tuf_petreg_licence ON fclPoint.fclBelongsToS = tuf_petreg_licence.tufNpdidTuf

mappingId Mapping:00967:ForeignKey
target    npd:wellbore/{wellbore_exploration_all.wlbNpdidWellbore} npdv:explorationWellboreForLicence npd:licence/{licence.prlNpdidLicence} . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, licence.prlNpdidLicence FROM wellbore_exploration_all INNER JOIN licence ON wellbore_exploration_all.wlbProductionLicence = licence.prlName

mappingId Mapping:00968:ForeignKey
target    npd:wellbore/{wellbore_exploration_all.wlbNpdidWellbore} npdv:drillingOperatorCompany npd:company/{company.cmpNpdidCompany} . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, company.cmpNpdidCompany FROM wellbore_exploration_all INNER JOIN company ON wellbore_exploration_all.wlbDrillingOperator = company.cmpLongName

mappingId Mapping:00969:ForeignKey
target    npd:field/{field_reserves.fldNpdidField}/reserve npdv:reservesForField npd:field/{field.fldNpdidField} . 
source    SELECT field_reserves.fldNpdidField, field.fldNpdidField FROM field_reserves INNER JOIN field ON field_reserves.fldNpdidField = field.fldNpdidField

mappingId Mapping:00970:ForeignKey
target    npd:company/{company_reserves.cmpNpdidCompany}/reserve/{company_reserves.fldNpdidField} npdv:reservesForField npd:field/{field.fldNpdidField} . 
source    SELECT company_reserves.cmpNpdidCompany, company_reserves.fldNpdidField, field.fldNpdidField FROM company_reserves INNER JOIN field ON company_reserves.fldNpdidField = field.fldNpdidField

mappingId Mapping:00971:ForeignKey
target    npd:facility/{facility_moveable.fclNpdidFacility} npdv:currentResponsibleCompany npd:company/{company.cmpNpdidCompany} . 
source    SELECT facility_moveable.fclNpdidFacility, company.cmpNpdidCompany FROM facility_moveable INNER JOIN company ON facility_moveable.fclNpdidCurrentRespCompany = company.cmpNpdidCompany

mappingId Mapping:00972:ForeignKey
target    npd:facility/{fclPoint.fclNpdidFacility}/point npdv:isGeometryOfFeature npd:facility/{facility_fixed.fclNpdidFacility} . 
source    SELECT fclPoint.fclNpdidFacility, facility_fixed.fclNpdidFacility FROM fclPoint INNER JOIN facility_fixed ON fclPoint.fclNpdidFacility = facility_fixed.fclNpdidFacility

mappingId Mapping:00973:ForeignKey
target    npd:wellbore/{strat_litho_wellbore.wlbNpdidWellbore}/stratum/{strat_litho_wellbore.lsuNpdidLithoStrat}/depth/{strat_litho_wellbore.lsuTopDepth}/{strat_litho_wellbore.lsuBottomDepth} npdv:stratumForWellbore npd:wellbore/{wellbore_npdid_overview.wlbNpdidWellbore} . 
source    SELECT strat_litho_wellbore.wlbNpdidWellbore, strat_litho_wellbore.lsuNpdidLithoStrat, strat_litho_wellbore.lsuTopDepth, strat_litho_wellbore.lsuBottomDepth, wellbore_npdid_overview.wlbNpdidWellbore FROM strat_litho_wellbore INNER JOIN wellbore_npdid_overview ON strat_litho_wellbore.wlbNpdidWellbore = wellbore_npdid_overview.wlbNpdidWellbore

mappingId Mapping:00974:Table:Subs:npdv:MoveableFacility
target    npd:facility/{fclNpdidFacility} a npdv:JackUp3LegsFacility . 
source    SELECT fclNpdidFacility FROM facility_moveable WHERE fclKind='JACK-UP 3 LEGS'

mappingId Mapping:00975:Table:Subs:npdv:MoveableFacility
target    npd:facility/{fclNpdidFacility} a npdv:SemisubSteelFacility . 
source    SELECT fclNpdidFacility FROM facility_moveable WHERE fclKind='SEMISUB STEEL'

mappingId Mapping:00976:Table:Subs:npdv:MoveableFacility
target    npd:facility/{fclNpdidFacility} a npdv:Jacket4LegsFacility . 
source    SELECT fclNpdidFacility FROM facility_moveable WHERE fclKind='JACKET 4 LEGS'

mappingId Mapping:00977:Table:Subs:npdv:MoveableFacility
target    npd:facility/{fclNpdidFacility} a npdv:VesselFacility . 
source    SELECT fclNpdidFacility FROM facility_moveable WHERE fclKind='VESSEL'

mappingId Mapping:00978:Table:Subs:npdv:MoveableFacility
target    npd:facility/{fclNpdidFacility} a npdv:JackUp4LegsFacility . 
source    SELECT fclNpdidFacility FROM facility_moveable WHERE fclKind='JACK-UP 4 LEGS'

mappingId Mapping:00979:Table:Subs:npdv:SeismicSurvey
target    npd:survey/{seaName} a npdv:RegularSeismicSurvey . 
source    SELECT seaName FROM seis_acquisition WHERE seaSurveyTypeMain='Ordinær seismisk undersøkelse'

mappingId Mapping:00980:Table:Subs:npdv:SeismicSurvey
target    npd:survey/{seaName} a npdv:ElectromagneticSurvey . 
source    SELECT seaName FROM seis_acquisition WHERE seaSurveyTypeMain='Elektromagnetisk undersøkelse'

mappingId Mapping:00981:Table:Subs:npdv:SeismicSurvey
target    npd:survey/{seaName} a npdv:SeabedSeismicSurvey . 
source    SELECT seaName FROM seis_acquisition WHERE seaSurveyTypeMain='Havbunnseismisk undersøkelse'

mappingId Mapping:00982:Table:Subs:npdv:SeismicSurvey
target    npd:survey/{seaName} a npdv:SiteSurvey . 
source    SELECT seaName FROM seis_acquisition WHERE seaSurveyTypeMain='Borestedundersøkelse / sitesurvey'

mappingId Mapping:00983:Table:Subs:npdv:SeismicSurvey
target    npd:survey/{seaName} a npdv:RouteSurvey . 
source    SELECT seaName FROM seis_acquisition WHERE seaSurveyTypeMain='Traseundersøkelser'

mappingId Mapping:00984:Table:Subs:npdv:SeismicSurvey
target    npd:survey/{seaName} a npdv:OtherSurvey . 
source    SELECT seaName FROM seis_acquisition WHERE seaSurveyTypeMain='Annen undersøkelse'

mappingId Mapping:00985:Table:Subs:npdv:SeismicSurvey
target    npd:survey/{seaName} a npdv:GroundSurvey . 
source    SELECT seaName FROM seis_acquisition WHERE seaSurveyTypeMain='Grunnundersøkelser'

mappingId Mapping:00986:Table:Subs:npdv:ExplorationWellbore
target    npd:wellbore/{wlbNpdidWellbore} a npdv:WildcatWellbore . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbPurpose='WILDCAT'

mappingId Mapping:00987:Table:Subs:npdv:ExplorationWellbore
target    npd:wellbore/{wlbNpdidWellbore} a npdv:AppraisalWellbore . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbPurpose='APPRAISAL'

mappingId Mapping:00988:Table:Subs:npdv:FixedFacility
target    npd:facility/{fclNpdidFacility} a npdv:Condeep4ShaftsFacility . 
source    SELECT fclNpdidFacility FROM facility_fixed WHERE fclKind='CONDEEP 4 SHAFTS'

mappingId Mapping:00989:Table:Subs:npdv:FixedFacility
target    npd:facility/{fclNpdidFacility} a npdv:Condeep3ShaftsFacility . 
source    SELECT fclNpdidFacility FROM facility_fixed WHERE fclKind='CONDEEP 3 SHAFTS'

mappingId Mapping:00990:Table:Subs:npdv:FixedFacility
target    npd:facility/{fclNpdidFacility} a npdv:Jacket12LegsFacility . 
source    SELECT fclNpdidFacility FROM facility_fixed WHERE fclKind='JACKET 12 LEGS'

mappingId Mapping:00991:Table:Subs:npdv:FixedFacility
target    npd:facility/{fclNpdidFacility} a npdv:Jacket8LegsFacility . 
source    SELECT fclNpdidFacility FROM facility_fixed WHERE fclKind='JACKET 8 LEGS'

mappingId Mapping:00992:Table:Subs:npdv:FixedFacility
target    npd:facility/{fclNpdidFacility} a npdv:Jacket4LegsFacility . 
source    SELECT fclNpdidFacility FROM facility_fixed WHERE fclKind='JACKET 4 LEGS'

mappingId Mapping:00993:Table:Subs:npdv:FixedFacility
target    npd:facility/{fclNpdidFacility} a npdv:MultiWellTemplateFacility . 
source    SELECT fclNpdidFacility FROM facility_fixed WHERE fclKind='MULTI WELL TEMPLATE'

mappingId Mapping:00994:Table:Subs:npdv:FixedFacility
target    npd:facility/{fclNpdidFacility} a npdv:ConcreteStructureFacility . 
source    SELECT fclNpdidFacility FROM facility_fixed WHERE fclKind='CONCRETE STRUCTURE'

mappingId Mapping:00995:Table:Subs:npdv:FixedFacility
target    npd:facility/{fclNpdidFacility} a npdv:TlpSteelFacility . 
source    SELECT fclNpdidFacility FROM facility_fixed WHERE fclKind='TLP STEEL'

mappingId Mapping:00996:Table:Subs:npdv:FixedFacility
target    npd:facility/{fclNpdidFacility} a npdv:DorisFacility . 
source    SELECT fclNpdidFacility FROM facility_fixed WHERE fclKind='DORIS'

mappingId Mapping:00997:Table:Subs:npdv:FixedFacility
target    npd:facility/{fclNpdidFacility} a npdv:Jacket6LegsFacility . 
source    SELECT fclNpdidFacility FROM facility_fixed WHERE fclKind='JACKET 6 LEGS'

mappingId Mapping:00998:Table:Subs:npdv:FixedFacility
target    npd:facility/{fclNpdidFacility} a npdv:CondeepMonoshaftFacility . 
source    SELECT fclNpdidFacility FROM facility_fixed WHERE fclKind='CONDEEP MONOSHAFT'

mappingId Mapping:00999:Table:Subs:npdv:FixedFacility
target    npd:facility/{fclNpdidFacility} a npdv:TlpConcreteFacility . 
source    SELECT fclNpdidFacility FROM facility_fixed WHERE fclKind='TLP CONCRETE'

mappingId Mapping:01000:Table:Subs:npdv:FixedFacility
target    npd:facility/{fclNpdidFacility} a npdv:LoadingSystemFacility . 
source    SELECT fclNpdidFacility FROM facility_fixed WHERE fclKind='LOADING SYSTEM'

mappingId Mapping:01001:Table:Subs:npdv:FixedFacility
target    npd:facility/{fclNpdidFacility} a npdv:SingleWellTemplateFacility . 
source    SELECT fclNpdidFacility FROM facility_fixed WHERE fclKind='SINGLE WELL TEMPLATE'

mappingId Mapping:01002:Table:Subs:npdv:FixedFacility
target    npd:facility/{fclNpdidFacility} a npdv:JacketTripodFacility . 
source    SELECT fclNpdidFacility FROM facility_fixed WHERE fclKind='JACKET TRIPOD'

mappingId Mapping:01003:Table:Subs:npdv:FixedFacility
target    npd:facility/{fclNpdidFacility} a npdv:SemisubSteelFacility . 
source    SELECT fclNpdidFacility FROM facility_fixed WHERE fclKind='SEMISUB STEEL'

mappingId Mapping:01004:Table:Subs:npdv:FixedFacility
target    npd:facility/{fclNpdidFacility} a npdv:SubseaStructureFacility . 
source    SELECT fclNpdidFacility FROM facility_fixed WHERE fclKind='SUBSEA STRUCTURE'

mappingId Mapping:01005:Table:Subs:npdv:FixedFacility
target    npd:facility/{fclNpdidFacility} a npdv:SemisubConcreteFacility . 
source    SELECT fclNpdidFacility FROM facility_fixed WHERE fclKind='SEMISUB CONCRETE'

mappingId Mapping:01006:Table:Subs:npdv:FixedFacility
target    npd:facility/{fclNpdidFacility} a npdv:FSUFacility . 
source    SELECT fclNpdidFacility FROM facility_fixed WHERE fclKind='FSU'

mappingId Mapping:01007:Table:Subs:npdv:FixedFacility
target    npd:facility/{fclNpdidFacility} a npdv:FPSOFacility . 
source    SELECT fclNpdidFacility FROM facility_fixed WHERE fclKind='FPSO'

mappingId Mapping:01008:Table:Subs:npdv:FixedFacility
target    npd:facility/{fclNpdidFacility} a npdv:MonotowerFacility . 
source    SELECT fclNpdidFacility FROM facility_fixed WHERE fclKind='MONOTOWER'

mappingId Mapping:01009:Table:Subs:npdv:FixedFacility
target    npd:facility/{fclNpdidFacility} a npdv:OnshoreFacility . 
source    SELECT fclNpdidFacility FROM facility_fixed WHERE fclKind='ONSHORE FACILITY'

mappingId Mapping:01010:Table:Subs:npdv:FixedFacility
target    npd:facility/{fclNpdidFacility} a npdv:MopustorFacility . 
source    SELECT fclNpdidFacility FROM facility_fixed WHERE fclKind='MOPUStor'

mappingId Mapping:01011:Table:Subs:npdv:FixedFacility
target    npd:facility/{fclNpdidFacility} a npdv:LandfallFacility . 
source    SELECT fclNpdidFacility FROM facility_fixed WHERE fclKind='LANDFALL'

mappingId Mapping:01012:Table:Subs:npdv:Pipeline
target    npd:pipeline/{pipNpdidPipe} a npdv:OilPipeline . 
source    SELECT pipNpdidPipe FROM pipLine WHERE pipMedium='Oil'

mappingId Mapping:01013:Table:Subs:npdv:Pipeline
target    npd:pipeline/{pipNpdidPipe} a npdv:GasPipeline . 
source    SELECT pipNpdidPipe FROM pipLine WHERE pipMedium='Gas'

mappingId Mapping:01014:Table:Subs:npdv:Pipeline
target    npd:pipeline/{pipNpdidPipe} a npdv:CondensatePipeline . 
source    SELECT pipNpdidPipe FROM pipLine WHERE pipMedium='Condensate'

mappingId Mapping:01015:Table:Subs:npdv:Pipeline
target    npd:pipeline/{pipNpdidPipe} a npdv:OilGasPipeline . 
source    SELECT pipNpdidPipe FROM pipLine WHERE pipMedium='Oil/gas'

mappingId Mapping:01016:Table:Subs:npdv:BAATransfer
target    npd:baa/{baaNpdidBsnsArrArea}/transfer/{baaTransferDirection}/{cmpNpdidCompany}/history/{baaTransferDateValidFrom} a npdv:Transfer . 
source    SELECT baaNpdidBsnsArrArea,baaTransferDirection,cmpNpdidCompany,baaTransferDateValidFrom FROM bsns_arr_area_transfer_hst WHERE baaTransferKind='TRANSFER'

mappingId Mapping:01017:Table:Subs:npdv:BAATransfer
target    npd:baa/{baaNpdidBsnsArrArea}/transfer/{baaTransferDirection}/{cmpNpdidCompany}/history/{baaTransferDateValidFrom} a npdv:ChangeOfCompanyNameTransfer . 
source    SELECT baaNpdidBsnsArrArea,baaTransferDirection,cmpNpdidCompany,baaTransferDateValidFrom FROM bsns_arr_area_transfer_hst WHERE baaTransferKind='CHANGE OF COMPANY NAME'

mappingId Mapping:01018:Table:Subs:npdv:BAATransfer
target    npd:baa/{baaNpdidBsnsArrArea}/transfer/{baaTransferDirection}/{cmpNpdidCompany}/history/{baaTransferDateValidFrom} a npdv:MergerTakeoverTransfer . 
source    SELECT baaNpdidBsnsArrArea,baaTransferDirection,cmpNpdidCompany,baaTransferDateValidFrom FROM bsns_arr_area_transfer_hst WHERE baaTransferKind='MERGER/TAKEOVER'

mappingId Mapping:01019:Table:Subs:npdv:BAATransfer
target    npd:baa/{baaNpdidBsnsArrArea}/transfer/{baaTransferDirection}/{cmpNpdidCompany}/history/{baaTransferDateValidFrom} a npdv:SDFITransfer . 
source    SELECT baaNpdidBsnsArrArea,baaTransferDirection,cmpNpdidCompany,baaTransferDateValidFrom FROM bsns_arr_area_transfer_hst WHERE baaTransferKind='SDFI'

mappingId Mapping:01020:Table:Subs:npdv:ProductionLicenceTransfer
target    npd:licence/{prlNpdidLicence}/transfer/{prlTransferDirection}/{cmpNpdidCompany}/history/{prlTransferDateValidFrom} a npdv:ChangeOfCompanyNameTransfer . 
source    SELECT prlNpdidLicence,prlTransferDirection,cmpNpdidCompany,prlTransferDateValidFrom FROM licence_transfer_hst WHERE prlTransferKind='CHANGE OF COMPANY NAME'

mappingId Mapping:01021:Table:Subs:npdv:ProductionLicenceTransfer
target    npd:licence/{prlNpdidLicence}/transfer/{prlTransferDirection}/{cmpNpdidCompany}/history/{prlTransferDateValidFrom} a npdv:Transfer . 
source    SELECT prlNpdidLicence,prlTransferDirection,cmpNpdidCompany,prlTransferDateValidFrom FROM licence_transfer_hst WHERE prlTransferKind='TRANSFER'

mappingId Mapping:01022:Table:Subs:npdv:ProductionLicenceTransfer
target    npd:licence/{prlNpdidLicence}/transfer/{prlTransferDirection}/{cmpNpdidCompany}/history/{prlTransferDateValidFrom} a npdv:MergerTakeoverTransfer . 
source    SELECT prlNpdidLicence,prlTransferDirection,cmpNpdidCompany,prlTransferDateValidFrom FROM licence_transfer_hst WHERE prlTransferKind='MERGER/TAKEOVER'

mappingId Mapping:01023:Table:Subs:npdv:ProductionLicenceTransfer
target    npd:licence/{prlNpdidLicence}/transfer/{prlTransferDirection}/{cmpNpdidCompany}/history/{prlTransferDateValidFrom} a npdv:SDFITransfer . 
source    SELECT prlNpdidLicence,prlTransferDirection,cmpNpdidCompany,prlTransferDateValidFrom FROM licence_transfer_hst WHERE prlTransferKind='SDFI'

mappingId Mapping:01024:Table:Subs:npdv:Pipeline
target    npd:pipeline/{pipNpdidPipe} a npdv:TransportationPipeline . 
source    SELECT pipNpdidPipe FROM pipLine WHERE pipMainGrouping='Transportation'

mappingId Mapping:01025:Table:Subs:npdv:Pipeline
target    npd:pipeline/{pipNpdidPipe} a npdv:FeederPipeline . 
source    SELECT pipNpdidPipe FROM pipLine WHERE pipMainGrouping='Feeder'

mappingId Mapping:01026:Table:Subs:ptl:ProductionLicenceNotification
target    npd:petreg/licence/{prlNpdidLicence}/message/{ptlMessageDocumentNo} a ptl:NewAwardNotification . 
source    SELECT prlNpdidLicence,ptlMessageDocumentNo FROM licence_petreg_message WHERE ptlMessageKindDesc='Ny tillatelse'

mappingId Mapping:01027:Table:Subs:ptl:ProductionLicenceNotification
target    npd:petreg/licence/{prlNpdidLicence}/message/{ptlMessageDocumentNo} a ptl:ChangedAwardNotification . 
source    SELECT prlNpdidLicence,ptlMessageDocumentNo FROM licence_petreg_message WHERE ptlMessageKindDesc='Endring i tillatelse'

mappingId Mapping:01028:Table:Subs:ptl:ProductionLicenceNotification
target    npd:petreg/licence/{prlNpdidLicence}/message/{ptlMessageDocumentNo} a ptl:EasementNotification . 
source    SELECT prlNpdidLicence,ptlMessageDocumentNo FROM licence_petreg_message WHERE ptlMessageKindDesc='Heftelse'

mappingId Mapping:01029:Table:Subs:ptl:ProductionLicenceNotification
target    npd:petreg/licence/{prlNpdidLicence}/message/{ptlMessageDocumentNo} a ptl:DeletedEasementNotification . 
source    SELECT prlNpdidLicence,ptlMessageDocumentNo FROM licence_petreg_message WHERE ptlMessageKindDesc='Sletting av heftelse'

mappingId Mapping:01030:Table:Subs:npdv:DevelopmentWellbore
target    npd:wellbore/{wlbNpdidWellbore} a npdv:InjectionWellbore . 
source    SELECT wlbNpdidWellbore FROM wellbore_development_all WHERE wlbPurposePlanned='INJECTION'

mappingId Mapping:01031:Table:Subs:npdv:DevelopmentWellbore
target    npd:wellbore/{wlbNpdidWellbore} a npdv:ProductionWellbore . 
source    SELECT wlbNpdidWellbore FROM wellbore_development_all WHERE wlbPurposePlanned='PRODUCTION'

mappingId Mapping:01032:Table:Subs:npdv:DevelopmentWellbore
target    npd:wellbore/{wlbNpdidWellbore} a npdv:ObservationWellbore . 
source    SELECT wlbNpdidWellbore FROM wellbore_development_all WHERE wlbPurposePlanned='OBSERVATION'

mappingId Mapping:01033:Table:Subs:npdv:DevelopmentWellbore
target    npd:wellbore/{wlbNpdidWellbore} a npdv:WildcatWellbore . 
source    SELECT wlbNpdidWellbore FROM wellbore_development_all WHERE wlbPurposePlanned='WILDCAT'

mappingId Mapping:01034:Table:Subs:npdv:ExplorationWellbore
target    npd:wellbore/{wlbNpdidWellbore} a npdv:PAWellbore . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbStatus='P&A'

mappingId Mapping:01035:Table:Subs:npdv:ExplorationWellbore
target    npd:wellbore/{wlbNpdidWellbore} a npdv:JunkedWellbore . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbStatus='JUNKED'

mappingId Mapping:01036:Table:Subs:npdv:ExplorationWellbore
target    npd:wellbore/{wlbNpdidWellbore} a npdv:SuspReenteredLaterWellbore . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbStatus='SUSP.REENTERED LATER'

mappingId Mapping:01037:Table:Subs:npdv:ExplorationWellbore
target    npd:wellbore/{wlbNpdidWellbore} a npdv:ReClassToDevWellbore . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbStatus='RE-CLASS TO DEV'

mappingId Mapping:01038:Table:Subs:npdv:ExplorationWellbore
target    npd:wellbore/{wlbNpdidWellbore} a npdv:BlowoutWellbore . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbStatus='BLOWOUT'

mappingId Mapping:01039:Table:Subs:npdv:ExplorationWellbore
target    npd:wellbore/{wlbNpdidWellbore} a npdv:SuspendedWellbore . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbStatus='SUSPENDED'

mappingId Mapping:01040:Table:Subs:npdv:ExplorationWellbore
target    npd:wellbore/{wlbNpdidWellbore} a npdv:ReClassToTestWellbore . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbStatus='RE-CLASS TO TEST'

mappingId Mapping:01041:Table:Subs:ptl:TUFNotification
target    npd:petreg/facility/{tufNpdidTuf}/message/{ptlMessageDocumentNo} a ptl:NewAwardNotification . 
source    SELECT tufNpdidTuf,ptlMessageDocumentNo FROM tuf_petreg_message WHERE ptlMessageKindDesc='Ny tillatelse'

mappingId Mapping:01042:Table:Subs:ptl:TUFNotification
target    npd:petreg/facility/{tufNpdidTuf}/message/{ptlMessageDocumentNo} a ptl:ChangedAwardNotification . 
source    SELECT tufNpdidTuf,ptlMessageDocumentNo FROM tuf_petreg_message WHERE ptlMessageKindDesc='Endring i tillatelse'

mappingId Mapping:01043:Table:Subs:ptl:TUFNotification
target    npd:petreg/facility/{tufNpdidTuf}/message/{ptlMessageDocumentNo} a ptl:EasementNotification . 
source    SELECT tufNpdidTuf,ptlMessageDocumentNo FROM tuf_petreg_message WHERE ptlMessageKindDesc='Heftelse'

mappingId Mapping:01044:Table:Subs:ptl:TUFNotification
target    npd:petreg/facility/{tufNpdidTuf}/message/{ptlMessageDocumentNo} a ptl:DeletedEasementNotification . 
source    SELECT tufNpdidTuf,ptlMessageDocumentNo FROM tuf_petreg_message WHERE ptlMessageKindDesc='Sletting av heftelse'

mappingId Mapping:01045:Table:Subs:npdv:ExplorationWellbore
target    npd:wellbore/{wlbNpdidWellbore} a npdv:InitialWellbore . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbDiskosWellboreType='initial'

mappingId Mapping:01046:Table:Subs:npdv:ExplorationWellbore
target    npd:wellbore/{wlbNpdidWellbore} a npdv:SidetrackWellbore . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbDiskosWellboreType='sidetrack'

mappingId Mapping:01047:Table:Subs:npdv:ExplorationWellbore
target    npd:wellbore/{wlbNpdidWellbore} a npdv:ReEntryWellbore . 
source    SELECT wlbNpdidWellbore FROM wellbore_exploration_all WHERE wlbDiskosWellboreType='re-entry'

mappingId Mapping:01048:Table:Subs:npdv:DevelopmentWellbore
target    npd:wellbore/{wlbNpdidWellbore} a npdv:InitialWellbore . 
source    SELECT wlbNpdidWellbore FROM wellbore_development_all WHERE wlbDiskosWellboreType='initial'

mappingId Mapping:01049:Table:Subs:npdv:DevelopmentWellbore
target    npd:wellbore/{wlbNpdidWellbore} a npdv:SidetrackWellbore . 
source    SELECT wlbNpdidWellbore FROM wellbore_development_all WHERE wlbDiskosWellboreType='sidetrack'

mappingId Mapping:01050:Table:Subs:npdv:DevelopmentWellbore
target    npd:wellbore/{wlbNpdidWellbore} a npdv:MultilateralWellbore . 
source    SELECT wlbNpdidWellbore FROM wellbore_development_all WHERE wlbDiskosWellboreType='multilateral'

mappingId Mapping:01051:Table:Subs:npdv:DevelopmentWellbore
target    npd:wellbore/{wlbNpdidWellbore} a npdv:MultiFieldWellbore . 
source    SELECT wlbNpdidWellbore FROM wellbore_development_all WHERE wlbDiskosWellboreType='multi-field'

mappingId Mapping:01052:Table:Subs:npdv:BAA
target    npd:baa/{baaNpdidBsnsArrArea} a npdv:UnitizedBAA . 
source    SELECT baaNpdidBsnsArrArea FROM bsns_arr_area WHERE baaKind='UNITIZED'

mappingId Mapping:01053:Table:Subs:npdv:BAA
target    npd:baa/{baaNpdidBsnsArrArea} a npdv:SlidingScaleBAA . 
source    SELECT baaNpdidBsnsArrArea FROM bsns_arr_area WHERE baaKind='SLIDING SCALE'

mappingId Mapping:01054:Table:Subs:npdv:BAA
target    npd:baa/{baaNpdidBsnsArrArea} a npdv:ParcellBAA . 
source    SELECT baaNpdidBsnsArrArea FROM bsns_arr_area WHERE baaKind='PARCELL'

mappingId Mapping:01055:Table:Subs:npdv:BAA
target    npd:baa/{baaNpdidBsnsArrArea} a npdv:SeismicAreaBAA . 
source    SELECT baaNpdidBsnsArrArea FROM bsns_arr_area WHERE baaKind='SEISMIC AREA'

mappingId Mapping:NPD:Manual1
target    npd:wellbore/{wellbore_exploration_all.wlbNpdidWellbore} npdv:wellboreFormationTD npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_exploration_all.wlbFormationAtTd=wellbore_formation_top.lsuName

mappingId Mapping:NPD:Manual2
target    npd:wellbore/{wellbore_exploration_all.wlbNpdidWellbore} npdv:wellboreFormationHcLevel1 npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_exploration_all.wlbFormationWithHc1=wellbore_formation_top.lsuName

mappingId Mapping:NPD:Manual3
target    npd:wellbore/{wellbore_exploration_all.wlbNpdidWellbore} npdv:wellboreFormationHcLevel2 npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_exploration_all.wlbFormationWithHc2=wellbore_formation_top.lsuName

mappingId Mapping:NPD:Manual4
target    npd:wellbore/{wellbore_exploration_all.wlbNpdidWellbore} npdv:wellboreFormationHcLevel3 npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_exploration_all.wlbFormationWithHc3=wellbore_formation_top.lsuName

mappingId Mapping:NPD:Manual5:1
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Campanian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeAtTd='CAMPANIAN'

mappingId Mapping:NPD:Manual5:2
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Campanian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc1='CAMPANIAN'

mappingId Mapping:NPD:Manual5:3
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Campanian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc2='CAMPANIAN'

mappingId Mapping:NPD:Manual5:4
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Campanian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc3='CAMPANIAN'

mappingId Mapping:NPD:Manual5:5
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Carboniferous . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeAtTd='CARBONIFEROUS'

mappingId Mapping:NPD:Manual5:6
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Carboniferous . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc1='CARBONIFEROUS'

mappingId Mapping:NPD:Manual5:7
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Carboniferous . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc2='CARBONIFEROUS'

mappingId Mapping:NPD:Manual5:8
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Carboniferous . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc3='CARBONIFEROUS'

mappingId Mapping:NPD:Manual5:9
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Cretaceous . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeAtTd='CRETACEOUS'

mappingId Mapping:NPD:Manual5:10
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Cretaceous . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc1='CRETACEOUS'

mappingId Mapping:NPD:Manual5:11
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Cretaceous . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc2='CRETACEOUS'

mappingId Mapping:NPD:Manual5:12
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Cretaceous . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc3='CRETACEOUS'

mappingId Mapping:NPD:Manual5:13
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Danian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeAtTd='DANIAN'

mappingId Mapping:NPD:Manual5:14
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Danian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc1='DANIAN'

mappingId Mapping:NPD:Manual5:15
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Danian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc2='DANIAN'

mappingId Mapping:NPD:Manual5:16
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Danian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc3='DANIAN'

mappingId Mapping:NPD:Manual5:17
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Devonian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeAtTd='DEVONIAN'

mappingId Mapping:NPD:Manual5:18
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Devonian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc1='DEVONIAN'

mappingId Mapping:NPD:Manual5:19
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Devonian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc2='DEVONIAN'

mappingId Mapping:NPD:Manual5:20
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Devonian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc3='DEVONIAN'

mappingId Mapping:NPD:Manual5:21
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Mississippian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeAtTd='EARLY CARBONIFEROUS'

mappingId Mapping:NPD:Manual5:22
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Mississippian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc1='EARLY CARBONIFEROUS'

mappingId Mapping:NPD:Manual5:23
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Mississippian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc2='EARLY CARBONIFEROUS'

mappingId Mapping:NPD:Manual5:24
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Mississippian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc3='EARLY CARBONIFEROUS'

mappingId Mapping:NPD:Manual5:25
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:LowerCretaceous . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeAtTd='EARLY CRETACEOUS'

mappingId Mapping:NPD:Manual5:26
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:LowerCretaceous . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc1='EARLY CRETACEOUS'

mappingId Mapping:NPD:Manual5:27
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:LowerCretaceous . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc2='EARLY CRETACEOUS'

mappingId Mapping:NPD:Manual5:28
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:LowerCretaceous . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc3='EARLY CRETACEOUS'

mappingId Mapping:NPD:Manual5:29
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:LowerJurassic . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeAtTd='EARLY JURASSIC'

mappingId Mapping:NPD:Manual5:30
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:LowerJurassic . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc1='EARLY JURASSIC'

mappingId Mapping:NPD:Manual5:31
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:LowerJurassic . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc2='EARLY JURASSIC'

mappingId Mapping:NPD:Manual5:32
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:LowerJurassic . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc3='EARLY JURASSIC'

mappingId Mapping:NPD:Manual5:33
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Cisuralian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeAtTd='EARLY PERMIAN'

mappingId Mapping:NPD:Manual5:34
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Cisuralian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc1='EARLY PERMIAN'

mappingId Mapping:NPD:Manual5:35
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Cisuralian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc2='EARLY PERMIAN'

mappingId Mapping:NPD:Manual5:36
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Cisuralian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc3='EARLY PERMIAN'

mappingId Mapping:NPD:Manual5:37
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:LowerTriassic . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeAtTd='EARLY TRIASSIC'

mappingId Mapping:NPD:Manual5:38
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:LowerTriassic . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc1='EARLY TRIASSIC'

mappingId Mapping:NPD:Manual5:39
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:LowerTriassic . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc2='EARLY TRIASSIC'

mappingId Mapping:NPD:Manual5:40
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:LowerTriassic . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc3='EARLY TRIASSIC'

mappingId Mapping:NPD:Manual5:41
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Eocene . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeAtTd='EOCENE'

mappingId Mapping:NPD:Manual5:42
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Eocene . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc1='EOCENE'

mappingId Mapping:NPD:Manual5:43
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Eocene . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc2='EOCENE'

mappingId Mapping:NPD:Manual5:44
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Eocene . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc3='EOCENE'

mappingId Mapping:NPD:Manual5:45
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Jurassic . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeAtTd='JURASSIC'

mappingId Mapping:NPD:Manual5:46
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Jurassic . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc1='JURASSIC'

mappingId Mapping:NPD:Manual5:47
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Jurassic . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc2='JURASSIC'

mappingId Mapping:NPD:Manual5:48
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Jurassic . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc3='JURASSIC'

mappingId Mapping:NPD:Manual5:49
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Pennsylvanian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeAtTd='LATE CARBONIFEROUS'

mappingId Mapping:NPD:Manual5:50
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Pennsylvanian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc1='LATE CARBONIFEROUS'

mappingId Mapping:NPD:Manual5:51
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Pennsylvanian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc2='LATE CARBONIFEROUS'

mappingId Mapping:NPD:Manual5:52
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Pennsylvanian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc3='LATE CARBONIFEROUS'

mappingId Mapping:NPD:Manual5:53
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:UpperCretaceous . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeAtTd='LATE CRETACEOUS'

mappingId Mapping:NPD:Manual5:54
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:UpperCretaceous . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc1='LATE CRETACEOUS'

mappingId Mapping:NPD:Manual5:55
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:UpperCretaceous . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc2='LATE CRETACEOUS'

mappingId Mapping:NPD:Manual5:56
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:UpperCretaceous . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc3='LATE CRETACEOUS'

mappingId Mapping:NPD:Manual5:57
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:UpperJurassic . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeAtTd='LATE JURASSIC'

mappingId Mapping:NPD:Manual5:58
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:UpperJurassic . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc1='LATE JURASSIC'

mappingId Mapping:NPD:Manual5:59
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:UpperJurassic . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc2='LATE JURASSIC'

mappingId Mapping:NPD:Manual5:60
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:UpperJurassic . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc3='LATE JURASSIC'

mappingId Mapping:NPD:Manual5:61
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Thanetian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeAtTd='LATE PALEOCENE'

mappingId Mapping:NPD:Manual5:62
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Thanetian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc1='LATE PALEOCENE'

mappingId Mapping:NPD:Manual5:63
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Thanetian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc2='LATE PALEOCENE'

mappingId Mapping:NPD:Manual5:64
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Thanetian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc3='LATE PALEOCENE'

mappingId Mapping:NPD:Manual5:65
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Lopingian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeAtTd='LATE PERMIAN'

mappingId Mapping:NPD:Manual5:66
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Lopingian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc1='LATE PERMIAN'

mappingId Mapping:NPD:Manual5:67
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Lopingian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc2='LATE PERMIAN'

mappingId Mapping:NPD:Manual5:68
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Lopingian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc3='LATE PERMIAN'

mappingId Mapping:NPD:Manual5:69
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Piacenzian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeAtTd='LATE PLIOCENE'

mappingId Mapping:NPD:Manual5:70
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Piacenzian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc1='LATE PLIOCENE'

mappingId Mapping:NPD:Manual5:71
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Piacenzian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc2='LATE PLIOCENE'

mappingId Mapping:NPD:Manual5:72
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Piacenzian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc3='LATE PLIOCENE'

mappingId Mapping:NPD:Manual5:73
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:UpperTriassic . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeAtTd='LATE TRIASSIC'

mappingId Mapping:NPD:Manual5:74
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:UpperTriassic . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc1='LATE TRIASSIC'

mappingId Mapping:NPD:Manual5:75
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:UpperTriassic . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc2='LATE TRIASSIC'

mappingId Mapping:NPD:Manual5:76
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:UpperTriassic . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc3='LATE TRIASSIC'

mappingId Mapping:NPD:Manual5:77
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:MiddleJurassic . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeAtTd='MIDDLE JURASSIC'

mappingId Mapping:NPD:Manual5:78
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:MiddleJurassic . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc1='MIDDLE JURASSIC'

mappingId Mapping:NPD:Manual5:79
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:MiddleJurassic . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc2='MIDDLE JURASSIC'

mappingId Mapping:NPD:Manual5:80
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:MiddleJurassic . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc3='MIDDLE JURASSIC'

mappingId Mapping:NPD:Manual5:81
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:MiddleTriassic . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeAtTd='MIDDLE TRIASSIC'

mappingId Mapping:NPD:Manual5:82
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:MiddleTriassic . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc1='MIDDLE TRIASSIC'

mappingId Mapping:NPD:Manual5:83
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:MiddleTriassic . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc2='MIDDLE TRIASSIC'

mappingId Mapping:NPD:Manual5:84
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:MiddleTriassic . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc3='MIDDLE TRIASSIC'

mappingId Mapping:NPD:Manual5:85
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Miocene . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeAtTd='MIOCENE'

mappingId Mapping:NPD:Manual5:86
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Miocene . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc1='MIOCENE'

mappingId Mapping:NPD:Manual5:87
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Miocene . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc2='MIOCENE'

mappingId Mapping:NPD:Manual5:88
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Miocene . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc3='MIOCENE'

mappingId Mapping:NPD:Manual5:89
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Oligocene . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeAtTd='OLIGOCENE'

mappingId Mapping:NPD:Manual5:90
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Oligocene . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc1='OLIGOCENE'

mappingId Mapping:NPD:Manual5:91
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Oligocene . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc2='OLIGOCENE'

mappingId Mapping:NPD:Manual5:92
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Oligocene . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc3='OLIGOCENE'

mappingId Mapping:NPD:Manual5:93
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Paleocene . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeAtTd='PALEOCENE'

mappingId Mapping:NPD:Manual5:94
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Paleocene . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc1='PALEOCENE'

mappingId Mapping:NPD:Manual5:95
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Paleocene . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc2='PALEOCENE'

mappingId Mapping:NPD:Manual5:96
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Paleocene . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc3='PALEOCENE'

mappingId Mapping:NPD:Manual5:97
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Permian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeAtTd='PERMIAN'

mappingId Mapping:NPD:Manual5:98
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Permian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc1='PERMIAN'

mappingId Mapping:NPD:Manual5:99
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Permian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc2='PERMIAN'

mappingId Mapping:NPD:Manual5:100
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Permian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc3='PERMIAN'

mappingId Mapping:NPD:Manual5:101
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Pleistocene . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeAtTd='PLEISTOCENE'

mappingId Mapping:NPD:Manual5:102
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Pleistocene . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc1='PLEISTOCENE'

mappingId Mapping:NPD:Manual5:103
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Pleistocene . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc2='PLEISTOCENE'

mappingId Mapping:NPD:Manual5:104
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Pleistocene . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc3='PLEISTOCENE'

mappingId Mapping:NPD:Manual5:105
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Pliocene . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeAtTd='PLIOCENE'

mappingId Mapping:NPD:Manual5:106
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Pliocene . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc1='PLIOCENE'

mappingId Mapping:NPD:Manual5:107
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Pliocene . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc2='PLIOCENE'

mappingId Mapping:NPD:Manual5:108
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Pliocene . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc3='PLIOCENE'

mappingId Mapping:NPD:Manual5:109
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Silurian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeAtTd='SILURIAN'

mappingId Mapping:NPD:Manual5:110
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Silurian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc1='SILURIAN'

mappingId Mapping:NPD:Manual5:111
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Silurian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc2='SILURIAN'

mappingId Mapping:NPD:Manual5:112
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Silurian . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc3='SILURIAN'

mappingId Mapping:NPD:Manual5:113
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Triassic . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeAtTd='TRIASSIC'

mappingId Mapping:NPD:Manual5:114
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Triassic . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc1='TRIASSIC'

mappingId Mapping:NPD:Manual5:115
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Triassic . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc2='TRIASSIC'

mappingId Mapping:NPD:Manual5:116
target    npd:stratum/{wellbore_formation_top.lsuNpdidLithoStrat} npdv:geochronologicEra isc:Triassic . 
source    SELECT wellbore_exploration_all.wlbNpdidWellbore, wellbore_formation_top.lsuNpdidLithoStrat FROM wellbore_formation_top, wellbore_exploration_all WHERE wellbore_formation_top.lsuName=wellbore_exploration_all.wlbFormationAtTd AND wellbore_exploration_all.wlbAgeWithHc3='TRIASSIC'

mappingId Mapping:NPD:Manual8:1
target    npd:licence/{prlNpdidLicence}/block/{blcName}/polyno/{prlAreaPolyPolyNo}/history/{prlAreaPolyDateValidFrom}/{prlAreaPolyDateValidTo} npdv:isActive "true"^^rdfs:Literal . 
source    SELECT prlNpdidLicence,blcName,prlAreaPolyPolyNo,prlAreaPolyDateValidFrom,prlAreaPolyDateValidTo FROM prlAreaSplitByBlock WHERE prlCurrentArea='ACTIVE'

mappingId Mapping:NPD:Manual8:2
target    npd:licence/{prlNpdidLicence}/block/{blcName}/polyno/{prlAreaPolyPolyNo}/history/{prlAreaPolyDateValidFrom}/{prlAreaPolyDateValidTo} npdv:isActive "false"^^rdfs:Literal . 
source    SELECT prlNpdidLicence,blcName,prlAreaPolyPolyNo,prlAreaPolyDateValidFrom,prlAreaPolyDateValidTo FROM prlAreaSplitByBlock WHERE prlCurrentArea='INACTIVE'

mappingId Mapping:NPD:Manual9:1
target    npd:licence/{prlNpdidLicence}/area/{prlArea_id}/history/{prlAreaPolyDateValidFrom}/{prlAreaPolyDateValidTo} npdv:isActive "true"^^rdfs:Literal . 
source    SELECT prlArea_id,prlNpdidLicence,prlAreaPolyDateValidFrom,prlAreaPolyDateValidTo FROM prlArea  WHERE prlCurrentArea='ACTIVE'

mappingId Mapping:NPD:Manual9:2
target    npd:licence/{prlNpdidLicence}/area/{prlArea_id}/history/{prlAreaPolyDateValidFrom}/{prlAreaPolyDateValidTo} npdv:isActive "false"^^rdfs:Literal . 
source    SELECT prlArea_id,prlNpdidLicence,prlAreaPolyDateValidFrom,prlAreaPolyDateValidTo FROM prlArea  WHERE prlCurrentArea='INACTIVE'

mappingId Mapping:NPD:Manual9:3
target    npd:licence/{prlNpdidLicence} npdv:currentAreaSize {prlCurrentArea}^^xsd:decimal . 
source    SELECT prlNpdidLicence,prlCurrentArea FROM licence

mappingId Mapping:NPD:Manual10:1
target    npd:wellbore/{wlbNpdidWellbore}/core/{wlbCoreNumber} npdv:coreIntervalBottom {wlbCoreIntervalBottom}^^xsd:decimal . 
source    SELECT wellbore_core_id,wlbNpdidWellbore,wlbCoreNumber,wlbCoreIntervalBottom FROM wellbore_core WHERE wlbCoreIntervalUom='[m   ]'

mappingId Mapping:NPD:Manual10:2
target    npd:wellbore/{wlbNpdidWellbore}/core/{wlbCoreNumber} npdv:coreIntervalBottom {wlbCoreIntervalBottomFT}^^xsd:decimal . 
source    SELECT wellbore_core_id,wlbNpdidWellbore,wlbCoreNumber,wlbCoreIntervalBottom * 0.3048 AS wlbCoreIntervalBottomFT FROM wellbore_core WHERE wlbCoreIntervalUom='[ft  ]'

mappingId Mapping:NPD:Manual11:1
target    npd:wellbore/{wlbNpdidWellbore}/core/{wlbCoreNumber} npdv:coreIntervalTop {wlbCoreIntervalTop}^^xsd:decimal . 
source    SELECT wellbore_core_id,wlbNpdidWellbore,wlbCoreNumber,wlbCoreIntervalTop FROM wellbore_core WHERE wlbCoreIntervalUom='[m   ]'

mappingId Mapping:NPD:Manual11:2
target    npd:wellbore/{wlbNpdidWellbore}/core/{wlbCoreNumber} npdv:coreIntervalTop {wlbCoreIntervalTopFT}^^xsd:decimal . 
source    SELECT wellbore_core_id,wlbNpdidWellbore,wlbCoreNumber,wlbCoreIntervalTop * 0.3048 AS wlbCoreIntervalTopFT FROM wellbore_core WHERE wlbCoreIntervalUom='[ft  ]'

mappingId Mapping:NPD:Manual12
target    npd:wellbore/{wlbNpdidWellbore}/cores npdv:member npd:wellbore/{wlbNpdidWellbore}/core/{wlbCoreNumber} . 
source    SELECT wlbNpdidWellbore,wlbCoreNumber FROM wellbore_core

mappingId Mapping:NPD:Manual13
target    npd:licence/{A.prlNpdidLicence}/task/{A.prlTaskID} npdv:dependsOnTask npd:licence/{B.prlNpdidLicence}/task/{B.prlTaskRefID} . 
source    SELECT A.prlNpdidLicence, A.prlTaskID, B.prlNpdidLicence, B.prlTaskRefID FROM licence_task AS A, licence_task AS B WHERE A.prlTaskID=B.prlTaskRefID

mappingId Mapping:NPD:ManualDavide2
target    npd:wellbore/{wlbNpdidWellbore}/core/{wlbCoreNumber} npdv:coresTotalLength {wlbTotalCoreLength}^^xsd:decimal . 
source    SELECT wlbNpdidWellbore, wlbCoreNumber, wlbTotalCoreLength FROM wellbore_core

mappingId Mapping:NPD:ManualDavide3
target    npd:wellbore/{wlbNpdidWellbore}/core/{wlbCoreNumber} npdv:coreIntervalUOM {wlbCoreIntervalUom}^^xsd:string . 
source    SELECT wlbNpdidWellbore, wlbCoreNumber, wlbCoreIntervalUom FROM wellbore_core
]]

